\NeedsTeXFormat{LaTeX2e}
\ProvidesClass{seg97}[1997/03/16 v0.1 SEG abstract format]

\LoadClass[alone,11pt]{sep2e}

%\RequirePackage{times} % TimesRoman fonts

\newcommand{\seg@title}{}
\renewcommand{\title}[1]{\renewcommand{\seg@title}{#1}}

%\newcommand{\seg@author}{}
%\renewcommand{\author}[1]{\renewcommand{\seg@author}{#1}}

\renewcommand{\author}[1]{%
\twocolumn[\vspace{0.25in}\normal@size\textbf{\seg@title}\newline\small\textit{#1}\vspace{2ex}]}

\renewcommand{\Large}{\protect\scriptsize}
\let\normal@size\normalsize
\renewcommand{\normalsize}{\protect\scriptsize}
\renewcommand{\footnotesize}{\protect\tiny}

\renewcommand{\section}[2][]{\parbox[t]{\columnwidth}{\textbf{\MakeUppercase{#2}}\\*}}

\renewcommand{\subsection}[2][]{%
\begin{minipage}{\columnwidth}
\textbf{#2} 
\end{minipage}}

\renewcommand{\ABS}[1]{%
\begin{minipage}[t]{\columnwidth}
\textbf{SUMMARY}\\*
#1
\end{minipage}}

\setlength{\oddsidemargin}{0in}
\setlength{\evensidemargin}{0in}
\setlength{\textwidth}{6.5in}
\setlength{\textheight}{9.0625in}

\setlength{\parindent}{0em}
\setlength{\headheight}{0.3125in}
\setlength{\headsep}{0.125in}
\setlength{\parskip}{1.5ex plus0.1ex minus0.1ex}

\setlength{\topmargin}{-0.5in}
\setlength{\columnsep}{0.3125in}

\newcommand{\ps@seg}{%
\renewcommand{\@oddhead}{\hfill\small\textbf{\sep@rhead}\scriptsize\hfill}
\renewcommand{\@evenhead}{\@oddhead}
\renewcommand{\@oddfoot}{}
\renewcommand{\@evenfoot}{}}

\renewcommand{\sideplot}[4][htbp]{%
\begin{figure}[#1]
\centering
\includegraphics[#3]{\fig@file{#2}}
\caption[]{#4}
\expanded@label{\papername}{fig:#2}
\end{figure}}

\renewcommand{\activeplot}[5][htbp]{\plot[#1]{#2}{#3}{#5}}
\renewcommand{\activesideplot}[5][htbp]{\sideplot[#1]{#2}{#3}{#5}}

\thispagestyle{empty}
\pagestyle{seg}
\scriptsize  
