#include <sitedef.h>
#if defined (HAVE_MOTIF) || defined(HAVE_ATHENA)
/*
help object
called for command line selfdoc or
portions for menu help
*/
#include <stdio.h>

char *help = "\n\
Movie - display cubic array of data in XWindows-Motif\n\
\n\
USAGE: Movie in=datafile [ data pars ] [ display pars ]\n\
\n\
DATA ARGUMENTS:\n\
in=datafile				vgrid format\n\
					bytes or float with header\n\
in=datafile n1= n2= n3= segy=1		segy/SU format\n\
					float traces with headers\n\
in=datafile n1= n2= n3=			bytes format (SEPlib)\n\
					byte array without header\n\
in=datafile n1= n2= n3= esize=4		float format\n\
					float array without header\n\
\n\
DATA PARAMETERS:\n\
par=\"\"			name of parameter file\n\
in=\"stdin\"		name of input file\n\
n1= n2= n3= n4=1 n5=1	length of three dimensions, n1 is fastest, e.g. time\n\
o1=0, o2=0 ...		first sample value in each dimension\n\
d1=1 d2=1 ...		sample increment in each dimension\n\
z1=1 z2=1 ...		relative spacing for true size, z3=3 means wide lines\n\
label1=\"n1\" ...		label for each dimension\n\
title=in		dataset title\n\
script=\"\"		script file with label for every panel (n3 dimension)\n\
segy=0			data format is segy or not\n\
vgrid=			specify vgrid choice\n\
esize=1			data samples are =1 for bytes or =4 for floats\n\
hbytes=0,3600		header bytes to skip; 3600 for segy=1\n\
pclip=255		positive clip value; high= and clip= are synonyms\n\
nclip=1			negative clip value; low= and clip= are synonyms\n\
value=\"sample\"	name for values on colorbar\n\
\n\
DISPLAY PARAMETERS:\n\
width=600 height=600	pixel dimension (> 64) or fraction of screen (<= 1.0)\n\
pick=\"\"		pick line data file\n\
npick=25000		maximum number of picks used\n\
style=\"cube\"		view is front, side, top, plan, array, picks, cube, fence, or transparent\n\
orient=\"front\"		orient is front, side, top\n\
origin=\"minimum\"		frames set to middle or minimum\n\
transp=0		if 1, transpose down and across\n\
shape=\"fit\"		shape fits screen, true, or pixel\n\
movie=\"off\"		run movie in up, down, left, right, in, or out direction\n\
color=\"gray\"		color is gray, straw, flag, tiger, blue, or rainbow\n\
contrast=\"50\"		contrast is between 0 and 100\n\
font=			alternative XWindows font; default bold-courier-20\n\
\n\
FILE FORMATS:\n\
seplib, bytes input data set: (user supplied)\n\
	2-D of 3-D array of unsigned byte integers 0-255.\n\
	Use segy2movie to convert segy.\n\
	Use Byte to convert seplib floating point.\n\
seplib, float input data set: (user supplied)\n\
	2-D of 3-D array of float numbers\n\
segy, su input data set: (user supplied)\n\
	Two dataset headers.\n\
	n2 x n3 segy traces.\n\
	Each trace 240 bytes + n1 IEEE floating point samples.\n\
	Use suread to convert tape dataset.\n\
vgrid, (read or written by Movie).\n\
	cubic array of data.\n\
	100 byte tail describing dimensions.\n\
script file: (user supplied)\n\
	Text file.\n\
	Each line of text annotates an n3 direction frame.\n\
pick file: (generated by program or user supplied)\n\
	First line is dataset name.\n\
	Second line is dataset dimensions.\n\
	Third line are axes labels.\n\
	Followed by pick-lines:\n\
		First line is ID and frame.\n\
		Following lines are pick points:\n\
			three coordinates and data value.\n\
par file: (user supplied or generated by Save State menu)\n\
	List of parameters in name=value form. Free format.\n\
	Last of duplicates used.\n\
\n\
WINDOWS:\n\
(1) Menubar on top.\n\
(2) Message window below menubar.\n\
(3) Control panel below message window.\n\
(4) Color spectrum below control panel.\n\
    Line shows relative data sample distribution.\n\
    Bar shows last pick value or range of values.\n\
    Mouse click-drag-up specifies a value range.\n\
(5) Resizable image window.  Responds to following mouse clicks:\n\
\n\
MOUSE USAGE:\n\
LEFT: zoom; MIDDLE: navigate; RIGHT: pick.\n\
LEFT click-drag-up: zoom window.\n\
LEFT click only: initial size.\n\
LEFT click-drag-up + 'h' key: zoom horizontal only.\n\
LEFT click-drag-up + 'v' key: zoom vertical only.\n\
LEFT click-drag-up in ARRAY window: those panels.\n\
MIDDLE click: select cross frames.\n\
MIDDLE click-drag-up: select an animation range.\n\
RIGHT click: pick a point on the image.\n\
RIGHT click + 'a' key: add a point to end of pick line.\n\
RIGHT click + 'm' key: move nearest point in pick line.\n\
RIGHT click + 'd' key: delete nearest point in pick line.\n\
RIGHT click-drag-up + 's' key: select seed point and sub-volume pick bounds.\n\
COLORBAR ANY click-drag-up: replace sub-volume range with this new range.\n\
\n\
INTERACTIVE CONTROLS:\n\
END\n";


/* print text on screen */
HelpPrint (start,finish)
char *start, *finish;
	{
	char *startp=0, *finishp=0;
	extern char *help, *strstr();

	startp = strstr (help,start);
	finishp = strstr (help,finish);
	if (startp == 0 || finishp == 0) return;
	for (;startp<finishp; startp++) fputc (*startp,stderr);
	fputc ('\n',stderr);
	fflush (stderr);
	}

/* pipe text through more */
HelpMore (start,finish)
char *start, *finish;
	{
	FILE *pfile, *popen();
	char *startp=0, *finishp=0;
	extern char *help, *strstr();

	startp = strstr (help,start);
	finishp = strstr (help,finish);
	if (startp == 0 || finishp == 0) return;
	pfile = popen ("more","w");
	for (;startp<finishp; startp++) fputc (*startp,pfile);
	fputc ('\n',pfile);
	fflush (pfile);
	pclose (pfile);
	}
#endif
