#include <sitedef.h>
#if defined (HAVE_MOTIF) || defined(HAVE_ATHENA)
/*
User_interface: canvas controls
*/
#include <stdio.h>
#include "rick.h"


extern UI ui;
extern Message message;

/* canvas mouse callbacks */
char canvas_trans[] =
	"#replace\n\
	<Key>h,<Btn1Motion>:	UIZoomDrag()\n\
	<Key>h,<Btn1Down>:	UIHZoomStart()\n\
	<Key>v,<Btn1Motion>:	UIZoomDrag()\n\
	<Key>v,<Btn1Down>:	UIVZoomStart()\n\
	<Btn1Down>:	UIZoomStart()\n\
	<Btn1Motion>:	UIZoomDrag()\n\
	<Btn1Up>:	UIZoomEnd()\n\
	<Btn2Down>:	UIFrameStart()\n\
	<Btn2Motion>:	UIFrameDrag()\n\
	<Btn2Up>:	UIFrameEnd()\n\
	<Key>a,<Btn3Down>:	UIPikAdd()\n\
	<Key>b,<Btn3Down>:	UIPikBest()\n\
	<Key>m,<Btn3Down>:	UIPikMove()\n\
	<Key>m:	UIBackward()\n\
	<Key>n:	UIForward()\n\
	<Key>r:	UIRun()\n\
	<Key>f:	UIFast()\n\
	<Key>s:	UISlow()\n\
	<Key>o:	UIOverlay()\n\
	<Key>v:	UIViewChangef()\n\
	<Key>V:	UIViewChangeb()\n\
	<Key>f,<Btn3Down>:	UIFinish()\n\
	<Key>c,<Btn3Down>:	UIPikSymbol()\n\
	<Key>d,<Btn3Down>:	UIPikDelete()\n\
	<Key>q,<Btn3Down>:	UIPikQuery()\n\
	<Key>?,<Btn3Down>:	UIPikQuery()\n\
	<Key>l,<Btn3Down>:	UIDrawIndLine()\n\
	<Key>l,<Btn3Up>:	UIEraseIndLine()\n\
	<Key>s,<Btn3Motion>:	UISubvolumeDrag()\n\
	<Key>s,<Btn3Down>:	UISubvolumeStart()\n\
	<Key>s,<Btn3Up>:	UISubvolumeEnd()\n\
	<Key>g,<Btn3Motion>:	UIGrowDrag()\n\
	<Key>g,<Btn3Down>:	UIGrowStart()\n\
	<Key>g,<Btn3Up>:	UIGrowEnd()\n\
	<Key>p,<Btn3Motion>:	UIPikDrag()\n\
	<Key>p,<Btn3Down>:	UIPikStart()\n\
	<Key>p,<Btn3Up>:	UIPikEnd()\n\
	<Key>e,<Btn3Motion>:	UIEraseDrag()\n\
	<Key>e,<Btn3Down>:	UIEraseStart()\n\
	<Key>e,<Btn3Up>:	UIEraseEnd()\n\
	<Btn3Down>:	UIPick()";
char colorbar_trans[] = 
	"#replace\n\
	<BtnDown>:	UIColorbarStart()\n\
	<BtnMotion>:	UIColorbarDrag()\n\
	<BtnUp>:	UIColorbarEnd()";
XtActionsRec ui_actions[] = {
	{"UIZoomStart", (XtActionProc)UIZoomStart},
	{"UIHZoomStart", (XtActionProc)UIHZoomStart},
	{"UIVZoomStart", (XtActionProc)UIVZoomStart},
	{"UIZoomDrag", (XtActionProc)UIZoomDrag},
	{"UIZoomEnd", (XtActionProc)UIZoomEnd},
	{"UIFrameStart", (XtActionProc)UIFrameStart},
	{"UIFrameDrag", (XtActionProc)UIFrameDrag},
	{"UIFrameEnd", (XtActionProc)UIFrameEnd},
	{"UISubvolumeStart", (XtActionProc)UISubvolumeStart},
	{"UISubvolumeDrag", (XtActionProc)UISubvolumeDrag},
	{"UISubvolumeEnd", (XtActionProc)UISubvolumeEnd},
	{"UIGrowStart", (XtActionProc)UIGrowStart},
	{"UIGrowDrag", (XtActionProc)UIGrowDrag},
	{"UIGrowEnd", (XtActionProc)UIGrowEnd},
	{"UIPikStart", (XtActionProc)UIPikStart},
	{"UIPikDrag", (XtActionProc)UIPikDrag},
	{"UIPikEnd", (XtActionProc)UIPikEnd},
	{"UIEraseStart", (XtActionProc)UIEraseStart},
	{"UIEraseDrag", (XtActionProc)UIEraseDrag},
	{"UIEraseEnd", (XtActionProc)UIEraseEnd},
	{"UIPick", (XtActionProc)UIPick},
	{"UIPikAdd", (XtActionProc)UIPikAdd},
	{"UIPikBest", (XtActionProc)UIPikBest},
	{"UIFinish", (XtActionProc)UIFinish},
	{"UIPikMove", (XtActionProc)UIPikMove},
	{"UIForward", (XtActionProc)UIForward},
	{"UIBackward", (XtActionProc)UIBackward},
	{"UIRun", (XtActionProc)UIRun},
	{"UIViewChangef", (XtActionProc)UIViewChangef},
	{"UIViewChangeb", (XtActionProc)UIViewChangeb},
	{"UIFast", (XtActionProc)UIFast},
	{"UISlow", (XtActionProc)UISlow},
	{"UIOverlay", (XtActionProc)UIOverlay},
	{"UIPikSymbol", (XtActionProc)UIPikSymbol},
	{"UIPikDelete", (XtActionProc)UIPikDelete},
	{"UIPikQuery", (XtActionProc)UIPikQuery},
	{"UIDrawIndLine", (XtActionProc)UIDrawIndLine},
	{"UIEraseIndLine", (XtActionProc)UIEraseIndLine},
	{"PikUndo", (XtActionProc)PikUndo},
	{"UIColorbarStart", (XtActionProc)UIColorbarStart},
	{"UIColorbarDrag", (XtActionProc)UIColorbarDrag},
	{"UIColorbarEnd", (XtActionProc)UIColorbarEnd},
};
int ui_nactions = sizeof (ui_actions) / sizeof (ui_actions[0]);

/* return canvas size */
int UICanvasSize (int *wide,int *hite)
	{
	if (!ui) return(0);
	*wide = 0;
	*hite = 0;
	XtVaGetValues (ui->canvas,XmNwidth,wide,XmNheight,hite,NULL);
#ifndef LINUX
	*wide /= 65536;
	*hite /= 65536;
#endif
  return(0);
	}

/* return color bar size */
int UIColorbarSize (int *wide,int *hite)
	{
	if (!ui) return(0);
	*wide = 0;
	*hite = 0;
	XtVaGetValues (ui->colorbar,XmNwidth,wide,XmNheight,hite,NULL);
#ifndef LINUX
	*wide /= 65536;
	*hite /= 65536;
#endif
  return(0);
	}

/* callbacks:
	call one or routines of other objects with arguments
	fetch state from widget
	set state of user interface to be conistent
if a callback does not fetch or set state and is only one routine,
	the it is called directly from other objects
*/
/* draw color bar after exposure or resize callback */
int UIDrawColorbar (Widget widget)
	{
	int wide, hite;

	if (!ui) return(0);
	if (ui->first) {
		if (ui->first == 1) {
			MainFirst();
			ui->first = 2;
			}
		else if (ui->first == 2) {
			ui->first = 0;
			}
		}
	ColorbarDraw ();
  return(0);
	}

/* draw canvas after exposure or resize callback */
int UIDrawCanvas (Widget widget)
	{
	int wide, hite;

	if (!ui) return(0);
	if (ui->first) {
		if (ui->first == 1) {
			MainFirst();
			ui->first = 2;
			}
		else if (ui->first == 2) {
			ui->first = 0;
			}
		}
	ViewSize0();
	ViewDrawAll();
  return(0);
	}

/* start zoom window callback */
int UIEraseStart (Widget widget,XButtonEvent *event)
	{
	if (!ui) return(0);
	ui->x1 = event->x;
	ui->y1 = event->y;
  return(0);
	}

/* start zoom window callback */
int UIGrowStart (Widget widget,XButtonEvent *event)
	{
	if (!ui) return(0);
	ui->x1 = event->x;
	ui->y1 = event->y;
  return(0);
	}
/* start zoom window callback */
int UIPikStart (Widget widget,XButtonEvent *event)
	{
	if (!ui) return(0);
	ui->x1 = event->x;
	ui->y1 = event->y;
  return(0);
	}

/* start zoom window callback */
int UIZoomStart (Widget widget,XButtonEvent *event)
	{
	if (!ui) return(0);
	ui->hzoom = 1;
	ui->vzoom = 1;
	ui->x1 = event->x;
	ui->y1 = event->y;
  return(0);
	}

int UIHZoomStart (Widget widget,XButtonEvent *event)
	{
	if (!ui) return(0);
	ui->hzoom = 1;
	ui->x1 = event->x;
	ui->y1 = event->y;
  return(0);
	}

int UIVZoomStart (Widget widget,XButtonEvent *event)
	{
	if (!ui) return(0);
	ui->vzoom = 1;
	ui->x1 = event->x;
	ui->y1 = event->y;
  return(0);
	}

/* colorbar pick start callback */
int UIColorbarStart (Widget widget,XButtonEvent *event)
	{
	if (!ui) return(0);
	DrawWindow (UIColorbarWindow());
	ui->x1 = event->x;
	ui->y1 = event->y;
	UIColorbarDrag (widget,event);
  return(0);
	}

/* zoom window drag callback */
int UIZoomDrag (Widget widget,XButtonEvent *event)
	{
	int width,height,xc,yc;
	if (!ui) return(0);
	if(grab_do_ano()==1){
		AnoOval (ui->x1,ui->y1,ui->x2,ui->y2,ERASE);
		AnoOval (ui->x1,ui->y1,ui->x2=event->x,ui->y2=event->y,DRAW);
	}
	else{
		DrawBox (ui->x1,ui->y1,ui->x2,ui->y2,ERASE_ALL);
		DrawBox (ui->x1,ui->y1,ui->x2=event->x,ui->y2=event->y,DRAW);
	}
  return(0);
	}

/* colorbar pick drag callback */
int UIColorbarDrag (Widget widget,XButtonEvent *event)
	{
	View myv;
  
  myv=current_view();

	if (!ui) return(0);
	ColorbarSetMark (MapMap(ViewMap(myv,AXIS_COLOR),event->x),
		MapMap(ViewMap(myv,AXIS_COLOR),event->x),TOP_MARK);
  return(0);
	}

/* smooth drag callback */
int UISubvolumeDrag (Widget widget,XButtonEvent *event)
	{
	PickPoint_ pick;

	if (!ui) return(0);
	if ((ui->x1-event->x)*(ui->x1-event->x)+(ui->y1-event->y)*(ui->y1-event->y)<25) return(0);
	DrawArrow (ui->x1,ui->y1,ui->x2,ui->y2,10,ERASE);
	DrawArrow (ui->x1,ui->y1,ui->x2=event->x,ui->y2=event->y,10,DRAW);
	PickDecode (event->x,event->y,&pick,1);
	ui->v2 = pick.index[DATA_VALUE];
	ColorbarSetMark (ui->v1,ui->v2,BOTTOM_MARK);
  return(0);
	}

/* frame drag callback */
int UIGrowDrag (Widget widget,XButtonEvent *event)
	{
	DrawBox (ui->x1,ui->y1,ui->x2,ui->y2,ERASE_ALL);
	DrawBox (ui->x1,ui->y1,ui->x2=event->x,ui->y2=event->y,DRAW);
  return(0);
}
/* frame drag callback */
int UIPikDrag (Widget widget,XButtonEvent *event)
	{
	PickPoint_ pick;
	DrawLine (ui->x1,ui->y1,ui->x2,ui->y2,ERASE_ALL);
	DrawLine (ui->x1,ui->y1,ui->x2=event->x,ui->y2=event->y,DRAW);
  return(0);
}
int UIEraseDrag (Widget widget,XButtonEvent *event)
	{
	DrawBox (ui->x1,ui->y1,ui->x2,ui->y2,ERASE_ALL);
	DrawBox (ui->x1,ui->y1,ui->x2=event->x,ui->y2=event->y,DRAW);
  return(0);
}

/* frame drag callback */
int UIFrameDrag (Widget widget,XButtonEvent *event)
	{
	PickPoint_ pick;
	if(grab_do_ano()!=1){ 
	DrawLine (ui->x1,ui->y1,ui->x2,ui->y2,ERASE_ALL);
	DrawLine (ui->x1,ui->y1,ui->x2=event->x,ui->y2=event->y,DRAW);
	PickDecode (event->x,event->y,&pick,1);
	}
	else{
	DrawBox (ui->x1,ui->y1,ui->x2,ui->y2,ERASE_ALL);
	DrawBox (ui->x1,ui->y1,ui->x2=event->x,ui->y2=event->y,DRAW);
	PickDecode (event->x,event->y,&pick,1);
	}
  return(0);
	}

int UIGrowEnd (Widget widget,XButtonEvent *event)
	{
	DrawBox (ui->x1,ui->y1,ui->x2,ui->y2,ERASE);
	RunGrowPik(ui->x1,ui->y1,ui->x2,ui->y2);
	return(0);
}

int UIPikEnd (Widget widget,XButtonEvent *event)
	{
	DrawLine (ui->x1,ui->y1,ui->x2,ui->y2,ERASE);
	RunAutoPik(ui->x1,ui->y1,ui->x2,ui->y2);
	return(0);
}

int UIEraseEnd (Widget widget,XButtonEvent *event)
	{
	DrawBox (ui->x1,ui->y1,ui->x2,ui->y2,ERASE);
	ErasePikWindow(ui->x1,ui->y1,ui->x2,ui->y2);
	return(0);
}


/* zoom window end callback */
int UIZoomEnd (Widget widget,XButtonEvent *event)
	{
	if(grab_do_ano()==1){
		AnoOval (ui->x1,ui->y1,ui->x2,ui->y2,ERASE);
		AddAnoOval(ui->x1,ui->y1,ui->x2,ui->y2);
		UIFinishPanelRaise();
	}
	else{
	DrawBox (ui->x1,ui->y1,ui->x2,ui->y2,ERASE);
	if (ui->x1 == event->x && ui->y1 == event->y) {
		UISize0 ();
		}
	else	{
		ViewWindow (ui->x1,ui->y1,ui->x2=event->x,ui->y2=event->y,ui->hzoom,ui->vzoom);
		ui->hzoom = 0;
		ui->vzoom = 0;
		ui->x1 = NO_INDEX;
		ui->y1 = NO_INDEX;
		ui->x2 = NO_INDEX;
		ui->y2 = NO_INDEX;
		UISizeReset ();
		}
	}
  return(0);
	}

/* colorbar pick end callback */
int UIColorbarEnd (Widget widget,XButtonEvent *event)
	{
	View myv;
  
  myv=current_view();
	ColorbarSetMark (MapMap(ViewMap(myv,AXIS_COLOR),event->x),
		MapMap(ViewMap(myv,AXIS_COLOR),event->x),TOP_MARK);
	DrawWatch (1);
	RegionSetValue (MapMap(ViewMap(myv,AXIS_COLOR),event->x),RegionBound(1));
	DrawWatch (0);
	ViewDrawAll ();
	ColorbarSetMark (NO_INDEX,NO_INDEX,TOP_MARK);
	ColorbarSetMark (NO_INDEX,NO_INDEX,BOTTOM_MARK);
	ui->x1 = NO_INDEX;
	ui->y1 = NO_INDEX;
	ui->x2 = NO_INDEX;
	ui->y2 = NO_INDEX;
	DrawWindow (UICanvasWindow());
  return(0);
	}

/* smooth end callback */
int UISubvolumeEnd (Widget widget,XButtonEvent *event)
	{
	PickPoint_ pick1, pick2;

	if (!ui) return(0);
	DrawArrow (ui->x1,ui->y1,ui->x2,ui->y2,10,ERASE);
	PickDecode (ui->x1,ui->y1,&pick1,1);
	PickDecode (ui->x2,ui->y2,&pick2,1);
	if (!PickSameFrame (&pick1,&pick2)) return(0);
	RegionSetBound (ui->v1,0);
	RegionSetBound (ui->v2,1);
	DrawWatch (1);
	RegionMark0 ();
	DrawWatch (0);
	ui->x1 = NO_INDEX;
	ui->y1 = NO_INDEX;
	ui->x2 = NO_INDEX;
	ui->y2 = NO_INDEX;
  return(0);
	}

/* report pick point values */
int UIPick (Widget widget,XButtonEvent *event)
	{
	PickPoint_ pick;

	PickDecode (event->x,event->y,&pick,1);
  return(0);
	}

/* movie callback */
int UIFrameStart (Widget widget,XButtonEvent *event)
	{
	if (!ui) return(0);
	ui->x1 = event->x;
	ui->y1 = event->y;
  return(0);
	}

int UIFrameEnd (Widget widget,XButtonEvent *event)
	{
	PickPoint_ pick1, pick2;
	int iaxis, iaxis1, sep[VIEW_NAXIS];
	View myv;
  
  myv=current_view();

	if (!ui) return(0);
	PickDecode (ui->x1,ui->y1,&pick1,1);
	DrawLine (ui->x1,ui->y1,ui->x2,ui->y2,ERASE);
	ui->x2 = event->x;
	ui->y2 = event->y;
	PickDecode (ui->x2,ui->y2,&pick2,1);
	for (iaxis=AXIS_DOWN; iaxis<=AXIS_DEEP; iaxis++) {
		iaxis1 = AxisDir(MapAxis(ViewMap(myv,iaxis)));
		sep[iaxis1] = pick1.index[iaxis1] - MapFrame(ViewMap(myv,iaxis));
		sep[iaxis1] *= sep[iaxis1];
		}
	if ((ui->x1-ui->x2)*(ui->x1-ui->x2)+(ui->y1-ui->y2)*(ui->y1-ui->y2) < 30) {
		if(grab_do_ano()!=1) ViewSetFrames (event->x,event->y);
			else{
				AddAnoTextPt(ui->x2,ui->y2);
	      UIAnoTextRaise();
			}
		}
	else{
		if(grab_do_ano()==1){ /*Draw a rectangle */
				AddAnoRect(ui->x1,ui->y1,ui->x2,ui->y2);
				UIFinishPanelRaise();
			} 
			else{
		 switch (pick1.iaxis[AXIS_DEEP]) {
	case AXIS_DEEP:
		if ((ui->x1-ui->x2)*(ui->x1-ui->x2)>(ui->y1-ui->y2)*(ui->y1-ui->y2)) {
			MapSetFrameBounds (ViewMap(myv,AXIS_ACROSS),pick1.index[AXIS_ACROSS],pick2.index[AXIS_ACROSS]);
			ViewSetMovie (AXIS_ACROSS);
			MovieOn ();
			}
		else	{
			MapSetFrameBounds (ViewMap(myv,AXIS_DOWN),pick1.index[AXIS_DOWN],pick2.index[AXIS_DOWN]);
			ViewSetMovie (AXIS_DOWN);
			MovieOn ();
			}
		break;
	case AXIS_ACROSS:
		if ((ui->x1-ui->x2)*(ui->x1-ui->x2)>(ui->y1-ui->y2)*(ui->y1-ui->y2)) {
			MapSetFrameBounds (ViewMap(myv,AXIS_DEEP),pick1.index[AXIS_DEEP],pick2.index[AXIS_DEEP]);
			ViewSetMovie (AXIS_DEEP);
			MovieOn ();
			}
		else	{
			MapSetFrameBounds (ViewMap(myv,AXIS_DOWN),pick1.index[AXIS_DOWN],pick2.index[AXIS_DOWN]);
			ViewSetMovie (AXIS_DOWN);
			MovieOn ();
			}
		break;
	case AXIS_DOWN:
		if ((ui->x1-ui->x2)*(ui->x1-ui->x2)>(ui->y1-ui->y2)*(ui->y1-ui->y2)) {
			MapSetFrameBounds (ViewMap(myv,AXIS_ACROSS),pick1.index[AXIS_ACROSS],pick2.index[AXIS_ACROSS]);
			ViewSetMovie (AXIS_ACROSS);
			MovieOn ();
			}
		else	{
			MapSetFrameBounds (ViewMap(myv,AXIS_DEEP),pick1.index[AXIS_DEEP],pick2.index[AXIS_DEEP]);
			ViewSetMovie (AXIS_DEEP);
			MovieOn ();
			}
		break;
		}
	}

	ui->x1 = NO_INDEX;
	ui->y1 = NO_INDEX;
	ui->x2 = NO_INDEX;
	ui->y2 = NO_INDEX;
	}
  return(0);
	}

/* add point point callback */
int UIPikBest (Widget widget,XButtonEvent *event)
	{
	PikBest ();
  return(0);
	}

/* add point point callback */
int UIPikAdd (Widget widget,XButtonEvent *event)
	{
	if(grab_do_ano()!=1){ 
		PikAdd (event->x,event->y);
	}
	else{
		 AnoAdd(event->x,event->y);
	}
  return(0);
	}


/*  */

int UIFinish (Widget widget,XButtonEvent *event)
	{
	if(grab_do_ano()==1 && grab_last_op()!=ANO_FINISHED)
	  UIFinishPanelRaise();
	else PikGrow3D();
  return(0);
	}



/* insert a pick into the pick line */
int UIPickInsert (Widget widget,XButtonEvent *event)
	{
	PickInsert (event->x,event->y);
  return(0);
	}

/* start region picking */
int UISubvolumeStart (Widget widget,XButtonEvent *event)
	{
	PickPoint_ pick;

	if (!ui) return(0);
	ui->x1 = event->x;
	ui->y1 = event->y;
	PickDecode (event->x,event->y,&pick,1);
	RegionSetSeed (pick.index);
	ui->v1 = pick.index[DATA_VALUE];
  return(0);
	}
int UIEraseIndLine(Widget widget,XButtonEvent *event)
{
int iold,i;
View myv;
Plane plane;
extern Plane planelist;
PickPoint_ pick;
Pik pik1,pik2;
int x1,x2,y1,y2;

	myv=current_view();
	PickDecode (ui->x1,ui->y1,&pick,1);
	 for(i=1;i<DATA_NAXIS; i++) pik2.loc[i]=pik1.loc[i]=pick.index[i];
  pik1.loc[0]=pik2.loc[0]=3;
  pik1.loc[myv->data->pik->depend]=0;

   for (plane=planelist; plane < planelist+NPLANE &&
    plane->attr->orient != NO_INDEX; plane++) {
    if(AxisDir(MapAxis(PlaneHmap(plane))) == myv->data->pik->depend ||
      AxisDir(MapAxis(PlaneVmap(plane))) == myv->data->pik->depend ){
      if( AxisDir(MapAxis(PlaneVmap(plane)))==myv->data->pik->depend)
           pik2.loc[myv->data->pik->depend]=AxisSize(MapAxis(plane->vmap))-1;
      if( AxisDir(MapAxis(PlaneHmap(plane)))==myv->data->pik->depend)
           pik2.loc[myv->data->pik->depend]=AxisSize(MapAxis(plane->hmap))-1;
        if(1==x_y_from_pik_plane(pik1,plane,&x1,&y1) && 
        x_y_from_pik_plane(pik2,plane,&x2,&y2))
					DrawLine(x1,y1,x2,y2,ERASE);

    }
  }
return(0);
}

int UIDrawIndLine(Widget widget,XButtonEvent *event)
{
int iold,i;
View myv;
Plane plane;
extern Plane planelist;
PickPoint_ pick;
Pik pik1,pik2;
int x1,x2,y1,y2,i1,i2;

	myv=current_view();
	ui->x1 = event->x;
	ui->y1 = event->y;
	PickDecode (event->x,event->y,&pick,1);
	for(i=1;i<DATA_NAXIS; i++) pik2.loc[i]=pik1.loc[i]=pick.index[i];
	pik1.loc[0]=pik2.loc[0]=3;
	pik1.loc[myv->data->pik->depend]=0;

	 for (plane=planelist; plane < planelist+NPLANE &&
    plane->attr->orient != NO_INDEX; plane++) {
		if(AxisDir(MapAxis(PlaneHmap(plane))) == myv->data->pik->depend ||
      AxisDir(MapAxis(PlaneVmap(plane))) == myv->data->pik->depend ){
			if( AxisDir(MapAxis(PlaneVmap(plane)))==myv->data->pik->depend)
           pik2.loc[myv->data->pik->depend]=AxisSize(MapAxis(plane->vmap))-1;
			if( AxisDir(MapAxis(PlaneHmap(plane)))==myv->data->pik->depend)
           pik2.loc[myv->data->pik->depend]=AxisSize(MapAxis(plane->hmap))-1;
				if(1==x_y_from_pik_plane(pik1,plane,&x1,&y1) &&
				x_y_from_pik_plane(pik2,plane,&x2,&y2))
					DrawLine(x1,y1,x2,y2,DRAW);

		}
	}
return(0);
}



int UIPikMove (Widget widget,XButtonEvent *event)
  {
  PikMove (event->x,event->y);
  return(0);
  }

int UIForward (Widget widget,XButtonEvent *event)
  {
  moveit(1);
  MovieOff ();
  return(0);
  }
int UIFast (Widget widget,XButtonEvent *event)
  {
  MovieDeltaSpeed(5);
  return(0);
  }
int UIViewChangeb (Widget widget,XButtonEvent *event)
  {
  ViewChange(-1);
  return(0);
  }
int UIViewChangef (Widget widget,XButtonEvent *event)
  {
  ViewChange(1);
  return(0);
  }
int UISlow (Widget widget,XButtonEvent *event)
  {
  MovieDeltaSpeed(-5);
  return(0);
  }
int UIOverlay (Widget widget,XButtonEvent *event)
  {
  DrawOverlayToggle();
  return(0);
  }
int UIRun (Widget widget,XButtonEvent *event)
  {
  MovieOn ();
  return(0);
  }

int UIBackward (Widget widget,XButtonEvent *event)
  {
  moveit(-1);
  MovieOff ();
  return(0);
  }


/* delete pick point callback */
int UIPikDelete (Widget widget,XButtonEvent *event)
	{
	PikDelete (event->x,event->y);
  return(0);
	}

/* delete pick point callback */
int UIPikSymbol (Widget widget,XButtonEvent *event)
	{
	PikSymbol();
  return(0);
	}

/* query pik point callback */
int UIPikQuery (Widget widget,XButtonEvent *event)
	{
	int i;
	if(grab_do_ano()==1){
		AnoModify(event->x,event->y);
	}
	else{
		PikQuery (event->x,event->y);
	}
  return(0);
}

#endif
