#define SET_SDOC 1
#include<sitedef.h>
#include<math.h>
#include<superset.h>
#include<superset_internal.h>


_XFUNCPROTOBEGIN
int SEPDFF_from_dff(char *dff,  sep_dff *info_dff)
_XFUNCPROTOEND
{
  int axis,nsect,naxis_convert,i;
  char pattern[128],mach[256],tag[256],temp_ch[256];
  sep_3d *info;
   
  if(info_dff->impi!=0) return(SUCCESS);

/*  if(SEPNULL!=auxinout(dff))*/
/*  	return(sepwarn(NOT_MET,"trouble opening up the dff file  (%s)=tag(%s)\n",dff,tag));*/

  if(1!=auxpar("nsect","d",&nsect,dff))
  	return(sepwarn(NOT_MET,"trouble reading the number of sections from the dff file \n"));
	
  if(1!=auxpar("axis","d",&axis,dff))
  	return(sepwarn(NOT_MET,"trouble reading the axis we split along for tag=%s \n",dff));

  if(1!=auxpar("naxis_convert","d",&naxis_convert,dff))
  	return(sepwarn(NOT_MET,"trouble reading the naxis_convert for tag=%s \n",dff));

  if(1!=auxpar("pattern","s",pattern,dff))
   	return(sepwarn(NOT_MET,"trouble reading distribution type for tag=%s \n",dff));
 
  if(0==strcmp(pattern,"BLOCK")) info_dff->pattern=BLOCK;
  else if(0==strcmp(pattern,"SPREAD")) info_dff->pattern=SPREAD;
  else return(sepwarn(NOT_MET,"invalid pattern=%s for dff=%s \n",pattern,dff));

  if(0!=SEPDFF_set_nsect(info_dff,nsect))
    return (sepwarn(NOT_MET,"tag:%s trouble setting nsect \n", dff));
	
  if(0!=SEPDFF_set_sect_axis(info_dff,axis,naxis_convert))
	  return(sepwarn(NOT_MET,"trouble setting sect_axis for tag=%s  \n",dff));

  if(0!=SEPDFF_pattern_to_axis_convert(info_dff))
	  return(sepwarn(NOT_MET,"trouble setting axis_convert based on pattern for tag=%s  \n",dff));
  

/*
  if(info_dff->nmpi >  nsect)
    return(sepwarn(NOT_MET,"number of sections less than number of threads dff=%s \n",
    dff));
*/

  for(i=0; i < info_dff->nsect; i++){
	  sprintf(temp_ch,"tag_sect%d",i);
    auxpar(temp_ch,"s",tag,dff);
	  sprintf(temp_ch,"mach_sect%d",i);
    auxpar(temp_ch,"s",mach,dff);
    if(0!=SEPDFF_set_mach_sect(info_dff,i,mach) || 0!=SEPDFF_set_tag_sect(info_dff,i,tag))
      return(sepwarn(NOT_MET,"trouble setting machine and tag for %s \n",dff));
  }
  return(SUCCESS);
}

_XFUNCPROTOBEGIN
int SEPDFF_to_dff(sep_dff *info_dff, char *dff)
_XFUNCPROTOEND
{
 char pattern[256],temp_ch[1024];
 int i;

if(info_dff->impi!=0) return(SUCCESS);

if(info_dff->pattern==BLOCK) strcpy(pattern,"BLOCK");
  else if(info_dff->pattern==SPREAD) strcpy(pattern,"SPREAD");
  else return(sepwarn(NOT_MET,"pattern not set for dff=%s \n",dff));

  if(info_dff->naxis_convert==0)
    return(sepwarn(NOT_MET,"axis convert hasn't been set won't write tag=%s \n",dff));

  if(info_dff->nsect==0)
    return(sepwarn(NOT_MET,"1:nsect hasn't been set won't write tag=%s \n",dff));

/*  if(SEPNULL!=auxinout(dff))*/
/*  	return(sepwarn(NOT_MET,"trouble opening up the dff file  (%s)\n",dff));*/

  if(0!=auxputch("nsect","d",&info_dff->nsect,dff))
  	return(sepwarn(NOT_MET,"trouble writing the number of sections from the dff file \n"));
	
  if(0!=auxputch("axis","d",&info_dff->sect_axis,dff))
  	return(sepwarn(NOT_MET,"trouble writing the axis we split along for tag=%s \n",dff));

  if(0!=auxputch("naxis_convert","d",&info_dff->naxis_convert,dff))
  	return(sepwarn(NOT_MET,"trouble writing the naxis_convert for tag=%s \n",dff));

  if(0!=auxputch("pattern","s",pattern,dff))
   	return(sepwarn(NOT_MET,"trouble writing distribution type for tag=%s \n",dff));
 

  for(i=0; i < info_dff->nsect; i++){
	  sprintf(temp_ch,"tag_sect%d",i);
    auxputch(temp_ch,"s",info_dff->tag_sect[i],dff);
	  sprintf(temp_ch,"mach_sect%d",i);
    auxputch(temp_ch,"s",info_dff->mach_sect[i],dff);
/*
   if(0!=sep3d_rite_format(info_dff->tag_sect[i],info_dff->tag_sect[i]))
     return(sepwarn(NOT_MET,"trouble writing out section=%d tag=%s \n",
      i,info_dff->tag_sect[i]));
*/
  }
  return(SUCCESS);
}



