#define SET_SDOC 1
#include<sitedef.h>
#include<superset.h>
#include<superset_internal.h>

_XFUNCPROTOBEGIN
int SEP3D_collect_headers(sep_3d *info_from, sep_dff *info_dff, sep_3d *info_to,int ithread)
_XFUNCPROTOEND
{
int nt,i,ih,ntot;
sep_3d  *info_small;
int *ncount,*index_small,*index_big,*nsmall;

if(info_from->file_format==REGULAR) return(SUCCESS);

ncount=(int*) malloc(sizeof(int)*info_dff->nmpi);
ncount[info_dff->impi]=info_from->ncoord;

if(info_dff->sect_axis!=1){
  for(i=0,ntot=0; i < info_dff->nmpi;i++){
    if(0!= sep3d_broadcast_ints(&ncount[i],1, i))
      return(sepwarn(NOT_MET,"trouble broadcasting number of headers \n"));
    ntot+=ncount[i];
  }
}
else{
  for(i=0; i < info_dff->nmpi;i++) ncount[i]=info_from->ncoord;
  ntot=info_from->ncoord;
}

if(info_dff->impi==ithread){
  if(0!=SEP3D_alloc_coord(info_to,ntot)){
     free(ncount);
     return(sepwarn(NOT_MET,
     "trouble setting nh tag=%s \n",info_to->name));
  }

  if(0!=sep3d_set_nh(info_to->name,ntot)){
    free(ncount);
    return(sepwarn(NOT_MET,
     "trouble setting nh tag=%s \n",info_to->name));
  }
  index_big=(int*) malloc(sizeof(int)*ntot);
}
else index_big=SEPNULL;
index_small=(int*)malloc(sizeof(int)*info_from->ncoord);

if(0!=SEP3D_create_index_maps(info_to,info_dff,info_from,ncount,index_big,index_small)){
  free(index_big); free(index_small); free(ncount);
  return(sepwarn(NOT_MET,"trouble creating big map %s \n",info_from->name));
}
free(ncount);
nsmall=(int*)malloc(sizeof(int)*info_dff->nsect);
for(i=0; i< info_dff->nsect;i++) nsmall[i]=0;
for(i=0; i < info_from->ncoord; i++) nsmall[index_small[i]]++;



for(i=0,ntot=0; i< info_dff->nsect;i++){
  if(info_dff->impi==ithread ||  info_dff->impi==info_dff->sect_thread[i]){
    info_small= tag_info_section(info_dff,i, INQUIRE);

    if(0!=sep3d_set_nh(info_small->name,nsmall[i]) ||
         0!=SEP3D_alloc_coord(info_small,nsmall[i])){
         free(index_big); free(index_small);free(nsmall);
         return(sepwarn(NOT_MET,
           "trouble allocating local sizes sect=%d size=%d thread=%d  \n",
            i,nsmall[i],sep_thread_num()));
      }



    if(info_dff->impi==info_dff->sect_thread[i]){
      if(0!=SEP3D_grab_header_section(info_from,info_dff,info_small,i,
          info_from->ncoord,index_small)){ 
         free(index_small); free(index_big); free(nsmall);
         return(sepwarn(NOT_MET,"tag=%s trouble grabbing header section \n",
          info_from->name));     
      }
    }
    if(0!=sep3d_pass_headers(info_dff->impi,info_small->name,
       info_dff->sect_thread[i],ithread)) {
           free(index_small);free(index_big); free(nsmall);
          return(sepwarn(NOT_MET,
         "tag=%s trouble passing section %d to %d from %d \n",
           info_from->name,i,ithread,info_dff->sect_thread[i]));
    }
    if(info_dff->impi==ithread){
       if(info_small->ncoord>0) info_small->drn[0]=-1;

       if(0!=SEP3D_add_header_section(info_small,info_dff,info_to,
         i,info_to->ncoord,index_big)){
           free(index_small);free(index_big); free(nsmall);
           return(sepwarn(NOT_MET,
          "trouble adding section %d to tag=%s \n",i,info_to->name));
        }
       ntot+=info_small->ncoord;
    }
  /* SEP3D_clean(info_small);*/
  }
}
free(index_small); free(index_big);
  return(SUCCESS);
}



_XFUNCPROTOBEGIN
int SEP3D_distribute_headers(sep_3d *info_from, sep_dff *info_dff, sep_3d *info_to,int ithread)
_XFUNCPROTOEND
{
int nt,ncount,i,ih,nsmall;
sep_3d  *info_small;
int *index_small,*index_big,*nlocal;
char temp2_ch[2049];

nt=info_from->ncoord;

if(0!= sep3d_broadcast_ints(&nt,1, ithread))
  return(sepwarn(NOT_MET,"trouble broadcasting number of coordinates \n"));

if(info_to->file_format==REGULAR) return(SUCCESS);

if(nt==0) return(SUCCESS);
index_big=(int*)malloc(sizeof(int)*nt);
if(info_dff->impi==ithread){
  if(0!=SEP3D_find_sect_index(info_from,info_from,info_dff,index_big)){
      free(index_big);
       return(sepwarn(NOT_MET,
         "trouble finding sect index tag=%s \n",info_from->name));
  }
}
if(0!= sep3d_broadcast_ints(index_big,nt, ithread))
  return(sepwarn(NOT_MET,"trouble broadcasting sect numbers \n"));

for(i=0,nsmall=0; i<nt; i++) if(info_dff->sect_thread[index_big[i]]==info_dff->impi) nsmall++;
index_small=(int*)malloc(sizeof(int)*nsmall);
nlocal=(int*)malloc(sizeof(int)*info_dff->nsect);
for(i=0; i < info_dff->nsect; i++) nlocal[i]=0;
for(i=0,nsmall=0; i<nt; i++) {
  if(info_dff->sect_thread[index_big[i]]==info_dff->impi){
     index_small[nsmall]=index_big[i];
     nsmall++;
  }
  nlocal[index_big[i]]++;
} 


if(0!=SEP3D_alloc_coord(info_to,nsmall)) return(sepwarn(NOT_MET,
   "trouble setting nh tag=%s \n",info_to->name));

if(0!=sep3d_set_nh(info_to->name,nsmall)) return(sepwarn(NOT_MET,
   "trouble setting nh tag=%s \n",info_to->name));

for(i=0,ncount=0; i< info_dff->nsect;i++){
  if(info_dff->impi==ithread ||  info_dff->impi==info_dff->sect_thread[i]){
    SEPDFF_sect_name(info_dff,i,temp2_ch);
    if(0!=sep3d_struct_init(temp2_ch,"tEMP","SCRATCH")){
      free(index_big); free(index_small);free(nlocal);
      return(sepwarn(NOT_MET,"trouble making temporary structure tag=%s \n",
        info_to->name));
    }
    info_small= tag_info_sep3d("tEMP", INQUIRE);
    if(info_dff->impi==ithread){
       
      if(0!=sep3d_set_nh(info_small->name,nlocal[i]) ||
         0!=SEP3D_alloc_coord(info_small,nlocal[i])){
         free(index_big); free(index_small);free(nlocal);
         return(sepwarn(NOT_MET,"trouble allocating local sizes sect=%d size=%d thread=%d  \n",
            i,nlocal[i],sep_thread_num()));
      }
      if(0!=SEP3D_grab_header_section(info_from,info_dff,info_small,i,
          info_from->ncoord,index_big)){ 
         free(index_big); free(index_small);free(nlocal);
         return(sepwarn(NOT_MET,"tag=%s trouble grabbing header section \n",
          info_from->name));     
      }
    }

    if(0!=sep3d_pass_headers(info_dff->impi,info_small->name,ithread,
       info_dff->sect_thread[i])){
         free(index_big); free(index_small);free(nlocal);
           return(sepwarn(NOT_MET,
         "tag=%s trouble passing section %d from %d to %d \n",
           info_from->name,i,ithread,info_dff->sect_thread[i]));
         }
    if(info_dff->impi==info_dff->sect_thread[i]){
      if(info_small->ncoord>0) info_small->drn[0]=-1;
      if(0!=SEP3D_add_header_section(info_small,info_dff,info_to,
         i,nsmall,index_small)) {
         free(index_big); free(index_small);free(nlocal);
           return(sepwarn(NOT_MET,
          "trouble adding section %d to tag=%s \n",i,info_from->name));
      }
       ncount+=info_small->ncoord;
    }
   sep3d_delete("tEMP");
  }
}
free(index_big); free(index_small);free(nlocal);
  return(SUCCESS);
}




_XFUNCPROTOBEGIN
int SEP3D_collect_data(sep_3d *info_from, sep_dff *info_dff, sep_3d *info_to,int ithread, char *data_in, char *data_out)
_XFUNCPROTOEND
{
int *index_big,*index_small;
int i,ih,ntot,i1;
sep_3d  *info_small;
int *ncount,*sect_index;
int esize,nelem,nt,ic;
float *temp_data;


ncount=(int*) malloc(sizeof(int)*info_dff->nmpi);
ncount[info_dff->impi]=info_from->ncoord;

if(info_dff->sect_axis!=1){
  for(i=0,ntot=0; i < info_dff->nmpi;i++){
    if(0!= sep3d_broadcast_ints(&ncount[i],1, i)){
      free(ncount);
      return(sepwarn(NOT_MET,"trouble broadcasting number of headers \n"));
    }
    ntot+=ncount[i];
  }
}
else{
  for(i=0,ntot=0; i < info_dff->nmpi;i++){
    ncount[i]=info_from->ncoord;
  }
  ntot=ncount[i]=info_from->ncoord;
}

if(info_dff->impi==ithread){
  if(info_to->file_format==REGULAR){
    if(0!=SEP3D_alloc_coord(info_to,ntot)){
      free(ncount);
      return(sepwarn(NOT_MET,
     "trouble setting nh tag=%s \n",info_to->name));
     }
  } 
  index_big=(int*) malloc(sizeof(int)*ntot);
} 
else index_big=SEPNULL;
index_small=(int*)malloc(sizeof(int)*info_from->ncoord);

if(0!=SEP3D_create_index_maps(info_to,info_dff,info_from,ncount,index_big,index_small)){
  free(index_big); free(index_small);
  return(sepwarn(NOT_MET,"trouble creating big map %s \n",info_from->name));
}
free(ncount);

for(i=0; i< info_dff->nsect;i++){


  if(info_dff->impi==ithread ||  info_dff->impi==info_dff->sect_thread[i]){
    info_small= tag_info_section(info_dff,i, INQUIRE);
    if(info_small==SEPNULL) {
       free(index_small); free(index_big);
       return(sepwarn(NOT_MET,"tag=%s trouble grabbing section(%d) tag=%s \n",
        info_from->name,i,info_dff->tag_sect[i]));     
    }
    if(info_dff->impi==info_dff->sect_thread[i]){
       if(info_dff->sect_axis==1) nelem=info_from->ncoord;
       else{ 
         for(i1=0,nelem=0; i1< info_from->ncoord; i1++){
           if(index_small[i1]==i) nelem++;
         }
       }
      if(0!=SEP3D_alloc_coord(info_small,nelem))
        return(sepwarn(NOT_MET,"trouble allocating coords %s \n",info_small->name));
       nelem=nelem*info_from->n[0];
       temp_data=(float*)malloc(sizeof(char)*nelem*SEP3D_get_esize(info_to));

      if(0!=SEP3D_grab_data_section(info_from,info_dff,info_small,i,
       data_in,(char*)temp_data, info_from->ncoord,index_small)){ 
         free(index_small); free(index_big);
         return(sepwarn(NOT_MET,"tag=%s trouble grabbing header section \n",
          info_from->name));     
      }

      nt=info_small->ncoord;
      nelem=info_small->n[0];
      nelem=nelem*info_small->ncoord;
    }
    if(info_small->file_format==REGULAR && ithread!=info_dff->sect_thread[i]){
      if(0!=sep3d_send_int(info_dff->impi,&nt,
        info_dff->sect_thread[i],ithread)){
          free(index_big); free(index_small);
          return(sepwarn(NOT_MET,"trouble sending size \n"));
      }
      if(info_dff->impi==ithread){
        if(0!=SEP3D_alloc_coord(info_small,nt)) 
          return(sepwarn(NOT_MET,"trouble allocating coords %s \n",info_small->name));
      }
      if(0!=sep3d_pass_data(info_dff->impi,
        info_dff->sect_thread[i],ithread,nt,(int)sizeof(double),(char*)info_small->coord)) 
         return(sepwarn(NOT_MET,
           "tag=%s trouble passing section %d from %d to %d \n",
             info_from->name,i,ithread,info_dff->sect_thread[i]));
    }


    if(0!=sep3d_send_int(info_dff->impi,&nelem,
      info_dff->sect_thread[i],ithread)){
        free(index_small);
        return(sepwarn(NOT_MET,"trouble sending size \n"));
    }
    esize=SEP3D_get_esize(info_to);

    if(info_dff->impi==ithread && info_dff->impi != info_dff->sect_thread[i])
       temp_data=(float*)malloc(sizeof(char)*nelem*SEP3D_get_esize(info_to));

    if(0!=sep3d_pass_data(info_dff->impi,
      info_dff->sect_thread[i],ithread,nelem,esize,(char*)temp_data));


    if(info_dff->impi==ithread){
      if(0!=SEP3D_add_data_section(info_small,(char*)temp_data,info_to,info_dff,
         data_out, i, ntot,index_big)) return(sepwarn(NOT_MET,
         "trouble adding section %d to tag=%s \n",i,info_to->name));
    }
  }
  if(info_dff->impi==ithread ||  info_dff->impi==info_dff->sect_thread[i]) 
    free(temp_data);
}
free(index_small); free(index_big);
  return(SUCCESS);
}



_XFUNCPROTOBEGIN
int SEP3D_distribute_data(sep_3d *info_from, sep_dff *info_dff, sep_3d *info_to,int ithread,char *data_in , float *data_out)
_XFUNCPROTOEND
{
int nt,ncount,i,ih;
sep_3d  *info_small;
int *index_small,*index_big,i1,i2;
float *temp_data;
int nelem,esize,nsmall,ic,nc;
float mymin,mymax;
char temp2_ch[2049];

nt=info_from->ncoord;

if(0!= sep3d_broadcast_ints(&nt,1, ithread))
  return(sepwarn(NOT_MET,"trouble broadcasting number of coordinates \n"));


if(nt==0) return(SUCCESS);
index_big=(int*)malloc(sizeof(int)*nt);
if(info_dff->impi==ithread){
  if(0!=SEP3D_find_sect_index(info_from,info_from,info_dff,index_big)){
      free(index_big);
       return(sepwarn(NOT_MET,
         "trouble finding sect index tag=%s \n",info_from->name));
  }
}
if(0!= sep3d_broadcast_ints(index_big,nt, ithread))
  return(sepwarn(NOT_MET,"trouble broadcasting sect numbers \n"));

for(i=0,nsmall=0; i<nt; i++) if(info_dff->sect_thread[index_big[i]]==info_dff->impi) nsmall++;
index_small=(int*)malloc(sizeof(int)*nsmall);
for(i=0,nsmall=0; i<nt; i++) {
  if(info_dff->sect_thread[index_big[i]]==info_dff->impi){
     index_small[nsmall]=index_big[i];
     nsmall++;
  }
} 





if(info_to->file_format==REGULAR){
  if(0!=SEP3D_alloc_coord(info_to,nsmall)) return(sepwarn(NOT_MET,
     "trouble setting nh tag=%s \n",info_to->name));
}


for(i=0; i< info_dff->nsect;i++){
  if(info_dff->impi==ithread ||  info_dff->impi==info_dff->sect_thread[i]){
   SEPDFF_sect_name(info_dff,i,temp2_ch);
    if(0!=sep3d_struct_init(temp2_ch,"tEMP","SCRATCH")){
      free(index_big); free(index_small);
      return(sepwarn(NOT_MET,"trouble making temporary structure tag=%s \n",
        info_to->name));
    }
    info_small= tag_info_sep3d("tEMP", INQUIRE);
    if(info_dff->impi==ithread){
       for(i1=0,nelem=0; i1< info_from->ncoord; i1++) if(index_big[i1]==i) nelem++;

       temp_data=(float*)malloc(sizeof(char)*info_to->n[0]*nelem*SEP3D_get_esize(info_to));

      if(0!=SEP3D_alloc_coord(info_small,nelem)){
        return(sepwarn(NOT_MET,"trouble allocating coords %s \n",info_small->name));
      }


      if(0!=SEP3D_grab_data_section(info_from,info_dff,info_small,i,data_in,
        (char*)temp_data, info_from->ncoord,index_big)){ 
         free(index_big); free(index_small);
         return(sepwarn(NOT_MET,"tag=%s trouble grabbing header section \n",
          info_from->name));     
      }
      nelem=info_small->n[0]*nelem;
      nt=info_small->ncoord;
    }
    if(info_small->file_format==REGULAR && ithread!=info_dff->sect_thread[i]){
      if(0!=sep3d_send_int(info_dff->impi,&nt,ithread,
        info_dff->sect_thread[i])){
          free(index_big); free(index_small);
          return(sepwarn(NOT_MET,"trouble sending size \n"));
      }
      if(info_dff->impi==info_dff->sect_thread[i])
        if(0!=SEP3D_alloc_coord(info_small,nt)){
          return(sepwarn(NOT_MET,"trouble allocating coords %s \n",info_small->name));
      }
      if(0!=sep3d_pass_data(info_dff->impi,
        ithread,info_dff->sect_thread[i],nt,(int)sizeof(double),(char*)info_small->coord)) 
         return(sepwarn(NOT_MET,
           "tag=%s trouble passing section %d from %d to %d \n",
             info_from->name,i,ithread,info_dff->sect_thread[i]));
    }
    if(0!=sep3d_send_int(info_dff->impi,&nelem,ithread,
      info_dff->sect_thread[i])){
        free(index_big); free(index_small);
        return(sepwarn(NOT_MET,"trouble sending size \n"));
    }

    if(info_dff->impi==info_dff->sect_thread[i] && info_dff->impi!=ithread)
       temp_data=(float*)malloc(sizeof(char)*nelem*SEP3D_get_esize(info_to));

 
    if(0!=sep3d_pass_data(info_dff->impi,
      ithread,info_dff->sect_thread[i],nelem,SEP3D_get_esize(info_to),
       (char*)temp_data)) 
       return(sepwarn(NOT_MET,
         "tag=%s trouble passing section %d from %d to %d \n",
           info_from->name,i,ithread,info_dff->sect_thread[i]));

  mymax=mymin=temp_data[0];
   if(sep_thread_num()==info_dff->sect_thread[i]){
      for(i1=0; i1 < nelem; i1++){
          if(mymin < temp_data[i]) mymin=temp_data[i];
          if(mymax > temp_data[i]) mymax=temp_data[i];
        }
    }

    if(info_dff->impi==info_dff->sect_thread[i]){
      if(0!=SEP3D_add_data_section(info_small,(char*)temp_data,info_to,info_dff,
        (char*)data_out, i,nsmall,index_small)) return(sepwarn(NOT_MET,
          "trouble adding section %d to tag=%s \n",i,info_to->name));
    }
   sep3d_delete("tEMP");
     free(temp_data);
  }
}
free(index_big); free(index_small);
  return(SUCCESS);
}
_XFUNCPROTOBEGIN
int sep3d_col_headers(char *sep3din, char *sep3dout, int ithread, int *nh)
_XFUNCPROTOEND
{
sep_3d *info_from, *info_to;
sep_dff *info_dff;
int i,ierr;

info_from = tag_info_sep3d(sep3din, INQUIRE);
if(info_from==SEPNULL) 
  return(sepwarn(NOT_MET,"1invalid tag=%s \n",sep3din));
info_to = tag_info_sep3d(sep3dout, INQUIRE);
if(info_from==SEPNULL) 
  return(sepwarn(NOT_MET,"2invalid tag=%s \n",sep3dout));
info_dff=info_from->dff;
if(info_dff==SEPNULL) 
  return(sepwarn(NOT_MET,"3invalid tag=%s  not sectioned \n",sep3din));

for(i=1,*nh=1; i< info_from->ndims; i++) *nh=(*nh)*info_from->nwind[i];

ierr=SEP3D_collect_headers(info_from,info_dff,info_to,ithread);

if(info_from->file_format!=REGULAR) *nh=info_to->ncoord;

return(ierr);
}

_XFUNCPROTOBEGIN
int sep3d_dist_headers(char *sep3din, char *sep3dout, int ithread)
_XFUNCPROTOEND
{
sep_3d *info_from, *info_to;
sep_dff *info_dff;

info_from = tag_info_sep3d(sep3din, INQUIRE);
if(info_from==SEPNULL) 
  return(sepwarn(NOT_MET,"4invalid tag=%s \n",sep3din));
info_to = tag_info_sep3d(sep3dout, INQUIRE);
if(info_from==SEPNULL) 
  return(sepwarn(NOT_MET,"5invalid tag=%s \n",sep3dout));
info_dff=info_to->dff;
if(info_dff==SEPNULL) 
  return(sepwarn(NOT_MET,"6invalid tag=%s  not sectioned \n",sep3dout));

return(SEP3D_distribute_headers(info_from,info_dff,info_to,ithread));
}

_XFUNCPROTOBEGIN
int sep3d_col_data(char *sep3din, char *sep3dout, int ithread, char *data_in, char *data_out)
_XFUNCPROTOEND
{
sep_3d *info_from, *info_to;
sep_dff *info_dff;

info_from = tag_info_sep3d(sep3din, INQUIRE);
if(info_from==SEPNULL) 
  return(sepwarn(NOT_MET,"7invalid tag=%s \n",sep3din));
info_to = tag_info_sep3d(sep3dout, INQUIRE);
if(info_from==SEPNULL) 
  return(sepwarn(NOT_MET,"8invalid tag=%s \n",sep3dout));
info_dff=info_from->dff;
if(info_dff==SEPNULL) 
  return(sepwarn(NOT_MET,"9invalid tag=%s  not sectioned \n",sep3din));

return(SEP3D_collect_data(info_from,info_dff,info_to,ithread,data_in,data_out));
}
_XFUNCPROTOBEGIN
int sep3d_com_data(char *sep3din, char *sep3dout, int ithread, char *data_in, char *data_out)
_XFUNCPROTOEND
{
sep_3d *info_from, *info_to;
sep_dff *info_dff;
info_from = tag_info_sep3d(sep3din, INQUIRE);
if(info_from==SEPNULL) 
  return(sepwarn(NOT_MET,"Ainvalid tag=%s \n",sep3din));
info_to = tag_info_sep3d(sep3dout, INQUIRE);
if(info_from==SEPNULL) 
  return(sepwarn(NOT_MET,"Binvalid tag=%s \n",sep3dout));
info_dff=info_from->dff;
if(info_dff==SEPNULL) 
  return(sepwarn(NOT_MET,"Cinvalid tag=%s  not sectioned \n",sep3din));

return(SEP3D_compress_data(info_from,info_dff,info_to,ithread,
   (float*)data_in,(float*)data_out));
}

_XFUNCPROTOBEGIN
int SEP3D_compress_data(sep_3d *info_from, sep_dff *info_dff, sep_3d *info_to,int ithread, float *data_in, float *data_out)
_XFUNCPROTOEND
{
double big;
char *temp_buf;
int iax,isect;
int nrepeat,i;

iax=info_dff->sect_axis;

if(info_from->nwind[iax] != info_from->nwind[iax])
  return(sepwarn(NOT_MET,"when compressing along you can not do a windowed read along the sectioned axis\n"));

if(iax==-1) return(SUCCESS); /* no compression along the time axis*/

if(info_from->file_format==GRID)
  return(sepwarn(NOT_MET,"I can not compress a gridded dataset not sectioned along axis 1 (sizes may not be consistant\n"));

/*we need float or complex data*/
if(info_from->data_format!=FLOAT && info_from->data_format!=COMPLEX)
  return(sepwarn(NOT_MET,"Only can compress float and complex data\n"));

/*we need the repeat interval*/
nrepeat=SEP3D_get_esize(info_from)/4;
for(i=0;  i< info_from->ndims; i++){
  if(i!=iax) nrepeat=nrepeat*info_from->nwind[i];
}

/*compress the various internal sections*/
for(isect=1; isect < info_dff->nsect_ithread;isect++){
  for(i=0; i < nrepeat; i++){
    data_in[i]=data_in[i+nrepeat*isect];
  }
}
return(SEPDFF_condense_buffer(info_dff,ithread,"+",data_in,data_out,nrepeat,4));
}



_XFUNCPROTOBEGIN
int sep3d_trans_data(char *sep3din, char *sep3dout,  char *data_in, char *data_out)
_XFUNCPROTOEND
{
sep_3d *info_from, *info_to;
sep_dff *info_dff;

info_from = tag_info_sep3d(sep3din, INQUIRE);
if(info_from==SEPNULL) 
  return(sepwarn(NOT_MET,"Dinvalid tag=%s \n",sep3din));
info_to = tag_info_sep3d(sep3dout, INQUIRE);
if(info_from==SEPNULL) 
  return(sepwarn(NOT_MET,"Einvalid tag=%s \n",sep3dout));

return(SEP3D_transfer_data(info_from,info_to,data_in,data_out));
}
_XFUNCPROTOBEGIN
int SEP3D_transfer_data(sep_3d *input, sep_3d *output,  char *data_in, char *data_out)
_XFUNCPROTOEND
{
int i,nin,nout,isect,iin,iout,nsect,esize;
int *ncoord_in,*ncoord_out;
int *thread_in,*thread_out;
int block,ithread,iax;
char *temp;

for(i=0,nin=1; i < input->ndims; i++) nin=input->nwind[i]*nin;
for(i=0,nout=1; i < output->ndims; i++) nout=output->nwind[i]*nout;
if(nin!=nout) return(sepwarn(NOT_MET,"input and output window not the same size\n"));
if(input->data_format!=output->data_format)
  return(sepwarn(NOT_MET,"input and output data format not the same \n"));

esize=SEP3D_get_esize(input);
/* if a normal dataset just do a copy*/
if(input->dff==SEPNULL && output->dff==SEPNULL) {
  memcpy((void*)data_out,(const void*)data_in,nin*esize);
  return(SUCCESS);
}
if(input->file_format==GRID)
  return(sepwarn(NOT_MET,"Transfer doesn't currently work with grided data\n"));

if(input->n[0] != output->n[0] ||  input->n[0] != output->n[0])
  return(sepwarn(NOT_MET,"input and out trace size must be the same size \n"));

thread_in=(int*) malloc(sizeof(int)*nin/input->nwind[0]);

if(input->dff==SEPNULL) for(i=0; i < nin/input->nwind[0]; i++) thread_in[i]=0;
else{
  iax= input->dff->sect_axis-1;
  block=1;
  for(i=1 ; i < input->dff->sect_axis-1; i++) block=block*input->nwind[i];
  for(i=0; i < nin/input->nwind[0]; i++) 
     thread_in[i]=input->dff->sect_thread[input->dff->axis_convert[SEPH2C(i,block,input->nwind[iax])]];
      thread_in[i]=input->dff->sect_thread[input->dff->axis_convert[SEPC2H(i,block)]];
}
for(i=0; i < nout/input->nwind[0];i++)
thread_out=(int*) malloc(sizeof(int)*nout/output->nwind[0]);
if(output->dff==SEPNULL) for(i=0; i < nout/output->nwind[0]; i++) thread_out[i]=0;
else{
  iax= output->dff->sect_axis-1;
  block=1;
  for(i=1 ; i <iax; i++) block=block*output->nwind[i];
  for(i=0; i < nout/output->nwind[0]; i++) {
     thread_out[i]=output->dff->sect_thread[output->dff->axis_convert[SEPH2C(i,block,output->nwind[iax])]];
  }
}
/*loop over trace window*/
iin=0; iout=0;
temp=(char*) malloc(esize*input->nwind[0]);
ithread=sep_thread_num();
for(i=0; i < nin/input->nwind[0]; i++){
   /*if iown input or output*/
   if(thread_in[i]==ithread || thread_out[i]==ithread){
     if(thread_in[i]==ithread) { 
       memcpy((void*)temp,(const void*) (data_in+iin), esize*input->nwind[0]);
       iin+=esize*input->nwind[0];
     }
     if(0!=sep3d_pass_data(ithread,thread_in[i],thread_out[i],esize,input->nwind[0],temp)){
       free(temp); free(thread_in); free(thread_out);
       return(sepwarn(NOT_MET,"trouble passing data \n"));
     }
     if(thread_out[i]==ithread) { 
       memcpy((void*) (data_out+iout), (const void*) temp,esize*output->nwind[0]);
       iout+=esize*output->nwind[0];
     }
   }
}
free(temp); free(thread_in); free(thread_out);
return(SUCCESS);
}

_XFUNCPROTOBEGIN
int sep3d_dist_data(char *sep3din, char *sep3dout, int ithread, char *data_in, char *data_out)
_XFUNCPROTOEND
{
sep_3d *info_from, *info_to;
sep_dff *info_dff;

info_from = tag_info_sep3d(sep3din, INQUIRE);
if(info_from==SEPNULL) 
  return(sepwarn(NOT_MET,"Finvalid tag=%s \n",sep3din));
info_to = tag_info_sep3d(sep3dout, INQUIRE);
if(info_from==SEPNULL) 
  return(sepwarn(NOT_MET,"Ginvalid tag=%s \n",sep3dout));
info_dff=info_to->dff;
if(info_dff==SEPNULL) 
  return(sepwarn(NOT_MET,"Hinvalid tag=%s  not sectioned \n",sep3dout));

return(SEP3D_distribute_data(info_from,info_dff,info_to,ithread,data_in,(float*)data_out));
}


_XFUNCPROTOBEGIN
int sep3d_buf_size(char *sep3din, int *nwind, int *fwind, int *jwind, int *n)
_XFUNCPROTOEND
{
sep_3d *info,*info_small;
sep_dff *info_dff;
int isect,i,idim,nc;

info = tag_info_sep3d(sep3din, INQUIRE);
if(info==SEPNULL) 
  return(sepwarn(NOT_MET,"Iinvalid tag=%s \n",sep3din));
info_dff=info->dff;
if(info_dff==SEPNULL) {
  n[0]=nwind[0];
  for(i=1,n[1]=1; i < info->ndims; i++) n[1]=n[1]*nwind[i];
  return(0);
}


for(i=0; i < info->ndims; i++){
  info->fwind[i]=fwind[i];
  info->jwind[i]=jwind[i];
  info->nwind[i]=nwind[i];
}



nc=0;
n[1]=1;
if(info_dff->sect_axis!=1) n[0]=info->nwind[0];
for(i=0; i < info_dff->nsect_ithread; i++){
  isect=info_dff->sect_ithread[i];
  info_small = tag_info_section(info_dff,isect, INQUIRE);

  if(info_small==SEPNULL) 
    return(sepwarn(NOT_MET,"Jinvalid tag=%s \n",info_dff->tag_sect[isect]));
  if(0!=SEP3D_localize_window(info,info_small,isect))
    return(sepwarn(NOT_MET,"trouble localizing window for tag %s \n",info->name));

  if(info_small->file_format==REGULAR){
      n[1]=1;
      for(idim=0; idim<info_small->ndims;idim++){
        if(idim==0 && info_dff->sect_axis!=1) n[0]=info_small->nwind[0];
        else if(idim+1!=info_dff->sect_axis) n[1]=n[1]*info_small->nwind[idim];
      }
    nc+=info_small->nwind[info_dff->sect_axis-1];
  }
  else{
    if(info_dff->sect_axis==1) nc+=info_small->nwind[0];
    else nc+=info_small->nh;
  }
}
if(info_dff->sect_axis==1) n[0]=nc;
else n[1]=n[1]*nc;

if(info->file_format!=REGULAR) n[1]=info->nh;
return(SUCCESS);
}


