#define SET_SDOC 1
#include<sitedef.h>
#include<superset_internal.h>
#include<superset.h>

#if NeedFunctionPrototypes
_XFUNCPROTOBEGIN
int sep3d_grab_sectparams(char *tag, int size, char *param, char *type, void *val)
_XFUNCPROTOEND
#endif
{
sep_3d *info,*info_small;
sep_dff *info_dff;
char *temp,*buf;
int i;
int *tempi;

info = tag_info_sep3d(tag, INQUIRE);  /* get info on this tag */
if(info==SEPNULL) return(sepwarn(-1,"Requested parameter from a non-existant tag\n"));
info_dff=info->dff;
if(info_dff==SEPNULL) {
     auxpar(param,type,val ,tag);
     return(0); 
}

buf=(char*) val;
temp=(char*) malloc(sizeof(char)*size);
tempi=(int*) temp;
for(i=0; i < info_dff->nsect; i++){
   memcpy((void*) temp,(const void*) (buf+i*size), size);
   if(info_dff->impi == info_dff->sect_thread[i]){
     auxpar(param,type,(void*) temp ,info_dff->tag_sect[i]);
   }
   if(0!=sep3d_broadcast_data(tag,info_dff->sect_thread[i],1,size,temp)){
     free(temp);
     return(sepwarn(NOT_MET,"trouble broadcasting parameters \n"));
   }
   memcpy((void*) (buf+i*size) , (const void*) temp, size);
}
   
return(SUCCESS);
}

#if NeedFunctionPrototypes
_XFUNCPROTOBEGIN
int sep3d_set_sectparams(char *tag, int size, char *param, char *type, void *val)
_XFUNCPROTOEND
#endif
{
sep_3d *info,*info_small;
sep_dff *info_dff;
char *temp,*buf;
int i;

info = tag_info_sep3d(tag, INQUIRE);  /* get info on this tag */
info_dff=info->dff;
if(info_dff==SEPNULL) {
  auxputch(param,type,(void*) val ,tag);
  return(0);
}

for(i=0; i < info_dff->nsect_ithread; i++)
auxputch(param,type,(void*) val ,info_dff->tag_sect[info_dff->sect_ithread[i]]);

return(SUCCESS);
}
