#define SET_SDOC 1
#include<sitedef.h>
#include<math.h>
#include<superset.h>
#include<superset_internal.h>
int sep3d_sect_io_verb;


int move_part(sep_3d *info,sep_dff *info_in, sep_dff *info_out, int nmove, int *move);

int sep3d_sync_tag(char *tag, char *sep3dname){
sep_3d *info;
sep_dff *info_dff,*info_new;
char dff[512],temp_ch[1024];
int *move,nmove;
int i;
char **machnew, **dffnew;

  /*init stuff*/
/*
  info = tag_info_sep3d(sep3dname, INQUIRE); 
  if(info==SEPNULL) return(sepwarn(NOT_MET,"invalid structure tag=%s \n",tag));

  if(info->dff==SEPNULL) return(SUCCESS);

  if(0!=fget_distrib_format_tag(tag,dff))
    return(sepwarn(NOT_MET,"trouble getting distribution tag from %s \n",tag));

  info_dff = tag_info_sepdff(dff, INQUIRE); 
  if(info==SEPNULL) return(sepwarn(NOT_MET,
    "can't find dff structure for tag=%s \n",tag));

  
  sprintf(temp_ch,"%s_sync",dff);
  info_new = tag_info_sepdff(temp_ch, info_dff->usage); 
  if(info==SEPNULL) return(sepwarn(NOT_MET,"invalid sync struct tag=%s \n",
   temp_ch));

  if(0!=SEPDFF_copy(info_dff,info_new)) return(sepwarn(NOT_MET,
    "trouble copying structure \n"));

  move=(int*) malloc(sizeof(int)*info_dff->nsect);
  if(0!=SEPDFF_assign_best(info_dff,move, &nmove))
   return(sepwarn(NOT_MET,"trouble finding best assignment  for tag=%s\n",tag));

  machnew=(char**) malloc(sizeof(char*)*info_new->nmpi);
  dffnew=(char**) malloc(sizeof(char*)*info_new->nmpi);

  if(0!=SEPDFF_grab_mpi_names(info_dff,machnew,dffnew)){
    for(i=0; i < info_dff->nmpi; i++) free(machnew[i]); free(machnew);
    for(i=0; i < info_dff->nmpi; i++) free(dffnew[i]); free(dffnew);
    free(move);
    return (sepwarn(NOT_MET,"tag:%s trouble getting mpi_names \n", info->name));  }
  for(i=0; i < info_dff->nmpi; i++) free(machnew[i]); free(machnew);

  for(i=0; i< nmove; i++){
    if(0!=SEPDFF_make_dff_name(info_dff,temp_ch,dffnew[info_dff->sect_thread[i]], dff, move[i],info_dff->sect_thread[i]))
      return(sepwarn(NOT_MET,"trouble making dff name \n"));
    if(0!=SEPDFF_set_tag_sect(info_new,i,temp_ch)){
      for(i=0; i < info_dff->nmpi; i++) free(dffnew[i]); free(dffnew);
      free(move);
      return(sepwarn(NOT_MET,"trouble setting tag sect=%s \n",dff));
    }
  }
  for(i=0; i < info_dff->nmpi; i++) free(dffnew[i]); free(dffnew);
     
 if(0!=SEPDFF_move_part(info,info_dff,info_new,nmove,move)){
   free(move);
   return(sepwarn(NOT_MET,"trouble moving sections for tag=%s \n",tag));
 } 
 info->dff=info_new;

*/
 free(move); 
 return(SUCCESS);
}

_XFUNCPROTOBEGIN
int SEPDFF_move_part(sep_3d *info,sep_dff *info_in, sep_dff *info_out, int nmove, int *move)
_XFUNCPROTOEND
{
double big1,big2;
int nsplit,nmax;
char *data;
int nh,ndone,nblock;
int i1,i2,i3,i4,i5,i6,i7,i8,i9,i,nsect;
int nwind[18],fwind[18],jwind[18],nloop[9];
int imove,isect,write_d,write_h,write_g;
sep_3d  *junk;


write_d=1;
if(info->file_format==HEADER){write_h=1; write_g=0; }
else if(info->file_format==HEADER){write_h=1; write_g=1; }
else { write_h=0; write_g=0;}


if(nmove==0) return(SUCCESS);

if(info->n[0]>2500000) 
  return(sepwarn(NOT_MET,"can't handle traces longer than 2.5 million samples\n"));

big1=info->n[0];nsplit=0;
for(i=1; i< info->ndims; i++){
  big2=big1*info->n[i];
  if(nsplit ==0) { /*we have  not found the split axis*/
    if(big2  >2500000){ nsplit=i; i=info->ndims;}
    else big1=big2;
  }
}
if(nsplit==0) {
  nmax=info->n[info->ndims-1];
  nsplit=info->ndims-1;
} 
else{
  nmax=2500000/(int)big1;
   if(nmax > info->n[nsplit]) nmax=info->n[nsplit];
}


if(info->ndims>9) 
  return(sepwarn(NOT_MET,"can't handle  ndims >9 \n"));

for(i=0; i< 9; i++){ nloop[i]=1; nwind[i]=1; fwind[i]=0; jwind[i]=1; }

  junk = tag_info_sep3d("scratch", INQUIRE); 
  if(junk==SEPNULL) return(sepwarn(NOT_MET,"invalid structure tag=%s \n","scratch"));

for(i=0; i < info->ndims; i++){
 if(i < nsplit) nwind[i]=info->n[i];
 else if(i>nsplit) nloop[i]=info->n[i];
}

for(i9=0; i9 < nloop[8]; i9++){ fwind[8]=i9;
for(i8=0; i8 < nloop[7]; i8++){ fwind[7]=i8;
for(i7=0; i7 < nloop[6]; i7++){ fwind[6]=i7;
for(i6=0; i6 < nloop[5]; i6++){ fwind[5]=i6;
for(i5=0; i5 < nloop[4]; i5++){ fwind[4]=i5;
for(i4=0; i4 < nloop[3]; i4++){ fwind[3]=i4;
for(i3=0; i3 < nloop[2]; i3++){ fwind[2]=i3;
for(i2=0; i2 < nloop[1]; i2++){ fwind[1]=i2;
for(i1=0; i1 < nloop[0]; i1++){ fwind[0]=i1;
/*
  ndone=0;
  while(ndone < info->n[nsplit]){
    if(nmax > info->n[nsplit]-ndone) nblock=info->n[nsplit]-ndone;
    else nblock=nmax;
     fwind[nsplit]=ndone; nwind[nsplit]=nblock;
      for(imove=0; imove < nmove; imove++){
        isect=move[imove];

        nh=0;
        if(0!=sep3d_read_header_section(info->name,info_in->tag_sect[isect],
          info_in->sect_thread[isect], "combo",info_in->sect_thread[isect], 
          isect,&nwind[1],&fwind[1],&jwind[1],&nh))
           return(sepwarn(NOT_MET,
             "tag=%s section=%d trouble reading header section \n", 
              info->name,isect));

        if(nh>0){
           data=(char*) malloc(SEP3D_get_esize(info)*nh*info->n[0]);
           if(0!=sep3d_read_data_section(info->name,info_in->tag_sect[isect],
            info_in->sect_thread[isect],
             "combo",info_in->sect_thread[isect], isect,info->n[0],0,1,data)){
              free(data);
              return(sepwarn(NOT_MET,"tag=%s section=%d trouble reading data section \n", info->name,isect));
           }
           info->dff=info_out;
           if(0!=SEP3D_rite_section(info,junk,
             info_in->sect_thread[isect], info_out->tag_sect[isect], 
             info_in->sect_thread[isect],nwind,fwind,jwind, data,write_d,
             write_h, write_g,nh,isect)){
              free(data);
              return(sepwarn(NOT_MET,"trouble writing sectioned tag  %s \n",info->name));
           }
           info->dff=info_in;
           free(data);
        }
      }
    ndone+=nblock;
  }
*/
}}}}}}}}}
sep3d_delete("combo");


return(SUCCESS);
}
