!<
!sep3d_struct_mod
module sep3d_struct_mod 
  implicit none
  integer, private, save :: counter
  integer, external, private :: sep3d_par_init,sep3d_tag_init&
    &,sep3d_struct_init
  integer, external, private ::sep3d_set_header_vals_s&
    &,sep3d_set_header_vals_i
  integer, external, private  :: sep3d_grab_header_vals_s&
    &,sep3d_grab_header_vals_i
  integer, external, private :: sep3d_grab_ndims, sep3d_read_headers
  integer, external, private  :: sep3d_read_list,sep3d_copy_headers&
    &,sep3d_copy_grid
  integer, external, private :: srite,sep3d_grab_nh,sep3d_set_ntraces
  integer, external, private  :: sep3d_set_nh,sep3d_change_dims&
    &,sep3d_rite_ntraces
  integer, external, private :: sep3d_rite,sep3d_grab_ng&
    &,sep3d_set_inorder
  integer, external, private :: sep3d_grab_ntraces,sep3d_grab_drn 
  integer, external, private  :: sep3d_rite_format,sep3d_set_drn
  integer, external, private :: sep3d_grab_key_index&
    &,sep3d_set_rite_status
  integer, external, private  :: sep3d_grab_axis_index,sep3d_copy_header&
    &,sep3d_copy_coords
  integer, external, private :: sep3d_grab_nkeys,sep3d_set_ng&
    &,sep_thread_num
  integer, external, private  :: sep3d_set_grid_vals,sep3d_delete&
    &,sep3d_grab_grid_block,sep3d_close_tag
  integer, external, private :: sep3dge_space,sep3dconform&
    &,sep3d_reed_data
  integer, external, private :: sep3d_set_nsect,sep3d_grab_nsect
  integer, external, private :: sep3d_grab_impi,sep3d_grab_nmpi
  integer, external, private :: sep3d_broadcast_headers
  integer, external, private :: sep3d_rite_local,sep3d_isect
  integer, external, private :: sep3d_broadcast_data,sep3d_copy_struct
  integer, external, private :: sep3d_read_header_local,sep3d_buf_size
  integer, external, private :: sep3d_read_data_local,sep_num_thread&
    &,sep3d_dist_headers,sep3d_dist_data
  integer, external, private :: sep3d_init_section_par,sep3d_sync_tag&
    &,sep3d_desection_tag
  integer, external, private :: sep3d_set_coord_vals,sep3d_grab_coord_vals&
    &,sep3d_have_dff
  integer, external, private :: sep3d_col_headers,sep3d_col_data&
    &,sep3d_grab_ncoord
  integer, external, private :: sep3d_grab_wind,sep3d_set_wind&
    &,sep3d_count_ntraces
  integer, external, private :: sep3d_grab_sectparams,sep3d_set_sectparams&
    &,sep3d_iown
  integer, external, private :: sep3d_com_data,sep3d_grab_sectaxis&
    &,sep3d_trans_data
  integer, external, private :: sep3d_fileexist&
    &,sep3d_open_local_sections
!$=head1 NAME
!$
!$sep3df - sep3d f90 structure (superset)
!$
!$=head1 SYNOPSIS
!$
!$type(sep3d)
!$
!$=head1 DESCRIPTION
!$
!$type sep3d{
!$
!$        character(len=128) :: tag              #tag to sep3df, MUST  BE SPECIFIED
!$
!$        integer, dimension(:),pointer  :: n #length of regular axes
!$
!$        real, dimension(:) ,pointer    :: o,d #initial and sampling  of regular axes
!$
!$        character(len=128),dimension(:),pointer::label,unit #label and unit for axes
!$
!$        integer :: nkeys,ndims           #number of keys and regular dimensions
!$
!$        integer :: drn #data record number (-1 if in same order)
!$
!$        integer :: ntraces # number of traces in the dataset
!$
!$  integer :: nsect   # number of sections
!$
!$  integer :: nmpi   # number of threads
!$
!$  integer :: impi   # thread number
!$
!$        character(len=128),pointer,dimension(:) :: keyname,keytype,keyfmt #keyname,type and format
!$
!$        character(len=128) :: usage #usage (INPUT,OUTPUT,SCRATCH) for dataset
!$
!$        character(len=128) :: data_format #data format (FLOAT,BYTE,COMPLEX,INTEGER)
!$
!$        character(len=128) :: file_format #file format (REGULAR,HEADER,GRID)
!$
!$
!$
!$
!$
!$
!$=head1 COMMENTS
!$
!$
!$
!$
!$
!$
!$
!$=head1 LIBRARY
!$
!$B<supersetf90>
!$
!$=cut
!$
  type sep3d 
    character(len=128) :: tag              
    !tag to sep3df, MUST  BE SPECIFIED
    integer, dimension(:),pointer  :: n !length of regular axes
    integer, dimension(:),pointer  :: nwind,fwind,jwind 
    !window parameters
    real, dimension(:) ,pointer    :: o,d 
    !initial and sampling  of regular axes
    character(len=128),dimension(:),pointer::label,unit 
    !label and unit for axes
    integer :: nkeys,ndims           !number of keys and regular dimensions
    integer :: drn !data record number (-1 if in same order)
    integer :: ntraces ! number of traces in the dataset
    integer :: nmpi, impi, nsect 
    !number of threads, thread number, section number
    character(len=128),pointer,dimension(:) :: keyname,keytype,keyfmt
!keyname,type and format
    character(len=128) :: usage 
    !usage (INPUT,OUTPUT,SCRATCH) for dataset
    character(len=128) :: data_format 
    !data format (FLOAT,BYTE,COMPLEX,INTEGER)
    character(len=128) :: file_format 
    !file format (REGULAR,HEADER,GRID)
  end type
  interface sep3d_distribute_data
  module procedure distf,disti,distc
  end interface 
  interface sep3d_spread_data
  module procedure broadf,broadi,broadc
  end interface 
  interface sep3d_collect_data
  module procedure colf,coli,colc
  end interface 
  interface sep3d_compress_data
  module procedure comf,comc
  end interface 
  interface init_sep3d
  module procedure tag_init,struct_init,par_init
  end interface 
  interface sep3d_grab_sect_param
  module procedure grab_secti,grab_sectf
  end interface 
  interface sep3d_set_sect_param
  module procedure set_secti,set_sectf
  end interface 
!$
!$=head1 NAME
!$
!$ init_sep3d - initialize a SEP3d type
!$
!$=head1 SYNOPSIS
!$
!$C<call init_sep3d(instruct, outstruct, usage)>
!$
!$C<call init_sep3d(intag,outstruct,usage)>
!$
!$C<call init_sep3d(outstruct,usage,data_format,file_format,n,o,d,label,unit,ntraces,keyname,keytype,keyfmt,nh)>
!$
!$
!$=head1 INPUT PARAMETERS
!$
!$=over 4
!$
!$=item IMPORTANT FOR FORTRAN USERS
!$    include C<ctag="out"> as an argument when initializing output.
!$    (have you noticed a f90 file mysteriously in your directory?)
!$
!$=item instruct  -  sep3d
!$
!$      Sep3d to structure to copy from
!$
!$=item usage     -  char*
!$
!$      Usage of the output tag
!$
!$=item tag       -  char*
!$
!$      Tag to initilize from
!$
!$=item data_format- char*
!$
!$      Data format (FLOAT,INTEGER,BYTE,COMPLEX)
!$
!$=item file_format- char*
!$
!$      File format (GRID,HEADER,REGULAR)
!$
!$=item n-  int*
!$
!$      (optional) axis dimensions
!$
!$=item o-  float*
!$
!$     (optional)  first sample axis
!$
!$=item d-  float*
!$
!$      (optional)  sampling of axis
!$
!$=item label-  char*
!$
!$      (optional)  label for axis
!$
!$=item unit-  char*
!$
!$      (optional)  unit for axis
!$
!$=item ntraces   -  int
!$
!$      (optional)  number of trac3es
!$
!$=item keyname  - char**
!$
!$      (optional)  keyname for dataset
!$
!$=item keytype  -  char**
!$
!$      (optional)  keytype for dataset
!$
!$=item keyfmt -  char**
!$
!$      (optional)  keyfmt for dataset
!$
!$=item nh-  int
!$
!$      (optional)  number of headers to store
!$
!$=back
!$
!$=head1 OUTPUT PARAMETERS
!$
!$=over 4
!$
!$=item outstruct -  sep3d
!$
!$      sep3d structure to create
!$
!$=back
!$
!$
!$=head1 DESCRIPTION
!$
!$Initialize structure
!$
!$
!$=head1 LIBRARY
!$
!$B<supersetf90>
!$
!$=cut
!$
!$=head1 NAME
!$
!$sep3d_grab_key_vals - grab header values from C structure
!$
!$=head1 SYNOPSIS
!$
!$C<call sep3d_grab_key_vals(struct, locate, values)>
!$   must have already made a call to C<sep3d_grab_headers('in',input,nh)>
!$
!$=head1 INPUT PARAMETERS
!$
!$=over 4
!$
!$=item struct   -    sep3d
!$
!$      structure to grab from
!$
!$=item locate   -    (char*/int)
!$
!$      locate through keyname or keyindex
!$
!$=back
!$
!$
!$=head1 OUTPUT PARAMETERS
!$
!$=over 4
!$
!$=item values   -    (float*/int*)
!$
!$              array of header values
!$
!$=back
!$
!$=head1 DESCRIPTION
!$
!$Grab header values
!$
!$=head1 SEE ALSO
!$
!$L<sep3d_set_key_vals>
!$
!$
!$=head1 LIBRARY
!$
!$B<supersetf90>
!$
!$=cut
!$
  interface sep3d_grab_key_vals
  module procedure getkey_i_c,getkey_i_i,getkey_f_c,getkey_f_i
  end interface
!$=head1 NAME
!$
!$sep3d_set_key_vals  - set header values in C structure
!$
!$=head1 SYNOPSIS
!$
!$C<call sep3d_set_key_vals(struct, locate, values)>
!$
!$=head1 INPUT PARAMETERS
!$
!$=over 4
!$
!$=item struct   -    sep3d
!$
!$      structure to grab from
!$
!$=item locate   -    (char*/int)
!$
!$      locate through keyname or keyindex
!$
!$=item values   -    (float*/int*)
!$
!$      array of header values
!$
!$=back
!$
!$=head1 DESCRIPTION
!$
!$Set header values
!$
!$=head1 SEE ALSO
!$
!$L<sep3d_grab_key_vals>
!$
!$=head1 LIBRARY
!$
!$B<supersetf90>
!$
!$=cut
  interface sep3d_set_key_vals
  module procedure putkey_i_c,putkey_i_i,putkey_f_c,putkey_f_i
  end interface
!$
!$=head1 NAME
!$
!$sep3d_read_data -read in data
!$
!$=head1 SYNOPSIS
!$
!$C<logic=sep3d_read_data(tag,struct,data,fwind,jwind,nwind)>
!$
!$=head1 INPUT PARAMETERS
!$
!$=over 4
!$
!$=item tag      -  char*
!$
!$      name of the tag to read from
!$
!$=item struct   -  sep3d
!$
!$      structure to read from
!$
!$=item fwind    -  int*
!$
!$      (optional) begining of window to read
!$
!$=item jwind    -  int*
!$
!$      (optional) sampling to read
!$
!$=item nwind    -  int*
!$
!$      (optional) number of elem to read
!$
!$=back
!$
!$=head1 OUTPUT PARAMETERS
!$
!$=over 4
!$
!$=item data     -  float/int/complex
!$
!$       data to read
!$
!$=back
!$
!$=head1 RETURN VALUES
!$
!$=over 4
!$
!$=item true    -
!$
!$      if success
!$
!$=item false   -
!$
!$      if it fails
!$
!$=back
!$
!$=head1 DESCRIPTION
!$
!$Read data
!$
!$
!$=head1 COMMENTS
!$
!$Must read in the headers first
!$
!$=head1 SEE ALSO
!$
!$L<sep3d_write_data>,L<sep3d_grab_headers>
!$
!$=head1 LIBRARY
!$
!$B<supersetf90>
!$
!$=cut
  interface sep3d_read_data
  module procedure  get_data_2i,get_data_2c,get_data_2f
  module procedure  get_data_3i,get_data_3c,get_data_3f
  module procedure  get_data_4i,get_data_4c,get_data_4f
  end interface
  interface sep3d_transfer_data
  module procedure  trans_data_i,trans_data_c,trans_data_f
  end interface
!$
!$=head1 NAME
!$
!$sep3d_write_data - write out data
!$
!$=head1 SYNOPSIS
!$
!$C<logic=sep3d_write_data(tag,struct,data,fwind,jwind,nwind,write_headers,write_grid)>
!$
!$=head1 INPUT PARAMETERS
!$
!$=over 4
!$
!$=item tag      -  char*
!$
!$      name of the tag to read from
!$
!$=item struct   -  sep3d
!$
!$      structure to read from
!$
!$=item fwind    -  int*
!$
!$      (optional) begining of window to read
!$
!$=item jwind    -  int*
!$
!$      (optional) sampling to read
!$
!$=item nwind    -  int*
!$
!$      (optional) number of elem to read
!$
!$=item data     -  float/int/complex
!$
!$      data tor read
!$
!$=item write_headers - logical
!$
!$      wheter or not write headers
!$
!$=item write_grid - logical
!$
!$      wheter or not write grid
!$
!$=back
!$
!$=head1 RETURN VALUES
!$
!$=over 4
!$
!$=item true    -
!$
!$      if success
!$
!$=item false   -
!$
!$      if fails
!$
!$=back
!$
!$=head1 DESCRIPTION
!$
!$ Write data
!$
!$=head1 SEE ALSO
!$
!$L<sep3d_read_data>,L<sep3d_grab_headers>
!$
!$=head1 LIBRARY
!$
!$B<supersetf90>
!$
!$=cut
  interface sep3d_write_data
  module procedure  put_data_2i,put_data_2c,put_data_2f,put_data_n
  module procedure  put_data_3i,put_data_3c,put_data_4f
  module procedure  put_data_4i,put_data_4c,put_data_3f
  end interface
!
!
!
  contains
!$
!$=head1 NAME
!$
!$ sep3d_grab_sep3d - synchronize f90 structure with C structure
!$
!$=head1 SYNOPSIS
!$
!$ call sep3d_grab_sep3d(sep3dc,sep3df)
!$
!$=head1 INPUT PARAMETERS
!$
!$=over 4
!$
!$=item sep3dc  -  char*
!$
!$      pointer to C sep3d structure
!$
!$=back
!$
!$=head1 OUTPUT PARAMETERS
!$
!$=over 4
!$
!$=item sep3df  -  sep3d
!$
!$      fortran sep3d structure to copy to
!$
!$=back
!$
!$=head1 DESCRIPTION
!$
!$ Copies sep3d C structure to its fortran equivilant
!$
!$=head1 SEE ALSO
!$
!$ sep3d_set_sep3d
!$
!$=head1 LIBRARY
!$
!$B<supersetf90>
!$
!$=cut
  subroutine sep3d_grab_sep3d(sep3dc,sep3df)
    type(sep3d) :: sep3df
    character(len=*),optional    :: sep3dc
    character(len=128) :: tag
    integer     :: ierr,i1
    integer,external :: sep3d_grab_key
    if (valid_structure(sep3df) .and. (sep3df%ndims.ne.0 .or. sep3df%nkeys.ne.0&
      &)) then
      call sep3d_clean(sep3df)
      if (.not. present(sep3dc)) then
        tag=sep3df%tag
      else
        tag =sep3dc
      end if
    else if (.not. present(sep3dc)) then
      call erexit("must specify a tag when first reading a structure")
    else
      tag=sep3dc
    end if 
    ierr= sep3d_grab_ndims(tag,sep3df%ndims)
    if (ierr.ne.0) then
      call seperr("trouble grabing ndim for tag %s \n",tag)
    end if
    if (sep3df%ndims>0) then
      allocate(sep3df%n(sep3df%ndims), sep3df%o(sep3df%ndims), sep3df%d&
        &(sep3df%ndims))
      allocate(sep3df%nwind(sep3df%ndims), sep3df%fwind(sep3df%ndims),&
        & sep3df%jwind(sep3df%ndims))
      allocate(sep3df%label(sep3df%ndims), sep3df%unit(sep3df%ndims)&
        &,stat=ierr)
      if (ierr.ne.0) then
        call erexit("trouble allocating n,o,d in structure")
      end if
      do i1=1,sep3df%ndims 
        call sep3d_grab_axis(tag,i1,sep3df%n(i1),sep3df%o(i1),sep3df%d&
          &(i1),sep3df%label(i1),sep3df%unit(i1))
      end do 
      if (0.ne. sep3d_grab_wind(sep3dc,sep3df%nwind,sep3df%fwind&
        &,sep3df%jwind)) then
        call seperr("trouble grabbing window parameters")
      end if
    end if
    ierr=sep3d_grab_nkeys(tag,sep3df%nkeys)
    if (ierr.ne.0) then
      call erexit("trouble grabbing nkeys ")
    end if
    if (sep3df%nkeys>0) then
      allocate(sep3df%keyname(sep3df%nkeys),sep3df%keytype(sep3df%nkeys&
        &)) 
      allocate(sep3df%keyfmt(sep3df%nkeys),stat=ierr)
      if (ierr.ne.0) then
        call erexit("trouble allocating keys in sep3df")
      end if
      do i1=1,sep3df%nkeys 
        if (0.ne.sep3d_grab_key(tag,i1,sep3df%keyname(i1),sep3df%keytype&
          &(i1),sep3df%keyfmt(i1))) then
          sep3df%keyname(i1)="Unspecified"
          sep3df%keytype(i1)="Unspecified"
          sep3df%keyfmt(i1)="Unspecified"
        end if
      end do
    end if
    call sep3d_grab_usage(tag,sep3df%usage)
    call sep3d_grab_file_type(tag,sep3df%file_format)
    call sep3d_grab_data_type(tag,sep3df%data_format)
    sep3df%tag=tag
    if (0.ne. sep3d_grab_ntraces(tag,sep3df%ntraces)) then
      sep3df%ntraces=0
    end if
    if (0.ne. sep3d_grab_nsect(tag,sep3df%nsect)) then
      sep3df%nsect=1
    end if
    if (0.ne. sep3d_grab_nmpi(tag,sep3df%nmpi)) then
      sep3df%nmpi=1
    end if
    if (0.ne. sep3d_grab_impi(tag,sep3df%impi)) then
      sep3df%impi=0
    end if
  end subroutine 
!$
!$=head1 NAME
!$
!$ sep3d_set_sep3d - synchronize C structure with f90 structure
!$
!$=head1 SYNOPSIS
!$
!$<call sep3d_set_sep3d(sep3df)>
!$
!$=head1 INPUT PARAMETERS
!$
!$=over 4
!$
!$=item sep3df  -  sep3d
!$
!$      fortran sep3d structure to copy from
!$
!$
!$=back
!$
!$=head1 DESCRIPTION
!$
!$ Copies sep3d F90 structure to its C equivilant
!$
!$=head1 SEE ALSO
!$
!$L<sep3d_grab_sep3d>
!$
!$=head1 LIBRARY
!$
!$B<supersetf90>
!$
!$=cut
  subroutine sep3d_set_sep3d(sep3df)
    type(sep3d) :: sep3df
    character(len=128) :: sep3dc
    integer :: i1,ierr
    integer,external :: sep3d_grab_key
    if (.not. valid_structure(sep3df)) then
      call erexit("must specify usage before copy structure")
    end if
    sep3dc=sep3df%tag
    if (0.ne. sep3d_par_init(sep3dc,sep3df%usage)) then
      call erexit("trouble initializing tag")
    end if
    if (sep3df%ndims>0) then
      call sep3d_set_ndims(sep3dc,sep3df%ndims)
      do i1=1,sep3df%ndims 
        call sep3d_set_axis(sep3dc,i1,sep3df%n(i1),sep3df%o(i1),sep3df%d&
          &(i1),sep3df%label(i1),sep3df%unit(i1))
      end do 
      if (0.ne. sep3d_set_wind(sep3dc,sep3df%nwind,sep3df%fwind,sep3df%jwind&
        &)) then
        call seperr("trouble setting window parameters")
      end if
    end if
    if (sep3df%nkeys>0) then
      call sep3d_set_nkeys(sep3dc,sep3df%nkeys)
      do i1=1,sep3df%nkeys 
        if (sep3df%keyname(i1)(1:18).ne."data_record_number") then
          call sep3d_set_key(sep3dc,i1,sep3df%keyname(i1),sep3df%keytype&
            &(i1),sep3df%keyfmt(i1))
        end if
      end do
    end if
    call sep3d_set_file_type(sep3dc,sep3df%file_format)
    call sep3d_set_data_type(sep3dc,sep3df%data_format)
    if (0.ne. sep3d_set_ntraces(sep3dc,sep3df%ntraces)) then
      call erexit("trouble putting into C the number of traces")
    end if
!if(0!=sep3d_set_nsect(sep3dc,sep3df%nsect))
!        call erexit("trouble setting number of sections")
  end subroutine 
!$=head1 NAME
!$
!$valid_structure - check if sep3d structure is valid
!$
!$=head1 SYNOPSIS
!$
!$C<logical =valid_structure(struct)>
!$
!$=head1 INPUT PARAMETERS
!$
!$=over 4
!$
!$=item struct - sep3d
!$
!$       Structure to check the validity of
!$
!$=back
!$
!$=head1 RETURN VALUE
!$
!$=over 4
!$
!$=item .true.
!$
!$      if valid
!$
!$=item .false.
!$
!$      if not valid
!$
!$=back
!$
!$
!$=head1 DESCRIPTION
!$
!$Check to see if structure is valid
!$
!$=head1 SEE ALSO
!$
!$L<sep3df>
!$
!$=head1 LIBRARY
!$
!$B<supersetf90>
!$
!$=cut
  logical function valid_structure(sep3df)
    type(sep3d) :: sep3df
    if (sep3df%usage(1:5).eq."INPUT" .or. sep3df%usage(1:6&
      &).eq."OUTPUT".or.sep3df%usage(1:7).eq."SCRATCH") then
      valid_structure=.true.
    else
      valid_structure=.false.
    end if
  end function 
  subroutine sep3df_delete(sep3df,tag1,tag2,tag3,tag4,tag5)
    type(sep3d) :: sep3df
    character(len=*),optional :: tag1,tag2,tag3,tag4,tag5
    if (present(tag1)) then
      if (0.ne.sep3d_close_tag(tag1,sep3df%tag)) then
        write(0,*) "tag=",trim(tag1)
        call seperr("trouble closing tag")
      end if
    end if
    if (present(tag2)) then
      if (0.ne.sep3d_close_tag(tag2,sep3df%tag)) then
        write(0,*) "tag=",trim(tag2)
        call seperr("trouble closing tag")
      end if
    end if
    if (present(tag3)) then
      if (0.ne.sep3d_close_tag(tag3,sep3df%tag)) then
        write(0,*) "tag=",trim(tag3)
        call seperr("trouble closing tag")
      end if
    end if
    if (present(tag4)) then
      if (0.ne.sep3d_close_tag(tag4,sep3df%tag)) then
        write(0,*) "tag=",trim(tag4)
        call seperr("trouble closing tag")
      end if
    end if
    if (present(tag5)) then
      if (0.ne.sep3d_close_tag(tag5,sep3df%tag)) then
        write(0,*) "tag=",trim(tag5)
        call seperr("trouble closing tag")
      end if
    end if
    if (0.ne.sep3d_delete(trim(sep3df%tag))) then
      call erexit("trouble deleting tag")
    end if
    call sep3d_clean(sep3df)
  end subroutine 
  subroutine sep3d_clean(sep3df)
    type(sep3d) :: sep3df
!        call sep3d_clear_headers(sep3df%tag)
!        call sep3d_clear_grid(sep3df%tag)
    if (sep3df%ndims.ne.0) then
      deallocate(sep3df%n,sep3df%o,sep3df%d,sep3df%label,sep3df%unit&
        &,sep3df%nwind,sep3df%fwind,sep3df%jwind)
    end if
    if (sep3df%nkeys.ne.0) then
      deallocate(sep3df%keyname,sep3df%keytype,sep3df%keyfmt)
    end if
    sep3df%usage="burned"
  end subroutine 
  subroutine struct_init(instruct,outstruct,usage,ctag)
    type(sep3d) :: instruct,outstruct
    character(len=*) :: usage
    character(len=128) :: temp,temp2
    character(len=*),optional :: ctag
    call sep3d_mpi_init()
    if (present(ctag)) then
      temp=ctag
    else
      write (temp,"(a,i1)") "sepf",counter
    end if 
    counter=counter+1
! call mkrandom_string(temp,temp2)
    if (0.ne.sep3d_struct_init(instruct%tag,temp,usage)) then
      call erexit("trouble initializing tag")
    end if
    call sep3d_grab_sep3d(temp,outstruct)
  end subroutine 
  subroutine tag_init(intag,outstruct,usage,local_tag)
    type(sep3d) :: outstruct
    character(len=*) ::  intag,usage
    character(len=7) :: temp
    logical, optional :: local_tag
    logical :: myloc
    integer :: ithread,nsz,i,nthread
    real, allocatable :: buf(:)
!write (temp,"(a,i1)") "sepf",counter;counter+=1
    ithread= sep_thread_num()
    nthread= sep_num_thread()
    call sep3d_mpi_init()
    if (present(local_tag)) then
      if (.not. local_tag) then
        return
      end if
      if (0.ne. sep3d_tag_init(intag,intag,usage)) then
        call erexit("trouble initializing tag")
      end if
    else
      if (ithread.eq.0) then
        if (0.ne. sep3d_tag_init(intag,intag,usage)) then
          call erexit("trouble initializing tag")
        end if
      end if
      if (nthread>1) then
        if (0.ne.sep3d_broadcast_headers(intag,0)) then
          call seperr("trouble broadcasting headers")
        end if
      end if
    end if 
    call sep3d_grab_sep3d(intag,outstruct)
    if (0.ne.sep3d_open_local_sections(outstruct%tag,0)) then
      call seperr("trouble opening local tags")
    end if
  end subroutine 
  subroutine par_init(struct,usage,data_format,file_format,n,o,d,label&
    &,unit,ntraces,keyname,keytype,keyfmt,nh,ctag)
    type(sep3d) :: struct
    character(len=*) :: usage,data_format,file_format
    character(len=128) :: temp
    integer,optional :: n(:),ntraces,nh
    character(len=*), optional :: label(:),unit(:),keyname(:),keytype(:&
      &),keyfmt(:)
    real, optional :: d(:),o(:)
    integer :: ndim
    character(len=*),optional :: ctag
    call sep3d_mpi_init()
    if (present(ctag)) then
      temp=ctag
    else
      write (temp,"(a,i1)") "sepf",counter
      counter=counter+1
    end if 
    if (0.ne.sep3d_par_init(temp,usage)) then
      call erexit("trouble initializing structure")
    end if
    call sep3d_grab_sep3d(temp,struct)
    struct%file_format=file_format
    struct%data_format=data_format
    ndim=0
    if (present(n)) then
      ndim=size(n)
    end if
    if (present(o)) then
      if (ndim.ne.0) then
        ndim=size(o)
      else if (size(o).ne.ndim) then
        call erexit("size of axis parts must be consistent")
      end if
    end if
    if (present(d)) then
      if (ndim.ne.0) then
        ndim=size(d)
      else if (size(d).ne.ndim) then
        call erexit("size of axis parts must be consistent")
      end if
    end if
    if (present(label)) then
      if (ndim.ne.0) then
        ndim=size(label)
      else if (size(label).ne.ndim) then
        call erexit("size of axis parts must be consistent")
      end if
    end if
    if (present(unit)) then
      if (ndim.ne.0) then
        ndim=size(unit)
      else if (size(unit).ne.ndim) then
        call erexit("size of axis parts must be consistent")
      end if
    end if
    if (ndim.ne.0) then
      call axis_allocate(struct,ndim)
      if (present(n)) then
        struct%n=n
      else
        struct%n=1
      end if 
      if (present(o)) then
        struct%o=o
      else
        struct%o=0.
      end if 
      if (present(d)) then
        struct%d=d
      else
        struct%d=1.
      end if 
      if (present(label)) then
        struct%label=label
      else
        struct%label=" "
      end if 
      if (present(unit)) then
        struct%unit=unit
      else
        struct%unit="Undefined"
      end if 
      struct%nwind=n
      struct%fwind=0
      struct%jwind=1
    end if
    if (present(keyname)) then
      if (.not. present(keytype) .or. .not. present(keyfmt)) then
        call erexit("must supply keyname, keytype, and keyfmt")
      else if (size(keyname) .ne. size(keyfmt) .or. size(keyname).ne.size&
        &(keyfmt)) then
        call erexit("keyname,keytype, and keyfmt must be the same size"&
          &)
      end if
      call key_allocate(struct,size(keyname))
      struct%keyname=keyname
      struct%keytype=keytype
      struct%keyfmt=keyfmt
    end if
    if (present(ntraces)) then
      struct%ntraces=ntraces
    end if
    if (present(nh)) then
      if (0.ne. sep3d_set_nh(struct%tag,nh)) then
        call erexit("trouble setting nh ")
      end if
    end if
    call sep3d_set_sep3d(struct)
  end subroutine 
  subroutine key_allocate(struct,nkeys)
    type(sep3d) :: struct
    integer :: nkeys
    if (.not.valid_structure(struct)) then
      call erexit("key_allocate: Structure has not been initialied")
    end if
    if (struct%nkeys.ne.0) then
      deallocate(struct%keyname,struct%keytype,struct%keyfmt)
    end if
    allocate(struct%keyname(nkeys),struct%keyfmt(nkeys),struct%keytype&
      &(nkeys))
    struct%keytype="scalar_float"
    struct%keyfmt="xdr_float"
    struct%nkeys=nkeys
  end subroutine 
  subroutine axis_allocate(struct,ndim)
    type(sep3d) :: struct
    integer :: ndim
    if (.not.valid_structure(struct)) then
      call erexit("axis_allocate: Structure has not been initialied")
    end if
    if (struct%ndims.ne.0) then
      deallocate(struct%n,struct%o,struct%d,struct%label,struct%unit&
        &,struct%nwind,struct%fwind,struct%jwind)
    end if
    allocate(struct%n(ndim),struct%o(ndim),struct%d(ndim),struct%label&
      &(ndim),struct%unit(ndim),struct%nwind(ndim),struct%fwind(ndim&
      &),struct%jwind(ndim))
    struct%ndims=ndim
    struct%n=1
    struct%o=0.
    struct%d=1.
    struct%label=" "
    struct%unit=" "
  end subroutine 
  subroutine putkey_i_c(struct,keyname,header)
    type(sep3d) :: struct
    character(len=*) :: keyname
    integer,dimension(:) :: header
    integer :: nh
    if (.not. valid_structure(struct)) then
      call erexit("structure has not been initialized")
    end if
    if (0.ne.sep3d_grab_nh(struct%tag,nh)) then
      if (0.ne. sep3d_set_nh(struct%tag,size(header))) then
        call erexit("trouble setting number of headers in structure\n"&
          &)
      end if
    else if (nh.ne.size(header)) then
      write(0,*) "size wrong ",nh,size(header)
      call erexit("header array not the same size as stored nh")
    end if
    if (0.ne.sep3d_set_header_vals_s(struct%tag,keyname,header)) then
      call erexit("trouble reading key")
    end if
  end subroutine 
  subroutine putkey_f_c(struct,keyname,header)
    type(sep3d) :: struct
    character(len=*) :: keyname
    real,dimension(:) :: header
    integer :: nh
    if (.not. valid_structure(struct)) then
      call erexit("structure has not been initialized")
    end if
    if (0.ne.sep3d_grab_nh(struct%tag,nh)) then
      if (0.ne. sep3d_set_nh(struct%tag,size(header))) then
        call erexit("trouble setting number of headers in structure\n"&
          &)
      end if
    else if (nh.ne.size(header)) then
      write(0,*) "check",nh,size(header)
      call erexit("header array not the same size as stored nh")
    end if
    if (0.ne.sep3d_set_header_vals_s(struct%tag,keyname,header)) then
      call erexit("trouble reading key")
    end if
  end subroutine 
  subroutine putkey_i_i(struct,keyindex,header)
    type(sep3d) :: struct
    integer :: keyindex,nh
    integer,dimension(:) :: header
    if (.not. valid_structure(struct)) then
      call erexit("structure has not been initialized")
    end if
    if (0.ne.sep3d_grab_nh(struct%tag,nh)) then
      if (0.ne. sep3d_set_nh(struct%tag,size(header))) then
        call erexit("trouble setting number of headers in structure\n"&
          &)
      end if
    else if (nh.ne.size(header)) then
      call erexit("header array not the same size as stored nh")
    end if
    if (0.ne.sep3d_set_header_vals_i(struct%tag,keyindex,header)) then
      call erexit("trouble reading key")
    end if
  end subroutine 
  subroutine putkey_f_i(struct,keyindex,header)
    type(sep3d) :: struct
    integer :: keyindex,nh
    real,dimension(:) :: header
    if (.not. valid_structure(struct)) then
      call erexit("structure has not been initialized")
    end if
    if (0.ne.sep3d_grab_nh(struct%tag,nh)) then
      if (0.ne. sep3d_set_nh(struct%tag,size(header))) then
        call erexit("trouble setting number of headers in structure\n"&
          &)
      end if
    else if (nh.ne.size(header)) then
      call erexit("header array not the same size as stored nh")
    end if
    if (0.ne.sep3d_set_header_vals_i(struct%tag,keyindex,header)) then
      call erexit("trouble reading key")
    end if
  end subroutine 
  subroutine getkey_i_c(struct,keyname,header)
    type(sep3d) :: struct
    character(len=*) :: keyname
    integer,dimension(:) :: header
    if (.not. valid_structure(struct)) then
      call erexit("structure has not been initialized")
    end if
    if (0.ne.sep3d_grab_header_vals_s(struct%tag,keyname,header)) then
      call erexit("trouble reading key")
    end if
  end subroutine 
  subroutine getkey_f_c(struct,keyname,header)
    type(sep3d) :: struct
    character(len=*) :: keyname
    real,dimension(:) :: header
    if (.not. valid_structure(struct)) then
      call erexit("structure has not been initialized")
    end if
    if (0.ne.sep3d_grab_header_vals_s(struct%tag,keyname,header)) then
      call erexit("trouble reading key")
    end if
  end subroutine 
  subroutine getkey_i_i(struct,keyindex,header)
    type(sep3d) :: struct
    integer :: keyindex
    integer,dimension(:) :: header
    real,dimension(:),allocatable :: headr
    if (.not. valid_structure(struct)) then
      call erexit("structure has not been initialized")
    end if
    if (struct%keytype(keyindex).eq."scalar_float") then
      allocate(headr(size(header)))
      if (0.ne.sep3d_grab_header_vals_i(struct%tag,keyindex,headr))&
        & then
        call erexit("trouble reading key")
      end if
      header=nint(headr)
      deallocate(headr)
    else
      if (0.ne.sep3d_grab_header_vals_i(struct%tag,keyindex,header))&
        & then
        if (0.ne.sep3d_grab_header_vals_i(struct%tag,keyindex,header))&
          & then
          call erexit("trouble reading key")
        end if
      end if
    end if
  end subroutine 
  subroutine getkey_f_i(struct,keyindex,header)
    type(sep3d) :: struct
    integer :: keyindex
    real,dimension(:) :: header
    integer,dimension(:),allocatable :: headi
    if (.not. valid_structure(struct)) then
      call erexit("structure has not been initialized")
    end if
    if (struct%keytype(keyindex).eq."scalar_int") then
      allocate(headi(size(header)))
      if (0.ne.sep3d_grab_header_vals_i(struct%tag,keyindex,headi))&
        & then
        call erexit("trouble reading key")
      end if
      header=real(headi)
      deallocate(headi)
    else
      if (0.ne.sep3d_grab_header_vals_i(struct%tag,keyindex,header))&
        & then
        call erexit("trouble reading key")
      end if
    end if
  end subroutine 
!$=head1 NAME
!$
!$sep3d_grab_headers - grab headers
!$
!$=head1 SYNOPSIS
!$
!$C<call sep3d_grab_headers(tag,struct,nh,nwind,fwind,jwind)>
!$
!$=head1 INPUT PARAMETERS
!$
!$=over 4
!$
!$=item tag   -  char*
!$
!$      tag to read from
!$
!$=item struct-  sep3d
!$
!$      struct to read into
!$
!$=item nwind -  int*
!$
!$      number of elements
!$
!$=item fwind -  int*
!$
!$      first element
!$
!$=item jwind -  int*
!$
!$      sampling of elements
!$
!$=back
!$
!$=head1 OUTPUT PARAMETERS
!$
!$=over 4
!$
!$=item nh    -  int
!$
!$      number of headers read
!$
!$=back
!$
!$=head1 DESCRIPTION
!$
!$Read in headers to structure
!$
!$=head1 SEE ALSO
!$
!$L<sep3d_read_data>
!$
!$=head1 LIBRARY
!$
!$B<supersetf90>
!$
!$=cut
!$
!$
  subroutine sep3d_grab_headers(tag,struct,nh,nwind,fwind,jwind,local_tag&
    &)
    character(len=*) :: tag
    type(sep3d) :: struct
    integer, optional, dimension(:) :: nwind,fwind,jwind
    integer, allocatable, dimension(:) :: ntemp,ftemp,jtemp,ng
    logical, optional :: local_tag
    logical ::  my_local
    real, allocatable,dimension(:) :: og,dg
    character(len=128), allocatable,dimension(:) :: label,unit
    integer :: ndim,i,nh,nthread
    nthread= sep_num_thread()
    if (.not. valid_structure(struct)) then
      call erexit("structure has not been initialized")
    end if
    if (0.ne.sep3d_grab_ndims(struct%tag,ndim)) then
      call erexit("trouble getting grid axis")
    end if
    ndim=ndim-1
    allocate(ntemp(ndim),ftemp(ndim),jtemp(ndim))
    if (present(nwind)) then
      if (size(nwind)<ndim) then
        call erexit("nwind not the right size")
      end if
      ntemp=nwind
    else
      ntemp=-1
    end if 
    if (present(local_tag)) then
      my_local=local_tag
    else if (sep_num_thread()>1) then
      my_local=.false.
    else
      my_local=.true.
    end if 
    if (present(fwind)) then
      if (size(fwind)<ndim) then
        call erexit("fwind not the right size")
      end if
      ftemp=fwind
    else
      ftemp=-1
    end if 
    if (present(jwind)) then
      if (size(jwind)<ndim) then
        call erexit("jwind not the right size")
      end if
      jtemp=jwind
    else
      jtemp=-1
    end if 
    call fix_vector(struct%n(2:),ftemp,jtemp,ntemp)
    struct%nwind(2:)=ntemp
    struct%fwind(2:)=ftemp
    struct%jwind(2:)=jtemp
    if (struct%nsect >1) then
      if (struct%nmpi>1) then
!sectioned and mpi
! read only local
        if (0.ne.sep3d_read_header_local(struct%tag,ntemp,ftemp,jtemp&
          &,nh)) then
          call erexit("trouble reading headers")
        end if
      else
!sectioned but no mpi
! read all
        if (0.ne.sep3d_read_header_local(struct%tag,ntemp,ftemp,jtemp&
          &,nh)) then
          call erexit("trouble reading headers")
        end if
      end if
    else
      if (sep_num_thread()>1) then
        if (struct%impi.eq.0 .or. my_local) then
          if (0.ne.sep3d_read_headers(tag,struct%tag,ntemp,ftemp,jtemp&
            &,nh)) then
            call erexit("trouble reading headers")
          end if
        end if
        if (.not. my_local) then
          if (nthread>1) then
            if (0.ne.sep3d_broadcast_headers(struct%tag,0)) then
              call erexit("trouble broadcasting  headers")
            end if
          end if
        end if
      else
!not mpi or sectioned
        if (0.ne.sep3d_read_headers(tag,struct%tag,ntemp,ftemp,jtemp,nh&
          &)) then
          call erexit("trouble reading headers")
        end if
      end if
    end if 
    deallocate(ftemp,jtemp,ntemp)
  end subroutine 
  logical function  get_data_3f(tag,struct,data,nwind,fwind,jwind,local_tag&
    &)
    character(len=*) :: tag
    type(sep3d) :: struct
    real,dimension(:,:,:) :: data
    integer ::drn,ierr
    integer, dimension(:), allocatable ::trnum
    integer, optional :: fwind,jwind,nwind
    integer :: ft,nt,jt,nh
    logical, optional :: local_tag
    logical :: my_local
    integer :: nthread
    nthread= sep_num_thread()
    if (present(fwind)) then
      ft=fwind
    else
      ft=-1
    end if 
    if (present(jwind)) then
      jt=jwind
    else
      jt=-1
    end if 
    if (present(nwind)) then
      nt=nwind
    else
      nt=-1
    end if 
    if (.not. fix1(struct%n(1),ft,jt,nt)) then
      write(0,*) "trouble fixing axis 1"
      return
    end if
    if (present(local_tag)) then
      my_local=local_tag
    else if (sep_num_thread()>1) then
      my_local=.false.
    else
      my_local=.true.
    end if 
    struct%nwind(1)=nt
    struct%fwind(1)=ft
    struct%jwind(1)=jt
    if (.not. valid_structure(struct)) then
      call erexit("structure has not been initialized")
    end if
    if (struct%data_format .ne. "FLOAT") then
      call erexit("data type is not float")
    end if
    if (struct%nsect >1) then
      if (0.ne.sep3d_read_data_local(struct%tag,nt,ft,jt,data)) then
        call erexit("trouble reading data")
      end if
    else
      if (sep_num_thread()>1) then
        if (sep_thread_num().eq.0 .or. my_local) then
          if (size(data) < product(struct%nwind) .and. struct%file_format&
            &(1:1).ne."G") then
            write(0,*) sep_thread_num(),"=thread Window size greater&
              & than buffer size",product(struct%nwind),size(data)
            call seperr("read request beyond buffer size")
          end if
          if (0.ne.sep3d_reed_data(tag,struct%tag,nt,ft,jt,data)) then
            call erexit("trouble reading data")
          end if
        end if
        if (.not. my_local) then
          if (nthread>1) then
            if (0.ne.sep3d_broadcast_data(struct%tag,0,4,size(Data),data&
              &)) then
              call erexit("trouble broadcastting  data")
            end if
          end if
        end if
      else
!not mpi or sectioned
        if (size(data) < product(struct%nwind) .and. struct%file_format&
          &(1:1).ne."G") then
          write(0,*) sep_thread_num(),"=thread Window size greater than&
            & buffer size",product(struct%nwind),size(data)
          call seperr("read request beyond buffer size")
        end if
        if (0.ne.sep3d_reed_data(tag,struct%tag,nt,ft,jt,data)) then
          call erexit("trouble reading data")
        end if
      end if
    end if 
    get_data_3f=.true.
!deallocate(trnum)
  end function 
  logical function  get_data_3c(tag,struct,data,nwind,fwind,jwind,local_tag&
    &)
    character(len=*) :: tag
    type(sep3d) :: struct
    complex,dimension(:,:,:) :: data
    integer ::drn,ierr
    integer, dimension(:), allocatable ::trnum
    integer, optional :: fwind,jwind,nwind
    integer :: ft,nt,jt,nh,nthread
    logical, optional :: local_tag
    logical :: my_local
    if (present(local_tag)) then
      my_local=local_tag
    else if (struct%nmpi>1) then
      my_local=.false.
    else
      my_local=.true.
    end if 
    nthread= sep_num_thread()
    if (present(fwind)) then
      ft=fwind
    else
      ft=-1
    end if 
    if (present(jwind)) then
      jt=jwind
    else
      jt=-1
    end if 
    if (present(nwind)) then
      nt=nwind
    else
      nt=-1
    end if 
    if (.not.  fix1(struct%n(1),ft,jt,nt)) then
      write(0,*) "axis 1 problem"
    end if
    struct%nwind(1)=nt
    struct%fwind(1)=ft
    struct%jwind(1)=jt
    if (.not. valid_structure(struct)) then
      call erexit("structure has not been initialized")
    end if
    if (struct%data_format .ne. "COMPLEX") then
      call erexit("data type is not complex")
    end if
    if (struct%nsect >1) then
! read only local
      if (0.ne.sep3d_read_data_local(struct%tag,nt,ft,jt,data)) then
        call erexit("trouble reading headers")
      end if
    else
      if (struct%nmpi>1) then
        if (struct%impi.eq.0 .or. my_local) then
          if (size(data) < product(struct%nwind) .and. struct%file_format&
            &(1:1).ne."G") then
            write(0,*) sep_thread_num(),"=thread Window size greater&
              & than buffer size",product(struct%nwind),size(data)
            call seperr("read request beyond buffer size")
          end if
          if (0.ne.sep3d_reed_data(tag,struct%tag,nt,ft,jt,nh)) then
            call erexit("trouble reading data")
          end if
        end if
        if (.not. my_local) then
          if (nthread>1) then
            if (0.ne.sep3d_broadcast_data(struct%tag,0,1,size(Data),data&
              &)) then
              call erexit("trouble broadcasting  data")
            end if
          end if
        end if
      else
!not mpi or sectioned
        if (size(data) < product(struct%nwind) .and. struct%file_format&
          &(1:1).ne."G") then
          write(0,*) sep_thread_num(),"=thread Window size greater than&
            & buffer size",product(struct%nwind),size(data)
          call seperr("read request beyond buffer size")
        end if
        if (0.ne.sep3d_reed_data(tag,struct%tag,nt,ft,jt,data)) then
          call erexit("trouble reading data")
        end if
      end if
    end if 
    get_data_3c=.true.
!deallocate(trnum)
  end function 
  logical function  get_data_3i(tag,struct,data,nwind,fwind,jwind,local_tag&
    &)
    character(len=*) :: tag
    type(sep3d) :: struct
    integer,dimension(:,:,:) :: data
    integer ::drn,ierr
    integer, dimension(:), allocatable ::trnum
    integer, optional :: fwind,jwind,nwind
    integer :: ft,nt,jt,nh,nthread
    logical, optional :: local_tag
    logical :: my_local
    nthread= sep_num_thread()
    get_data_3i=.false.
    if (present(local_tag)) then
      my_local=local_tag
    else if (struct%nmpi>1) then
      my_local=.false.
    else
      my_local=.true.
    end if 
    if (present(fwind)) then
      ft=fwind
    else
      ft=-1
    end if 
    if (present(jwind)) then
      jt=jwind
    else
      jt=-1
    end if 
    if (present(nwind)) then
      nt=nwind
    else
      nt=-1
    end if 
    if (.not. fix1(struct%n(1),ft,jt,nt)) then
      write(0,*) "axis 1 problem"
      return
    end if
    struct%nwind(1)=nt
    struct%fwind(1)=ft
    struct%jwind(1)=jt
    if (.not. valid_structure(struct)) then
      call erexit("structure has not been initialized")
    end if
    if (struct%data_format .ne. "INTEGER") then
      call erexit("data type is integer")
    end if
    if (struct%nsect >1) then
      if (0.ne.sep3d_read_data_local(struct%tag,nt,ft,jt,data)) then
        call erexit("trouble reading headers")
      end if
    else
      if (struct%nmpi>1) then
        if (struct%impi.eq.0 .or. my_local) then
          if (size(data) < product(struct%nwind) .and. struct%file_format&
            &(1:1).ne."G") then
            write(0,*) sep_thread_num(),"=thread Window size greater&
              & than buffer size",product(struct%nwind),size(data)
            call seperr("read request beyond buffer size")
          end if
          if (0.ne.sep3d_reed_data(tag,struct%tag,nt,ft,jt,nh)) then
            call erexit("trouble reading data")
          end if
        end if
        if (.not. my_local) then
          if (nthread>1) then
            if (0.ne.sep3d_broadcast_data(struct%tag,0,4,size(Data),data&
              &)) then
              call erexit("trouble broadcasting  data")
            end if
          end if
        end if
      else
!not mpi or sectioned
        if (size(data) < product(struct%nwind) .and. struct%file_format&
          &(1:1).ne."G") then
          write(0,*) sep_thread_num(),"=thread Window size greater than&
            & buffer size",product(struct%nwind),size(data)
          call seperr("read request beyond buffer size")
        end if
        if (0.ne.sep3d_reed_data(tag,struct%tag,nt,ft,jt,data)) then
          call erexit("trouble reading data")
        end if
      end if
    end if 
    get_data_3i=.true.
  end function 
  logical function  get_data_4f(tag,struct,data,nwind,fwind,jwind,local_tag&
    &)
    character(len=*) :: tag
    type(sep3d) :: struct
    real,dimension(:,:,:,:) :: data
    integer ::drn,ierr
    integer, dimension(:), allocatable ::trnum
    integer, optional :: fwind,jwind,nwind
    integer :: ft,nt,jt,nh
    logical, optional :: local_tag
    logical :: my_local
    integer :: nthread
    nthread= sep_num_thread()
    if (present(fwind)) then
      ft=fwind
    else
      ft=-1
    end if 
    if (present(jwind)) then
      jt=jwind
    else
      jt=-1
    end if 
    if (present(nwind)) then
      nt=nwind
    else
      nt=-1
    end if 
    if (.not. fix1(struct%n(1),ft,jt,nt)) then
      write(0,*) "trouble fixing axis 1"
      return
    end if
    struct%nwind(1)=nt
    struct%fwind(1)=ft
    struct%jwind(1)=jt
    if (present(local_tag)) then
      my_local=local_tag
    else if (sep_num_thread()>1) then
      my_local=.false.
    else
      my_local=.true.
    end if 
    if (.not. valid_structure(struct)) then
      call erexit("structure has not been initialized")
    end if
    if (struct%data_format .ne. "FLOAT") then
      call erexit("data type is not float")
    end if
    if (struct%nsect >1) then
      if (0.ne.sep3d_read_data_local(struct%tag,nt,ft,jt,data)) then
        call erexit("trouble reading data")
      end if
    else
      if (sep_num_thread()>1) then
        if (sep_thread_num().eq.0 .or. my_local) then
          if (size(data) < product(struct%nwind) .and. struct%file_format&
            &(1:1).ne."G") then
            write(0,*) sep_thread_num(),"=thread Window size greater&
              & than buffer size",product(struct%nwind),size(data)
            call seperr("read request beyond buffer size")
          end if
          if (0.ne.sep3d_reed_data(tag,struct%tag,nt,ft,jt,data)) then
            call erexit("trouble reading data")
          end if
        end if
        if (.not. my_local) then
          if (nthread>1) then
            if (0.ne.sep3d_broadcast_data(struct%tag,0,4,size(Data),data&
              &)) then
              call erexit("trouble broadcastting  data")
            end if
          end if
        end if
      else
!not mpi or sectioned
        if (size(data) < product(struct%nwind) .and. struct%file_format&
          &(1:1).ne."G") then
          write(0,*) sep_thread_num(),"=thread Window size greater than&
            & buffer size",product(struct%nwind),size(data)
          call seperr("read request beyond buffer size")
        end if
        if (0.ne.sep3d_reed_data(tag,struct%tag,nt,ft,jt,data)) then
          call erexit("trouble reading data")
        end if
      end if
    end if 
    get_data_4f=.true.
!deallocate(trnum)
  end function 
  logical function  get_data_4c(tag,struct,data,nwind,fwind,jwind,local_tag&
    &)
    character(len=*) :: tag
    type(sep3d) :: struct
    complex,dimension(:,:,:,:) :: data
    integer ::drn,ierr
    integer, dimension(:), allocatable ::trnum
    integer, optional :: fwind,jwind,nwind
    integer :: ft,nt,jt,nh,nthread
    logical, optional :: local_tag
    logical :: my_local
    if (present(local_tag)) then
      my_local=local_tag
    else if (struct%nmpi>1) then
      my_local=.false.
    else
      my_local=.true.
    end if 
    nthread= sep_num_thread()
    if (present(fwind)) then
      ft=fwind
    else
      ft=-1
    end if 
    if (present(jwind)) then
      jt=jwind
    else
      jt=-1
    end if 
    if (present(nwind)) then
      nt=nwind
    else
      nt=-1
    end if 
    if (.not.  fix1(struct%n(1),ft,jt,nt)) then
      write(0,*) "axis 1 problem"
    end if
    struct%nwind(1)=nt
    struct%fwind(1)=ft
    struct%jwind(1)=jt
    if (.not. valid_structure(struct)) then
      call erexit("structure has not been initialized")
    end if
    if (struct%data_format .ne. "COMPLEX") then
      call erexit("data type is not complex")
    end if
    if (struct%nsect >1) then
! read only local
      if (0.ne.sep3d_read_data_local(struct%tag,nt,ft,jt,data)) then
        call erexit("trouble reading headers")
      end if
    else
      if (struct%nmpi>1) then
        if (struct%impi.eq.0 .or. my_local) then
          if (size(data) < product(struct%nwind) .and. struct%file_format&
            &(1:1).ne."G") then
            write(0,*) sep_thread_num(),"=thread Window size greater&
              & than buffer size",product(struct%nwind),size(data)
            call seperr("read request beyond buffer size")
          end if
          if (0.ne.sep3d_reed_data(tag,struct%tag,nt,ft,jt,nh)) then
            call erexit("trouble reading data")
          end if
        end if
        if (.not. my_local) then
          if (nthread>1) then
            if (0.ne.sep3d_broadcast_data(struct%tag,0,1,size(Data),data&
              &)) then
              call erexit("trouble broadcasting  data")
            end if
          end if
        end if
      else
!not mpi or sectioned
        if (size(data) < product(struct%nwind) .and. struct%file_format&
          &(1:1).ne."G") then
          write(0,*) sep_thread_num(),"=thread Window size greater than&
            & buffer size",product(struct%nwind),size(data)
          call seperr("read request beyond buffer size")
        end if
        if (0.ne.sep3d_reed_data(tag,struct%tag,nt,ft,jt,data)) then
          call erexit("trouble reading data")
        end if
      end if
    end if 
    get_data_4c=.true.
!deallocate(trnum)
  end function 
  logical function  get_data_4i(tag,struct,data,nwind,fwind,jwind,local_tag&
    &)
    character(len=*) :: tag
    type(sep3d) :: struct
    integer,dimension(:,:,:,:) :: data
    integer ::drn,ierr
    integer, dimension(:), allocatable ::trnum
    integer, optional :: fwind,jwind,nwind
    integer :: ft,nt,jt,nh,nthread
    logical, optional :: local_tag
    logical :: my_local
    nthread= sep_num_thread()
    get_data_4i=.false.
    if (present(local_tag)) then
      my_local=local_tag
    else if (struct%nmpi>1) then
      my_local=.false.
    else
      my_local=.true.
    end if 
    if (present(fwind)) then
      ft=fwind
    else
      ft=-1
    end if 
    if (present(jwind)) then
      jt=jwind
    else
      jt=-1
    end if 
    if (present(nwind)) then
      nt=nwind
    else
      nt=-1
    end if 
    if (.not. fix1(struct%n(1),ft,jt,nt)) then
      write(0,*) "axis 1 problem"
      return
    end if
    struct%nwind(1)=nt
    struct%fwind(1)=ft
    struct%jwind(1)=jt
    if (.not. valid_structure(struct)) then
      call erexit("structure has not been initialized")
    end if
    if (struct%data_format .ne. "INTEGER") then
      call erexit("data type is integer")
    end if
    if (struct%nsect >1) then
      if (0.ne.sep3d_read_data_local(struct%tag,nt,ft,jt,data)) then
        call erexit("trouble reading headers")
      end if
    else
      if (struct%nmpi>1) then
        if (struct%impi.eq.0 .or. my_local) then
          if (size(data) < product(struct%nwind) .and. struct%file_format&
            &(1:1).ne."G") then
            write(0,*) sep_thread_num(),"=thread Window size greater&
              & than buffer size",product(struct%nwind),size(data)
            call seperr("read request beyond buffer size")
          end if
          if (0.ne.sep3d_reed_data(tag,struct%tag,nt,ft,jt,nh)) then
            call erexit("trouble reading data")
          end if
        end if
        if (.not. my_local) then
          if (nthread>1) then
            if (0.ne.sep3d_broadcast_data(struct%tag,0,4,size(Data),data&
              &)) then
              call erexit("trouble broadcasting  data")
            end if
          end if
        end if
      else
!not mpi or sectioned
        if (size(data) < product(struct%nwind) .and. struct%file_format&
          &(1:1).ne."G") then
          write(0,*) sep_thread_num(),"=thread Window size greater than&
            & buffer size",product(struct%nwind),size(data)
          call seperr("read request beyond buffer size")
        end if
        if (0.ne.sep3d_reed_data(tag,struct%tag,nt,ft,jt,data)) then
          call erexit("trouble reading data")
        end if
      end if
    end if 
    get_data_4i=.true.
  end function 
  logical function  get_data_2f(tag,struct,data,nwind,fwind,jwind,local_tag&
    &)
    character(len=*) :: tag
    type(sep3d) :: struct
    real,dimension(:,:) :: data
    integer ::drn,ierr
    integer, dimension(:), allocatable ::trnum
    integer, optional :: fwind,jwind,nwind
    integer :: ft,nt,jt,nh
    logical, optional :: local_tag
    logical :: my_local
    integer :: nthread
    nthread= sep_num_thread()
    if (present(fwind)) then
      ft=fwind
    else
      ft=-1
    end if 
    if (present(jwind)) then
      jt=jwind
    else
      jt=-1
    end if 
    if (present(nwind)) then
      nt=nwind
    else
      nt=-1
    end if 
    if (.not. fix1(struct%n(1),ft,jt,nt)) then
      write(0,*) "trouble fixing axis 1"
      return
    end if
    if (present(local_tag)) then
      my_local=local_tag
    else if (sep_num_thread()>1) then
      my_local=.false.
    else
      my_local=.true.
    end if 
    struct%nwind(1)=nt
    struct%fwind(1)=ft
    struct%jwind(1)=jt
    if (.not. valid_structure(struct)) then
      call erexit("structure has not been initialized")
    end if
    if (struct%data_format .ne. "FLOAT") then
      call erexit("data type is not float")
    end if
    if (struct%nsect >1) then
      if (0.ne.sep3d_read_data_local(struct%tag,nt,ft,jt,data)) then
        call erexit("trouble reading data")
      end if
    else
      if (sep_num_thread()>1) then
        if (sep_thread_num().eq.0 .or. my_local) then
          if (size(data) < product(struct%nwind) .and. struct%file_format&
            &(1:1).ne."G") then
            write(0,*) sep_thread_num(),"=thread Window size greater&
              & than buffer size",product(struct%nwind),size(data)
            call seperr("read request beyond buffer size")
          end if
          if (0.ne.sep3d_reed_data(tag,struct%tag,nt,ft,jt,data)) then
            call erexit("trouble reading data")
          end if
        end if
        if (.not. my_local) then
          if (nthread>1) then
            if (0.ne.sep3d_broadcast_data(struct%tag,0,4,size(Data),data&
              &)) then
              call erexit("trouble broadcastting  data")
            end if
          end if
        end if
      else
!not mpi or sectioned
        if (size(data) < product(struct%nwind) .and. struct%file_format&
          &(1:1).ne."G") then
          write(0,*) sep_thread_num(),"=thread Window size greater than&
            & buffer size",product(struct%nwind),size(data)
          call seperr("read request beyond buffer size")
        end if
        if (0.ne.sep3d_reed_data(tag,struct%tag,nt,ft,jt,data)) then
          call erexit("trouble reading data")
        end if
      end if
    end if 
    get_data_2f=.true.
!deallocate(trnum)
  end function 
  logical function  get_data_2c(tag,struct,data,nwind,fwind,jwind,local_tag&
    &)
    character(len=*) :: tag
    type(sep3d) :: struct
    complex,dimension(:,:) :: data
    integer ::drn,ierr
    integer, dimension(:), allocatable ::trnum
    integer, optional :: fwind,jwind,nwind
    integer :: ft,nt,jt,nh,nthread
    logical, optional :: local_tag
    logical :: my_local
    if (present(local_tag)) then
      my_local=local_tag
    else if (struct%nmpi>1) then
      my_local=.false.
    else
      my_local=.true.
    end if 
    nthread= sep_num_thread()
    if (present(fwind)) then
      ft=fwind
    else
      ft=-1
    end if 
    if (present(jwind)) then
      jt=jwind
    else
      jt=-1
    end if 
    if (present(nwind)) then
      nt=nwind
    else
      nt=-1
    end if 
    if (.not.  fix1(struct%n(1),ft,jt,nt)) then
      write(0,*) "axis 1 problem"
    end if
    struct%nwind(1)=nt
    struct%fwind(1)=ft
    struct%jwind(1)=jt
    if (.not. valid_structure(struct)) then
      call erexit("structure has not been initialized")
    end if
    if (struct%data_format .ne. "COMPLEX") then
      call erexit("data type is not complex")
    end if
    if (struct%nsect >1) then
! read only local
      if (0.ne.sep3d_read_data_local(struct%tag,nt,ft,jt,data)) then
        call erexit("trouble reading headers")
      end if
    else
      if (struct%nmpi>1) then
        if (struct%impi.eq.0 .or. my_local) then
          if (size(data) < product(struct%nwind) .and. struct%file_format&
            &(1:1).ne."G") then
            write(0,*) sep_thread_num(),"=thread Window size greater&
              & than buffer size",product(struct%nwind),size(data)
            call seperr("read request beyond buffer size")
          end if
          if (0.ne.sep3d_reed_data(tag,struct%tag,nt,ft,jt,nh)) then
            call erexit("trouble reading data")
          end if
        end if
        if (.not. my_local) then
          if (nthread>1) then
            if (0.ne.sep3d_broadcast_data(struct%tag,0,1,size(Data),data&
              &)) then
              call erexit("trouble broadcasting  data")
            end if
          end if
        end if
      else
!not mpi or sectioned
        if (size(data) < product(struct%nwind) .and. struct%file_format&
          &(1:1).ne."G") then
          write(0,*) sep_thread_num(),"=thread Window size greater than&
            & buffer size",product(struct%nwind),size(data)
          call seperr("read request beyond buffer size")
        end if
        if (0.ne.sep3d_reed_data(tag,struct%tag,nt,ft,jt,data)) then
          call erexit("trouble reading data")
        end if
      end if
    end if 
    get_data_2c=.true.
!deallocate(trnum)
  end function 
  logical function  get_data_2i(tag,struct,data,nwind,fwind,jwind,local_tag&
    &)
    character(len=*) :: tag
    type(sep3d) :: struct
    integer,dimension(:,:) :: data
    integer ::drn,ierr
    integer, dimension(:), allocatable ::trnum
    integer, optional :: fwind,jwind,nwind
    integer :: ft,nt,jt,nh,nthread
    logical, optional :: local_tag
    logical :: my_local
    nthread= sep_num_thread()
    get_data_2i=.false.
    if (present(local_tag)) then
      my_local=local_tag
    else if (struct%nmpi>1) then
      my_local=.false.
    else
      my_local=.true.
    end if 
    if (present(fwind)) then
      ft=fwind
    else
      ft=-1
    end if 
    if (present(jwind)) then
      jt=jwind
    else
      jt=-1
    end if 
    if (present(nwind)) then
      nt=nwind
    else
      nt=-1
    end if 
    if (.not. fix1(struct%n(1),ft,jt,nt)) then
      write(0,*) "axis 1 problem"
      return
    end if
    struct%nwind(1)=nt
    struct%fwind(1)=ft
    struct%jwind(1)=jt
    if (.not. valid_structure(struct)) then
      call erexit("structure has not been initialized")
    end if
    if (struct%data_format .ne. "INTEGER") then
      call erexit("data type is integer")
    end if
    if (struct%nsect >1) then
      if (0.ne.sep3d_read_data_local(struct%tag,nt,ft,jt,data)) then
        call erexit("trouble reading headers")
      end if
    else
      if (struct%nmpi>1) then
        if (struct%impi.eq.0 .or. my_local) then
          if (size(data) < product(struct%nwind) .and. struct%file_format&
            &(1:1).ne."G") then
            write(0,*) sep_thread_num(),"=thread Window size greater&
              & than buffer size",product(struct%nwind),size(data)
            call seperr("read request beyond buffer size")
          end if
          if (0.ne.sep3d_reed_data(tag,struct%tag,nt,ft,jt,nh)) then
            call erexit("trouble reading data")
          end if
        end if
        if (.not. my_local) then
          if (nthread>1) then
            if (0.ne.sep3d_broadcast_data(struct%tag,0,4,size(Data),data&
              &)) then
              call erexit("trouble broadcasting  data")
            end if
          end if
        end if
      else
!not mpi or sectioned
        if (size(data) < product(struct%nwind) .and. struct%file_format&
          &(1:1).ne."G") then
          write(0,*) sep_thread_num(),"=thread Window size greater than&
            & buffer size",product(struct%nwind),size(data)
          call seperr("read request beyond buffer size")
        end if
        if (0.ne.sep3d_reed_data(tag,struct%tag,nt,ft,jt,data)) then
          call erexit("trouble reading data")
        end if
      end if
    end if 
    get_data_2i=.true.
  end function 
! fix_window
! Usage
! fix_window(n_data,fwind,jwind,nwind)
! Input Parameter# n_data - integer(:) array describing the extent of the dataset
! fwind - integer(:) array of minimum values# jwind - integer(:) array of skip values
! nwind - integer(:) array of number of values tor read#
! Description
!
! Routine that checks if window params are valid.  By passing -1 it
! will also do the right thing in calculating reasonable values for# these parameters
!
! Category
! Base library - utility
!
  logical function fix1(n_data,f,j,n)
    integer,intent(in) :: n_data
    integer,intent(inout) ::  f,j,n
    fix1=.false.
    if (n_data <= f) then
      write(0,*) n_data,"=ndata f=",f
      write(0,*) "utils:invalid f parameter  "
      return
    end if
    if (n_data < n) then
      write(0,*) n_data,"=ndata n=",n
      write(0,*) "utils:invalid n parameter"
      return
    end if
    if (j .eq. -1) then
      j=1
    end if
    if (n .eq. -1) then
      if (f .eq. -1) then
        f=0
      end if
      n= (n_data-1-f)/j +1
!else if (f==-1) f=(n-1)/j +1
    else if (f.eq.-1) then
      f=0
    end if
    if (n_data < (1 + f + j * (n -1))) then
      write(0,*) "utils:invalid window parameters"
      return
    end if
    fix1=.true.
  end function 
  subroutine fix_vector(n_data,f,j,n)
    integer,dimension(:),intent(in)  ::  n_data
    integer,dimension(:),intent(inout)  ::  f,j,n
    integer  :: i1
    if (size(n_data) .ne.size(f) .or.  size(f) .ne. size(j) .or.  size&
      &(j) .ne. size(n)) then
      call erexit("utils:incompatible fix window vector lengths")
    end if
    do i1=1,size(n)
      if (.not. fix1(n_data(i1),f(i1),j(i1),n(i1))) then
        write(0,*) "trouble with axis ",i1," parameters"
        call erexit("")
      end if
    end do
  end subroutine 
  logical function put_data_4i(tag,struct,data,nwind,fwind,jwind&
    &,write_headers,write_grid,local_tag)
    integer, dimension(:,:,:,:),target :: data
    integer, pointer      :: tempp(:,:,:,:)
    character(len=*) :: tag
    type(sep3d)      :: struct
    integer,optional :: nwind(:),fwind(:),jwind(:)
    integer,allocatable,dimension(:) :: nt(:),ft(:),jt(:)
    logical, optional :: write_headers,write_grid
    logical, optional :: local_tag
    logical :: my_local
    integer           :: n
    integer,target    :: gt(1)
    integer :: gp
    integer           :: wd,wg,wh,ntm,nh,ierr,esize,ng
    esize=4
    tempp=>data
    wd=1
    gp=size(data)/size(data,1)
    if (present(local_tag)) then
      my_local=local_tag
    else if (struct%nmpi>1) then
      my_local=.false.
    else
      my_local=.true.
    end if 
    if (.not. valid_structure(struct)) then
      call erexit("not a valid sep structure\n")
    end if
!if(struct%usage=="INPUT") call erexit("can not write out input struct \n");
    n=struct%ndims
    allocate(nt(n),ft(n),jt(n))
    if (present(nwind)) then
      nt=nwind
    else
      nt=-1
    end if 
    if (present(fwind)) then
      ft=fwind
    else
      ft=-1
    end if 
    if (present(jwind)) then
      jt=jwind
    else
      jt=-1
    end if 
    if (present(write_grid)) then
      if (struct%file_format.ne."GRID" .and. write_grid) then
        call erexit("can not write grid when file_format not grid \n")
      end if
      if (write_grid) then
        wg=1
      else
        wg=0
      end if
    else
      if (struct%file_format.ne."GRID") then
        wg=0
      else
        wg=1
      end if
    end if 
    ierr=sep3d_grab_nh(struct%tag,nh)
    if (present(write_headers)) then
      if (struct%file_format.eq."REGULAR" .and. write_headers) then
        call erexit("file_format set to regular can not write out headers&
          & \n")
      end if
      if (write_headers) then
        wh=1
      else
        wh=0
      end if
    else
      ierr=sep3d_grab_nh(struct%tag,nh)
      if (nh.eq.0) then
        wh=0
      else
        wh=1
      end if
    end if 
    if (wd.eq.1 .and. wh.eq.1) then
      ntm=size(tempp,2)
      if (wh .eq. 1 .and. ntm < nh) then
        write(0,*) "number of traces",ntm,"number of headers",nh
        call erexit("f90rite:number of traces not equal to the number&
          & of traces being  stored\n")
      end if
    end if
    call fix_vector(struct%n,ft,jt,nt)
    if (wd.eq.1 .and. struct%file_format(1:1).ne."G") then
      if (size(tempp)<product(nwind)) then
        write(0,*) sep_thread_num(),"=thread window size=",product(nwind&
          &)," buffer size=",size(tempp)
        call seperr("window size > buffer size")
      end if
    end if
!if(wg==1 || wh==1){
    if (struct%nsect >1) then
      if (0.ne.sep3d_rite_local(trim(tag),trim(struct%tag), nt,ft,jt&
        &,tempp, gp,wd,wh,wg)) then
        call erexit("trouble writing out the data \n")
      end if
    else
      if (struct%impi.eq.0  .or. struct%nmpi.eq.1 .or. my_local) then
        if (0.ne.sep3d_rite(tag,struct%tag, nt,ft,jt,tempp, gp,wd,wh,wg&
          &)) then
          call erexit("trouble writing out the data \n")
        end if
      end if
    end if 
!}else if(wd==1){
!        if(size(tempp)*esize!= srite(tag,tempp,size(tempp)*esize))
!                call erexit("trouble writing out the data \n")
!}
!else call erexit("you didn't specify anything to write \n")
    deallocate(nt,ft,jt)
    put_data_4i=.true.
  end function 
  logical function put_data_4f(tag,struct,data,nwind,fwind,jwind&
    &,write_headers,write_grid,local_tag)
    real, dimension(:,:,:,:),target:: data
    real, dimension(1) :: tempd
    real, pointer      :: tempp(:,:,:,:)
    character(len=*) :: tag
    type(sep3d)      :: struct
    integer,optional :: nwind(:),fwind(:),jwind(:)
    integer,allocatable,dimension(:) :: nt(:),ft(:),jt(:)
    logical, optional :: write_headers,write_grid
    integer           :: n
    integer, target   :: gt(1)
    integer  :: gp
    integer           :: wd,wg,wh,ntm,nh,ierr,esize,ng
    logical, optional :: local_tag
    logical :: my_local
    esize=4
    tempp=>data
    wd=1
    gp=size(data)/size(data,1)
    if (present(local_tag)) then
      my_local=local_tag
    else if (struct%nmpi>1) then
      my_local=.false.
    else
      my_local=.true.
    end if 
    if (.not. valid_structure(struct)) then
      call erexit("not a valid sep structure\n")
    end if
!if(struct%usage=="INPUT") call erexit("can not write out input struct \n");
    n=struct%ndims
    allocate(nt(n),ft(n),jt(n))
    if (present(nwind)) then
      nt=nwind
    else
      nt=-1
    end if 
    if (present(fwind)) then
      ft=fwind
    else
      ft=-1
    end if 
    if (present(jwind)) then
      jt=jwind
    else
      jt=-1
    end if 
    if (present(write_grid)) then
      if (struct%file_format.ne."GRID" .and. write_grid) then
        call erexit("can not write grid when file_format not grid \n")
      end if
      if (write_grid) then
        wg=1
      else
        wg=0
      end if
    else
      if (struct%file_format.ne."GRID") then
        wg=0
      else
        wg=1
      end if
    end if 
    ierr=sep3d_grab_nh(struct%tag,nh)
    if (present(write_headers)) then
      if (struct%file_format.eq."REGULAR" .and. write_headers) then
        call erexit("file_format set to regular can not write out headers&
          & \n")
      end if
      if (write_headers) then
        wh=1
      else
        wh=0
      end if
    else
      ierr=sep3d_grab_nh(struct%tag,nh)
      if (nh.eq.0) then
        wh=0
      else
        wh=1
      end if
    end if 
    if (wd.eq.1 .and. wh.eq.1) then
      ntm=size(tempp,2)
      if (wh .eq. 1 .and. ntm < nh) then
        write(0,*) "number of traces",ntm,"number of headers",nh
        call erexit("f90rite:number of traces not equal to the number&
          & of traces being  stored\n")
      end if
    end if
    call fix_vector(struct%n,ft,jt,nt)
    if (wd.eq.1 .and. struct%file_format(1:1).ne."G") then
      if (size(tempp)<product(nwind)) then
        write(0,*) sep_thread_num(),"=thread window size=",product(nwind&
          &)," buffer size=",size(tempp)
        call seperr("window size > buffer size")
      end if
    end if
!if(wg==1 || wh==1){
    if (struct%nsect >1) then
      if (0.ne.sep3d_rite_local(trim(tag),trim(struct%tag), nt,ft,jt&
        &,tempp, gp,wd,wh,wg)) then
        call erexit("trouble writing out the data \n")
      end if
    else
      if (struct%impi.eq.0  .or. struct%nmpi.eq.1 .or. my_local) then
        if (0.ne.sep3d_rite(tag,struct%tag, nt,ft,jt,tempp, gp,wd,wh,wg&
          &)) then
          call erexit("trouble writing out the data \n")
        end if
      end if
    end if 
!}else if(wd==1){
!        if(size(tempp)*esize!= srite(tag,tempp,size(tempp)*esize))
!                call erexit("trouble writing out the data \n")
!}
!else call erexit("you didn't specify anything to write \n")
    deallocate(nt,ft,jt)
    put_data_4f=.true.
  end function 
  logical function put_data_4c(tag,struct,data,nwind,fwind,jwind&
    &,write_headers,write_grid,local_tag)
    complex, dimension(:,:,:,:),target :: data
    complex, dimension(1) :: tempd
    complex, pointer      :: tempp(:,:,:,:)
    character(len=*) :: tag
    type(sep3d)      :: struct
    integer,optional :: nwind(:),fwind(:),jwind(:)
    integer,allocatable,dimension(:) :: nt(:),ft(:),jt(:)
    logical, optional :: write_headers,write_grid
    integer           :: n
    integer,target    :: gt(1)
    integer           :: gp
    integer           :: wd,wg,wh,ntm,nh,ierr,esize,ng
    logical, optional :: local_tag
    logical :: my_local
    gp=size(data)/size(data,1)
    tempp=>data
    esize=8
    wd=1
    if (present(local_tag)) then
      my_local=local_tag
    else if (struct%nmpi>1) then
      my_local=.false.
    else
      my_local=.true.
    end if 
    if (.not. valid_structure(struct)) then
      call erexit("not a valid sep structure\n")
    end if
!if(struct%usage=="INPUT") call erexit("can not write out input struct \n");
    n=struct%ndims
    allocate(nt(n),ft(n),jt(n))
    if (present(nwind)) then
      nt=nwind
    else
      nt=-1
    end if 
    if (present(fwind)) then
      ft=fwind
    else
      ft=-1
    end if 
    if (present(jwind)) then
      jt=jwind
    else
      jt=-1
    end if 
    if (present(write_grid)) then
      if (struct%file_format.ne."GRID" .and. write_grid) then
        call erexit("can not write grid when file_format not grid \n")
      end if
      if (write_grid) then
        wg=1
      else
        wg=0
      end if
    else
      if (struct%file_format.ne."GRID") then
        wg=0
      else
        wg=1
      end if
    end if 
    ierr=sep3d_grab_nh(struct%tag,nh)
    if (present(write_headers)) then
      if (struct%file_format.eq."REGULAR" .and. write_headers) then
        call erexit("file_format set to regular can not write out headers&
          & \n")
      end if
      if (write_headers) then
        wh=1
      else
        wh=0
      end if
    else
      ierr=sep3d_grab_nh(struct%tag,nh)
      if (nh.eq.0) then
        wh=0
      else
        wh=1
      end if
    end if 
    if (wd.eq.1 .and. wh.eq.1) then
      ntm=size(tempp,2)
      if (wh .eq. 1 .and. ntm < nh) then
        write(0,*) "number of traces",ntm,"number of headers",nh
        call erexit("f90rite:number of traces not equal to the number&
          & of traces being  stored\n")
      end if
    end if
    call fix_vector(struct%n,ft,jt,nt)
    if (wd.eq.1 .and. struct%file_format(1:1).ne."G") then
      if (size(tempp)<product(nwind)) then
        write(0,*) sep_thread_num(),"=thread window size=",product(nwind&
          &)," buffer size=",size(tempp)
        call seperr("window size > buffer size")
      end if
    end if
!if(wg==1 || wh==1){
    if (struct%nsect >1) then
      if (0.ne.sep3d_rite_local(trim(tag),trim(struct%tag), nt,ft,jt&
        &,tempp, gp,wd,wh,wg)) then
        call erexit("trouble writing out the data \n")
      end if
    else
      if (struct%impi.eq.0  .or. struct%nmpi.eq.1 .or. my_local) then
        if (0.ne.sep3d_rite(tag,struct%tag, nt,ft,jt,tempp, gp,wd,wh,wg&
          &)) then
          call erexit("trouble writing out the data \n")
        end if
      end if
    end if 
!}else if(wd==1){
!        if(size(tempp)*esize!= srite(tag,tempp,size(tempp)*esize))
!                call erexit("trouble writing out the data \n")
!}
!else call erexit("you didn't specify anything to write \n")
    deallocate(nt,ft,jt)
    put_data_4c=.true.
  end function 
  logical function put_data_3i(tag,struct,data,nwind,fwind,jwind&
    &,write_headers,write_grid,local_tag)
    integer, dimension(:,:,:),target :: data
    integer, pointer      :: tempp(:,:,:)
    character(len=*) :: tag
    type(sep3d)      :: struct
    integer,optional :: nwind(:),fwind(:),jwind(:)
    integer,allocatable,dimension(:) :: nt(:),ft(:),jt(:)
    logical, optional :: write_headers,write_grid
    logical, optional :: local_tag
    logical :: my_local
    integer           :: n
    integer,target    :: gt(1)
    integer :: gp
    integer           :: wd,wg,wh,ntm,nh,ierr,esize,ng
    esize=4
    tempp=>data
    wd=1
    gp=size(data)/size(data,1)
    if (present(local_tag)) then
      my_local=local_tag
    else if (struct%nmpi>1) then
      my_local=.false.
    else
      my_local=.true.
    end if 
    if (.not. valid_structure(struct)) then
      call erexit("not a valid sep structure\n")
    end if
!if(struct%usage=="INPUT") call erexit("can not write out input struct \n");
    n=struct%ndims
    allocate(nt(n),ft(n),jt(n))
    if (present(nwind)) then
      nt=nwind
    else
      nt=-1
    end if 
    if (present(fwind)) then
      ft=fwind
    else
      ft=-1
    end if 
    if (present(jwind)) then
      jt=jwind
    else
      jt=-1
    end if 
    if (present(write_grid)) then
      if (struct%file_format.ne."GRID" .and. write_grid) then
        call erexit("can not write grid when file_format not grid \n")
      end if
      if (write_grid) then
        wg=1
      else
        wg=0
      end if
    else
      if (struct%file_format.ne."GRID") then
        wg=0
      else
        wg=1
      end if
    end if 
    ierr=sep3d_grab_nh(struct%tag,nh)
    if (present(write_headers)) then
      if (struct%file_format.eq."REGULAR" .and. write_headers) then
        call erexit("file_format set to regular can not write out headers&
          & \n")
      end if
      if (write_headers) then
        wh=1
      else
        wh=0
      end if
    else
      ierr=sep3d_grab_nh(struct%tag,nh)
      if (nh.eq.0) then
        wh=0
      else
        wh=1
      end if
    end if 
    if (wd.eq.1 .and. wh.eq.1) then
      ntm=size(tempp,2)
      if (wh .eq. 1 .and. ntm < nh) then
        write(0,*) "number of traces",ntm,"number of headers",nh
        call erexit("f90rite:number of traces not equal to the number&
          & of traces being  stored\n")
      end if
    end if
    call fix_vector(struct%n,ft,jt,nt)
    if (wd.eq.1 .and. struct%file_format(1:1).ne."G") then
      if (size(tempp)<product(nwind)) then
        write(0,*) sep_thread_num(),"=thread window size=",product(nwind&
          &)," buffer size=",size(tempp)
        call seperr("window size > buffer size")
      end if
    end if
!if(wg==1 || wh==1){
    if (struct%nsect >1) then
      if (0.ne.sep3d_rite_local(trim(tag),trim(struct%tag), nt,ft,jt&
        &,tempp, gp,wd,wh,wg)) then
        call erexit("trouble writing out the data \n")
      end if
    else
      if (struct%impi.eq.0  .or. struct%nmpi.eq.1 .or. my_local) then
        if (0.ne.sep3d_rite(tag,struct%tag, nt,ft,jt,tempp, gp,wd,wh,wg&
          &)) then
          call erexit("trouble writing out the data \n")
        end if
      end if
    end if 
!}else if(wd==1){
!        if(size(tempp)*esize!= srite(tag,tempp,size(tempp)*esize))
!                call erexit("trouble writing out the data \n")
!}
!else call erexit("you didn't specify anything to write \n")
    deallocate(nt,ft,jt)
    put_data_3i=.true.
  end function 
  logical function put_data_3f(tag,struct,data,nwind,fwind,jwind&
    &,write_headers,write_grid,local_tag)
    real, dimension(:,:,:),target:: data
    real, dimension(1) :: tempd
    real, pointer      :: tempp(:,:,:)
    character(len=*) :: tag
    type(sep3d)      :: struct
    integer,optional :: nwind(:),fwind(:),jwind(:)
    integer,allocatable,dimension(:) :: nt(:),ft(:),jt(:)
    logical, optional :: write_headers,write_grid
    integer           :: n
    integer, target   :: gt(1)
    integer  :: gp
    integer           :: wd,wg,wh,ntm,nh,ierr,esize,ng
    logical, optional :: local_tag
    logical :: my_local
    esize=4
    tempp=>data
    wd=1
    gp=size(data)/size(data,1)
    if (present(local_tag)) then
      my_local=local_tag
    else if (struct%nmpi>1) then
      my_local=.false.
    else
      my_local=.true.
    end if 
    if (.not. valid_structure(struct)) then
      call erexit("not a valid sep structure\n")
    end if
!if(struct%usage=="INPUT") call erexit("can not write out input struct \n");
    n=struct%ndims
    allocate(nt(n),ft(n),jt(n))
    if (present(nwind)) then
      nt=nwind
    else
      nt=-1
    end if 
    if (present(fwind)) then
      ft=fwind
    else
      ft=-1
    end if 
    if (present(jwind)) then
      jt=jwind
    else
      jt=-1
    end if 
    if (present(write_grid)) then
      if (struct%file_format.ne."GRID" .and. write_grid) then
        call erexit("can not write grid when file_format not grid \n")
      end if
      if (write_grid) then
        wg=1
      else
        wg=0
      end if
    else
      if (struct%file_format.ne."GRID") then
        wg=0
      else
        wg=1
      end if
    end if 
    ierr=sep3d_grab_nh(struct%tag,nh)
    if (present(write_headers)) then
      if (struct%file_format.eq."REGULAR" .and. write_headers) then
        call erexit("file_format set to regular can not write out headers&
          & \n")
      end if
      if (write_headers) then
        wh=1
      else
        wh=0
      end if
    else
      ierr=sep3d_grab_nh(struct%tag,nh)
      if (nh.eq.0) then
        wh=0
      else
        wh=1
      end if
    end if 
    if (wd.eq.1 .and. wh.eq.1) then
      ntm=size(tempp,2)
      if (wh .eq. 1 .and. ntm < nh) then
        write(0,*) "number of traces",ntm,"number of headers",nh
        call erexit("f90rite:number of traces not equal to the number&
          & of traces being  stored\n")
      end if
    end if
    call fix_vector(struct%n,ft,jt,nt)
    if (wd.eq.1 .and. struct%file_format(1:1).ne."G") then
      if (size(tempp)<product(nwind)) then
        write(0,*) sep_thread_num(),"=thread window size=",product(nwind&
          &)," buffer size=",size(tempp)
        call seperr("window size > buffer size")
      end if
    end if
!if(wg==1 || wh==1){
    if (struct%nsect >1) then
      if (0.ne.sep3d_rite_local(trim(tag),trim(struct%tag), nt,ft,jt&
        &,tempp, gp,wd,wh,wg)) then
        call erexit("trouble writing out the data \n")
      end if
    else
      if (struct%impi.eq.0  .or. struct%nmpi.eq.1 .or. my_local) then
        if (0.ne.sep3d_rite(tag,struct%tag, nt,ft,jt,tempp, gp,wd,wh,wg&
          &)) then
          call erexit("trouble writing out the data \n")
        end if
      end if
    end if 
!}else if(wd==1){
!        if(size(tempp)*esize!= srite(tag,tempp,size(tempp)*esize))
!                call erexit("trouble writing out the data \n")
!}
!else call erexit("you didn't specify anything to write \n")
    deallocate(nt,ft,jt)
    put_data_3f=.true.
  end function 
  logical function put_data_3c(tag,struct,data,nwind,fwind,jwind&
    &,write_headers,write_grid,local_tag)
    complex, dimension(:,:,:),target :: data
    complex, dimension(1) :: tempd
    complex, pointer      :: tempp(:,:,:)
    character(len=*) :: tag
    type(sep3d)      :: struct
    integer,optional :: nwind(:),fwind(:),jwind(:)
    integer,allocatable,dimension(:) :: nt(:),ft(:),jt(:)
    logical, optional :: write_headers,write_grid
    integer           :: n
    integer,target    :: gt(1)
    integer           :: gp
    integer           :: wd,wg,wh,ntm,nh,ierr,esize,ng
    logical, optional :: local_tag
    logical :: my_local
    gp=size(data)/size(data,1)
    tempp=>data
    esize=8
    wd=1
    if (present(local_tag)) then
      my_local=local_tag
    else if (struct%nmpi>1) then
      my_local=.false.
    else
      my_local=.true.
    end if 
    if (.not. valid_structure(struct)) then
      call erexit("not a valid sep structure\n")
    end if
!if(struct%usage=="INPUT") call erexit("can not write out input struct \n");
    n=struct%ndims
    allocate(nt(n),ft(n),jt(n))
    if (present(nwind)) then
      nt=nwind
    else
      nt=-1
    end if 
    if (present(fwind)) then
      ft=fwind
    else
      ft=-1
    end if 
    if (present(jwind)) then
      jt=jwind
    else
      jt=-1
    end if 
    if (present(write_grid)) then
      if (struct%file_format.ne."GRID" .and. write_grid) then
        call erexit("can not write grid when file_format not grid \n")
      end if
      if (write_grid) then
        wg=1
      else
        wg=0
      end if
    else
      if (struct%file_format.ne."GRID") then
        wg=0
      else
        wg=1
      end if
    end if 
    ierr=sep3d_grab_nh(struct%tag,nh)
    if (present(write_headers)) then
      if (struct%file_format.eq."REGULAR" .and. write_headers) then
        call erexit("file_format set to regular can not write out headers&
          & \n")
      end if
      if (write_headers) then
        wh=1
      else
        wh=0
      end if
    else
      ierr=sep3d_grab_nh(struct%tag,nh)
      if (nh.eq.0) then
        wh=0
      else
        wh=1
      end if
    end if 
    if (wd.eq.1 .and. wh.eq.1) then
      ntm=size(tempp,2)
      if (wh .eq. 1 .and. ntm < nh) then
        write(0,*) "number of traces",ntm,"number of headers",nh
        call erexit("f90rite:number of traces not equal to the number&
          & of traces being  stored\n")
      end if
    end if
    call fix_vector(struct%n,ft,jt,nt)
    if (wd.eq.1 .and. struct%file_format(1:1).ne."G") then
      if (size(tempp)<product(nwind)) then
        write(0,*) sep_thread_num(),"=thread window size=",product(nwind&
          &)," buffer size=",size(tempp)
        call seperr("window size > buffer size")
      end if
    end if
!if(wg==1 || wh==1){
    if (struct%nsect >1) then
      if (0.ne.sep3d_rite_local(trim(tag),trim(struct%tag), nt,ft,jt&
        &,tempp, gp,wd,wh,wg)) then
        call erexit("trouble writing out the data \n")
      end if
    else
      if (struct%impi.eq.0  .or. struct%nmpi.eq.1 .or. my_local) then
        if (0.ne.sep3d_rite(tag,struct%tag, nt,ft,jt,tempp, gp,wd,wh,wg&
          &)) then
          call erexit("trouble writing out the data \n")
        end if
      end if
    end if 
!}else if(wd==1){
!        if(size(tempp)*esize!= srite(tag,tempp,size(tempp)*esize))
!                call erexit("trouble writing out the data \n")
!}
!else call erexit("you didn't specify anything to write \n")
    deallocate(nt,ft,jt)
    put_data_3c=.true.
  end function 
  logical function put_data_2i(tag,struct,data,nwind,fwind,jwind&
    &,write_headers,write_grid,local_tag)
    integer, dimension(:,:),target :: data
    integer, pointer      :: tempp(:,:)
    character(len=*) :: tag
    type(sep3d)      :: struct
    integer,optional :: nwind(:),fwind(:),jwind(:)
    integer,allocatable,dimension(:) :: nt(:),ft(:),jt(:)
    logical, optional :: write_headers,write_grid
    logical, optional :: local_tag
    logical :: my_local
    integer           :: n
    integer,target    :: gt(1)
    integer :: gp
    integer           :: wd,wg,wh,ntm,nh,ierr,esize,ng
    esize=4
    tempp=>data
    wd=1
    gp=size(data,2)
    if (present(local_tag)) then
      my_local=local_tag
    else if (struct%nmpi>1) then
      my_local=.false.
    else
      my_local=.true.
    end if 
    if (.not. valid_structure(struct)) then
      call erexit("not a valid sep structure\n")
    end if
!if(struct%usage=="INPUT") call erexit("can not write out input struct \n");
    n=struct%ndims
    allocate(nt(n),ft(n),jt(n))
    if (present(nwind)) then
      nt=nwind
    else
      nt=-1
    end if 
    if (present(fwind)) then
      ft=fwind
    else
      ft=-1
    end if 
    if (present(jwind)) then
      jt=jwind
    else
      jt=-1
    end if 
    if (present(write_grid)) then
      if (struct%file_format.ne."GRID" .and. write_grid) then
        call erexit("can not write grid when file_format not grid \n")
      end if
      if (write_grid) then
        wg=1
      else
        wg=0
      end if
    else
      if (struct%file_format.ne."GRID") then
        wg=0
      else
        wg=1
      end if
    end if 
    ierr=sep3d_grab_nh(struct%tag,nh)
    if (present(write_headers)) then
      if (struct%file_format.eq."REGULAR" .and. write_headers) then
        call erexit("file_format set to regular can not write out headers&
          & \n")
      end if
      if (write_headers) then
        wh=1
      else
        wh=0
      end if
    else
      ierr=sep3d_grab_nh(struct%tag,nh)
      if (nh.eq.0) then
        wh=0
      else
        wh=1
      end if
    end if 
    if (wd.eq.1 .and. wh.eq.1) then
      ntm=size(tempp,2)
      if (wh .eq. 1 .and. ntm < nh) then
        write(0,*) "number of traces",ntm,"number of headers",nh
        call erexit("f90rite:number of traces not equal to the number&
          & of traces being  stored\n")
      end if
    end if
    call fix_vector(struct%n,ft,jt,nt)
    if (wd.eq.1 .and. struct%file_format(1:1).ne."G") then
      if (size(tempp)<product(nwind)) then
        write(0,*) sep_thread_num(),"=thread window size=",product(nwind&
          &)," buffer size=",size(tempp)
        call seperr("window size > buffer size")
      end if
    end if
!if(wg==1 || wh==1){
    if (struct%nsect >1) then
      if (0.ne.sep3d_rite_local(trim(tag),trim(struct%tag), nt,ft,jt&
        &,tempp, gp,wd,wh,wg)) then
        call erexit("trouble writing out the data \n")
      end if
    else
      if (struct%impi.eq.0  .or. struct%nmpi.eq.1 .or. my_local) then
        if (0.ne.sep3d_rite(tag,struct%tag, nt,ft,jt,tempp, gp,wd,wh,wg&
          &)) then
          call erexit("trouble writing out the data \n")
        end if
      end if
    end if 
!}else if(wd==1){
!        if(size(tempp)*esize!= srite(tag,tempp,size(tempp)*esize))
!                call erexit("trouble writing out the data \n")
!}
!else call erexit("you didn't specify anything to write \n")
    deallocate(nt,ft,jt)
    put_data_2i=.true.
  end function 
  logical function put_data_2f(tag,struct,data,nwind,fwind,jwind&
    &,write_headers,write_grid,local_tag)
    real, dimension(:,:),target:: data
    real, dimension(1) :: tempd
    real, pointer      :: tempp(:,:)
    character(len=*) :: tag
    type(sep3d)      :: struct
    integer,optional :: nwind(:),fwind(:),jwind(:)
    integer,allocatable,dimension(:) :: nt(:),ft(:),jt(:)
    logical, optional :: write_headers,write_grid
    integer           :: n
    integer, target   :: gt(1)
    integer  :: gp
    integer           :: wd,wg,wh,ntm,nh,ierr,esize,ng
    logical, optional :: local_tag
    logical :: my_local
    esize=4
    tempp=>data
    wd=1
    gp=size(data,2)
    if (present(local_tag)) then
      my_local=local_tag
    else if (struct%nmpi>1) then
      my_local=.false.
    else
      my_local=.true.
    end if 
    if (.not. valid_structure(struct)) then
      call erexit("not a valid sep structure\n")
    end if
!if(struct%usage=="INPUT") call erexit("can not write out input struct \n");
    n=struct%ndims
    allocate(nt(n),ft(n),jt(n))
    if (present(nwind)) then
      nt=nwind
    else
      nt=-1
    end if 
    if (present(fwind)) then
      ft=fwind
    else
      ft=-1
    end if 
    if (present(jwind)) then
      jt=jwind
    else
      jt=-1
    end if 
    if (present(write_grid)) then
      if (struct%file_format.ne."GRID" .and. write_grid) then
        call erexit("can not write grid when file_format not grid \n")
      end if
      if (write_grid) then
        wg=1
      else
        wg=0
      end if
    else
      if (struct%file_format.ne."GRID") then
        wg=0
      else
        wg=1
      end if
    end if 
    ierr=sep3d_grab_nh(struct%tag,nh)
    if (present(write_headers)) then
      if (struct%file_format.eq."REGULAR" .and. write_headers) then
        call erexit("file_format set to regular can not write out headers&
          & \n")
      end if
      if (write_headers) then
        wh=1
      else
        wh=0
      end if
    else
      ierr=sep3d_grab_nh(struct%tag,nh)
      if (nh.eq.0) then
        wh=0
      else
        wh=1
      end if
    end if 
    if (wd.eq.1 .and. wh.eq.1) then
      ntm=size(tempp,2)
      if (wh .eq. 1 .and. ntm < nh) then
        write(0,*) "number of traces",ntm,"number of headers",nh
        call erexit("f90rite:number of traces not equal to the number&
          & of traces being  stored\n")
      end if
    end if
    call fix_vector(struct%n,ft,jt,nt)
    if (wd.eq.1 .and. struct%file_format(1:1).ne."G") then
      if (size(tempp)<product(nwind)) then
        write(0,*) sep_thread_num(),"=thread window size=",product(nwind&
          &)," buffer size=",size(tempp)
        call seperr("window size > buffer size")
      end if
    end if
!if(wg==1 || wh==1){
    if (struct%nsect >1) then
      if (0.ne.sep3d_rite_local(trim(tag),trim(struct%tag), nt,ft,jt&
        &,tempp, gp,wd,wh,wg)) then
        call erexit("trouble writing out the data \n")
      end if
    else
      if (struct%impi.eq.0  .or. struct%nmpi.eq.1 .or. my_local) then
        if (0.ne.sep3d_rite(tag,struct%tag, nt,ft,jt,tempp, gp,wd,wh,wg&
          &)) then
          call erexit("trouble writing out the data \n")
        end if
      end if
    end if 
!}else if(wd==1){
!        if(size(tempp)*esize!= srite(tag,tempp,size(tempp)*esize))
!                call erexit("trouble writing out the data \n")
!}
!else call erexit("you didn't specify anything to write \n")
    deallocate(nt,ft,jt)
    put_data_2f=.true.
  end function 
  logical function put_data_2c(tag,struct,data,nwind,fwind,jwind&
    &,write_headers,write_grid,local_tag)
    complex, dimension(:,:),target :: data
    complex, dimension(1) :: tempd
    complex, pointer      :: tempp(:,:)
    character(len=*) :: tag
    type(sep3d)      :: struct
    integer,optional :: nwind(:),fwind(:),jwind(:)
    integer,allocatable,dimension(:) :: nt(:),ft(:),jt(:)
    logical, optional :: write_headers,write_grid
    integer           :: n
    integer,target    :: gt(1)
    integer           :: gp
    integer           :: wd,wg,wh,ntm,nh,ierr,esize,ng
    logical, optional :: local_tag
    logical :: my_local
    gp=size(data,2)
    tempp=>data
    esize=8
    wd=1
    if (present(local_tag)) then
      my_local=local_tag
    else if (struct%nmpi>1) then
      my_local=.false.
    else
      my_local=.true.
    end if 
    if (.not. valid_structure(struct)) then
      call erexit("not a valid sep structure\n")
    end if
!if(struct%usage=="INPUT") call erexit("can not write out input struct \n");
    n=struct%ndims
    allocate(nt(n),ft(n),jt(n))
    if (present(nwind)) then
      nt=nwind
    else
      nt=-1
    end if 
    if (present(fwind)) then
      ft=fwind
    else
      ft=-1
    end if 
    if (present(jwind)) then
      jt=jwind
    else
      jt=-1
    end if 
    if (present(write_grid)) then
      if (struct%file_format.ne."GRID" .and. write_grid) then
        call erexit("can not write grid when file_format not grid \n")
      end if
      if (write_grid) then
        wg=1
      else
        wg=0
      end if
    else
      if (struct%file_format.ne."GRID") then
        wg=0
      else
        wg=1
      end if
    end if 
    ierr=sep3d_grab_nh(struct%tag,nh)
    if (present(write_headers)) then
      if (struct%file_format.eq."REGULAR" .and. write_headers) then
        call erexit("file_format set to regular can not write out headers&
          & \n")
      end if
      if (write_headers) then
        wh=1
      else
        wh=0
      end if
    else
      ierr=sep3d_grab_nh(struct%tag,nh)
      if (nh.eq.0) then
        wh=0
      else
        wh=1
      end if
    end if 
    if (wd.eq.1 .and. wh.eq.1) then
      ntm=size(tempp,2)
      if (wh .eq. 1 .and. ntm < nh) then
        write(0,*) "number of traces",ntm,"number of headers",nh
        call erexit("f90rite:number of traces not equal to the number&
          & of traces being  stored\n")
      end if
    end if
    call fix_vector(struct%n,ft,jt,nt)
    if (wd.eq.1 .and. struct%file_format(1:1).ne."G") then
      if (size(tempp)<product(nwind)) then
        write(0,*) sep_thread_num(),"=thread window size=",product(nwind&
          &)," buffer size=",size(tempp)
        call seperr("window size > buffer size")
      end if
    end if
!if(wg==1 || wh==1){
    if (struct%nsect >1) then
      if (0.ne.sep3d_rite_local(trim(tag),trim(struct%tag), nt,ft,jt&
        &,tempp, gp,wd,wh,wg)) then
        call erexit("trouble writing out the data \n")
      end if
    else
      if (struct%impi.eq.0  .or. struct%nmpi.eq.1 .or. my_local) then
        if (0.ne.sep3d_rite(tag,struct%tag, nt,ft,jt,tempp, gp,wd,wh,wg&
          &)) then
          call erexit("trouble writing out the data \n")
        end if
      end if
    end if 
!}else if(wd==1){
!        if(size(tempp)*esize!= srite(tag,tempp,size(tempp)*esize))
!                call erexit("trouble writing out the data \n")
!}
!else call erexit("you didn't specify anything to write \n")
    deallocate(nt,ft,jt)
    put_data_2c=.true.
  end function 
  logical function put_data_n(tag,struct,nwind,fwind,jwind,write_headers&
    &,write_grid,local_tag)
    complex, dimension(1,1),target :: tempd
    complex, pointer      :: tempp(:,:)
    character(len=*) :: tag
    type(sep3d)      :: struct
    integer,optional :: nwind(:),fwind(:),jwind(:)
    integer,allocatable,dimension(:) :: nt(:),ft(:),jt(:)
    logical, optional :: write_headers,write_grid
    integer           :: n
    integer,target    :: gt(1)
    integer, pointer  :: gp
    integer           :: wd,wg,wh,ntm,nh,ierr,esize,ng
    logical, optional :: local_tag
    logical :: my_local
    allocate(gp)
    gp=0
    esize=8
    tempp=>tempd
    wd=0
    if (present(local_tag)) then
      my_local=local_tag
    else if (struct%nmpi>1) then
      my_local=.false.
    else
      my_local=.true.
    end if 
    if (.not. valid_structure(struct)) then
      call erexit("not a valid sep structure\n")
    end if
!if(struct%usage=="INPUT") call erexit("can not write out input struct \n");
    n=struct%ndims
    allocate(nt(n),ft(n),jt(n))
    if (present(nwind)) then
      nt=nwind
    else
      nt=-1
    end if 
    if (present(fwind)) then
      ft=fwind
    else
      ft=-1
    end if 
    if (present(jwind)) then
      jt=jwind
    else
      jt=-1
    end if 
    if (present(write_grid)) then
      if (struct%file_format.ne."GRID" .and. write_grid) then
        call erexit("can not write grid when file_format not grid \n")
      end if
      if (write_grid) then
        wg=1
      else
        wg=0
      end if
    else
      if (struct%file_format.ne."GRID") then
        wg=0
      else
        wg=1
      end if
    end if 
    ierr=sep3d_grab_nh(struct%tag,nh)
    if (present(write_headers)) then
      if (struct%file_format.eq."REGULAR" .and. write_headers) then
        call erexit("file_format set to regular can not write out headers&
          & \n")
      end if
      if (write_headers) then
        wh=1
      else
        wh=0
      end if
    else
      ierr=sep3d_grab_nh(struct%tag,nh)
      if (nh.eq.0) then
        wh=0
      else
        wh=1
      end if
    end if 
    if (wd.eq.1 .and. wh.eq.1) then
      ntm=size(tempp,2)
      if (wh .eq. 1 .and. ntm < nh) then
        write(0,*) "number of traces",ntm,"number of headers",nh
        call erexit("f90rite:number of traces not equal to the number&
          & of traces being  stored\n")
      end if
    end if
    call fix_vector(struct%n,ft,jt,nt)
    if (wd.eq.1 .and. struct%file_format(1:1).ne."G") then
      if (size(tempp)<product(nwind)) then
        write(0,*) sep_thread_num(),"=thread window size=",product(nwind&
          &)," buffer size=",size(tempp)
        call seperr("window size > buffer size")
      end if
    end if
!if(wg==1 || wh==1){
    if (struct%nsect >1) then
      if (0.ne.sep3d_rite_local(trim(tag),trim(struct%tag), nt,ft,jt&
        &,tempp, gp,wd,wh,wg)) then
        call erexit("trouble writing out the data \n")
      end if
    else
      if (struct%impi.eq.0  .or. struct%nmpi.eq.1 .or. my_local) then
        if (0.ne.sep3d_rite(tag,struct%tag, nt,ft,jt,tempp, gp,wd,wh,wg&
          &)) then
          call erexit("trouble writing out the data \n")
        end if
      end if
    end if 
!}else if(wd==1){
!        if(size(tempp)*esize!= srite(tag,tempp,size(tempp)*esize))
!                call erexit("trouble writing out the data \n")
!}
!else call erexit("you didn't specify anything to write \n")
    deallocate(nt,ft,jt)
    deallocate(gp)
    put_data_n=.true.
  end function 
!/*<
!init_sepf90
!
!USAGE
!call init_sep3d()
!
!
!DESCRIPTION
!Initialize sep3d
!
!>*/
  subroutine init_sepf90()
    counter=0
  end subroutine 
!$
!$=head1 NAME
!$
!$print_sep3d - print info about the sep3d struct
!$
!$=head1 SYNOPSIS
!$
!$C<call print_sep3d(struct,level)>
!$
!$=head1 INPUT PARAMETERS
!$
!$=over 4
!$
!$=item struct  -  sep3d
!$
!$      structure to get info about
!$
!$=item level   -  int
!$
!$      level of verbosity
!$
!$=back
!$
!$=head1 DESCRIPTION
!$
!$Get info about strucut
!$
!$head1 LIBRARY
!$
!$B<supersetf90>
!$
!$=cut
!$
  subroutine print_sep3d(struct,level)
    type(sep3d) :: struct 
    integer, optional :: level
    integer :: lv,i
    if (present(level)) then
      lv=level
    else
      lv=0
    end if 
    write(0,*) "----------FORTRAN 90 STATUS----------"
    write(0,*) "tag=",struct%tag(1:15)
    write(0,*) "data_format=",struct%data_format(1:15)
    write(0,*) "file_format=",struct%file_format(1:15)
    write(0,*) "usage=",struct%usage(1:len_trim(struct%usage))
    if (struct%ndims>0) then
      write(0,*)  "axis      n       o      d     label unit"
      do i=1,struct%ndims
        write(0,*) i,struct%n(i),struct%o(i),struct%d(i),struct%label(i&
          &)(1:15)," ",struct%unit(i)(1:15)
      end do
    else
      write(0,*) "NO AXES ALLOCATED"
    end if 
    if (struct%nkeys>0) then
      write(0,*)  "key number   name    type format"
      do i=1,struct%nkeys
        write(0,*) i,struct%keyname(i)(1:15)," ",struct%keytype(i)(1:15&
          &)," ",struct%keyfmt(i)(1:15)
      end do
    else
      write(0,*) "NO KEYS ALLOCATED"
    end if 
    write(0,*) "ntraces",struct%ntraces
    write(0,*) "----------------- C  STATUS----------"
    call sep3d_print_info(struct%tag)
  end subroutine 
!$
!$=head1 NAME
!$
!$sep3d_write_description - write out format file info
!$
!$=head1 SYNOPSIS
!$
!$C<sep3d_write_description(tag,struct)>
!$
!$=head1 INPUT PARAMETERS
!$
!$=over 4
!$
!$=item tag      -  char*
!$
!$      tag to write out
!$
!$=item struct   -  sep3d
!$
!$      structure to write out
!$
!$=back
!$
!$=head1 DESCRIPTION
!$
!$Write out description to tag
!$
!$=head1 SEE ALSO
!$
!$B<sep3d_write>
!$
!$=head1 LIBRARY
!$
!$B<supersetf90>
!$
!$=cut
!$
  subroutine sep3d_write_description(tag,structure)
    type(sep3d) :: structure
    character(len=*) :: tag
    if (.not. valid_structure(structure)) then
      call erexit("you are attempting to write out an invalid strucutre"&
        &)
    end if
    call sep3d_set_sep3d(structure)
    if (0.ne.sep3d_set_ntraces(structure%tag,structure%ntraces)) then
      call erexit("trouble writing out struture to disk1")
    end if
    if (0.ne.sep3d_rite_format(tag,structure%tag)) then
      call erexit("trouble writing out struture to disk2")
    end if
    if (0.ne.sep3d_rite_ntraces(tag,structure%tag)) then
      call erexit("trouble writing out struture to disk3")
    end if
  end subroutine 
  subroutine sep3d_set_write_status(structure,data,header)
    type(sep3d) :: structure
    logical :: header,data
    integer :: h,d
    if (.not. valid_structure(structure)) then
      call erexit("you are attempting to write out an invalid strucutre"&
        &)
    end if
    call sep3d_set_sep3d(structure)
    if (header) then
      h=1
    else
      h=0
    end if 
    if (data) then
      d=1
    else
      d=0
    end if 
    if (0.ne.sep3d_set_rite_status(structure%tag,d,h)) then
      call erexit("trouble writing out struture to disk ")
    end if
  end subroutine 
!$
!$=head1 NAME
!$
!$sep3d_add_drn - add data record number
!$
!$=head1 SYNOPSIS
!$
!$C<call sep3d_add_drn(struct,drn)>
!$
!$=head1 INPUT PARAMETERS
!$
!$=over 4
!$
!$=item struct  -  sep3d
!$
!$      structure to add drn too
!$
!$=item drn     -  int*
!$
!$      drn to add
!$
!$=back
!$
!$=head1 DESCRIPTION
!$
!$Add data record number to sep3d structure
!$
!$=head1 LIBRARY
!$
!$B<supersetf90>
!$
!$=cut
!$
!$
  subroutine sep3d_add_drn(structure,drn)
    type(sep3d) :: structure
    integer :: drn(:)
    if (.not. valid_structure(structure)) then
      call erexit("you are attempting to write out an invalid strucutre"&
        &)
    end if
    if (0.ne.sep3d_set_drn (structure%tag,drn)) then
      call erexit("trouble setting drn")
    end if
  end subroutine 
!$=head1 NAME
!$
!$sep3d_key_index - try to find key in structure
!$
!$
!$=head1 SYNOPSIS
!$
!$C<logical sep3d_key_index(struct,keyname,keyindex)>
!$
!$=head1 INPUT PARAMETERS
!$
!$=over 4
!$
!$=item struct  -  sep3d
!$
!$      structure to find key in
!$
!$=item keyname - char*
!$
!$       name of the key to find
!$
!$=back
!$
!$=head1 OUTPUT PARAMETERS
!$
!$=over 4
!$
!$=item keyindex- integer
!$
!$      index of the key
!$
!$=back
!$
!$=head1 RETURN VALUES
!$
!$=over 4
!$
!$=item .true.  -
!$
!$      found key
!$
!$=item .false. -
!$
!$       didn't find key
!$
!$=back
!$
!$=head1 DESCRIPTION
!$
!$Attempte to find the given key
!$
!$=head1 SEE ALSO
!$
!$L<sep3d_axis_index>
!$
!$=head1 LIBRARY
!$
!$B<supersetf90>
!$
!$=cut
!>
  logical  function sep3d_key_index(struct,keyname,keyindex)
    type(sep3d) :: struct
    integer :: keyindex
    character(len=*) ::  keyname
    integer :: ierr
    if (.not. valid_structure(struct)) then
      call erexit("you are attempting to write out an invalid strucutre"&
        &)
    end if
    call sep3d_set_sep3d(struct)
    ierr=sep3d_grab_key_index(struct%tag,keyname,keyindex)
    if (ierr.eq.0) then
      sep3d_key_index=.true.
    else
      sep3d_key_index=.false.
    end if
  end function 
!$=head1 NAME
!$
!$sep3d_axis_index - try to axis key in structure
!$
!$
!$=head1 SYNOPSIS
!$
!$C<logical sep3d_axis_index(struct,axisname,axisindex)>
!$
!$=head1 INPUT PARAMETERS
!$
!$=over 4
!$
!$=item struct  -  sep3d
!$
!$      structure to find key in
!$
!$=item axisname - char*
!$
!$      name of the axis to find
!$
!$=back
!$
!$=head1 OUTPUT PARAMETERS
!$
!$=over 4
!$
!$=item axisindex- integer
!$
!$      index of the axis
!$
!$=back
!$
!$=head1 RETURN VALUES
!$
!$=over 4
!$
!$=item .true.  -
!$
!$      found axis
!$
!$=item .false. -
!$
!$      didn't find axis
!$
!$=back
!$
!$=head1 DESCRIPTION
!$
!$Attempte to find the given axis
!$
!$=head1 SEE ALSO
!$
!$L<sep3d_key_index>
!$
!$=head1 LIBRARY
!$
!$B<supersetf90>
!$
!$=cut
  logical  function sep3d_axis_index(struct,axisname,axisindex)
    type(sep3d) :: struct
    integer :: axisindex
    character(len=*) ::  axisname
    integer :: ierr
    if (.not. valid_structure(struct)) then
      call erexit("you are attempting to write out an invalid strucutre"&
        &)
    end if
    call sep3d_set_sep3d(struct)
    ierr=sep3d_grab_axis_index(struct%tag,axisname,axisindex)
    if (ierr.eq.0) then
      sep3d_axis_index=.true.
    else
      sep3d_axis_index=.false.
    end if
  end function 
!$=head1 NAME
!$
!$sep3d_set_number_headers - set the number of headers to store
!$
!$
!$=head1 SYNOPSIS
!$
!$C<call sep3d_set_number_headers(struct,nh)>
!$
!$=head1 INPUT PARAMETERS
!$
!$=over 4
!$
!$=item struct  -  sep3d
!$
!$      structure
!$
!$=item nh      -  integer
!$
!$      number of headers
!$
!$=back
!$
!$=head1 DESCRIPTION
!$
!$Set number of headers to hold in structure
!$
!$=head1 SEE ALSO
!$
!$L<sep3d_store_grid_values>
!$
!$=head1 LIBRARY
!$
!$B<supersetf90>
!$
!$=cut
  subroutine sep3d_set_number_headers(struct,num)
    type(sep3d) :: struct
    integer :: num
    if (.not. valid_structure(struct)) then
      call erexit("invalid structure ")
    end if
    if (0.ne.sep3d_set_nh(struct%tag,num)) then
      call erexit("trouble setting number of headers ")
    end if
  end subroutine 
!$=head1 NAME
!$
!$sep3d_grab_grid_values - store  a grid
!$
!$
!$=head1 SYNOPSIS
!$
!$C<call sep3d_grab_grid_values(struct,grid)>
!$
!$=head1 INPUT PARAMETERS
!$
!$=over 4
!$
!$=item struct  -  sep3d
!$
!$      structure
!$
!$=back
!$
!$=head1 OUTPUT PARAMETERS
!$
!$=over 4
!$
!$=item grid - C<int(:)>
!$
!$      grid
!$
!$=back
!$
!$=head1 DESCRIPTION
!$
!$Grab grid values in C strucutre
!$
!$=head1 SEE ALSO
!$
!$L<sep3d_set_number_headers>
!$
!$=head1 LIBRARY
!$
!$B<supersetf90>
!$
!$=cut
  subroutine sep3d_grab_grid_values(struct,vals)
    type(sep3d) :: struct
    integer     :: vals(:)
    if (.not. valid_structure(struct)) then
      call erexit("invalid structure ")
    end if
    if (0.ne.sep3d_grab_grid_block(struct%tag,vals)) then
      call erexit("trouble storing grid values")
    end if
  end subroutine 
!$=head1 NAME
!$
!$sep3d_store_grid_values - store  a grid
!$
!$
!$=head1 SYNOPSIS
!$
!$C<call sep3d_store_grid_values(struct,grid)>
!$
!$=head1 INPUT PARAMETERS
!$
!$=over 4
!$
!$=item struct  -  sep3d
!$
!$      structure
!$
!$=item grid - C<int(:)>
!$
!$      grid
!$
!$=back
!$
!$=head1 DESCRIPTION
!$
!$Store grid values in C strucutre
!$
!$=head1 SEE ALSO
!$
!$L<sep3d_set_number_headers>
!$
!$=head1 LIBRARY
!$
!$B<supersetf90>
!$
!$=cut
  subroutine sep3d_store_grid_values(struct,vals)
    type(sep3d) :: struct
    integer     :: vals(:)
    if (.not. valid_structure(struct)) then
      call erexit("invalid structure ")
    end if
    if (0.ne.sep3d_set_ng(struct%tag,size(vals))) then
      call erexit("trouble setting number of grid values")
    end if
    if (0.ne.sep3d_set_grid_vals(struct%tag,vals)) then
      call erexit("trouble storing grid values")
    end if
  end subroutine 
!$=head1 NAME
!$
!$sep3d_with_drn - sets
!$
!$
!$=head1 SYNOPSIS
!$
!$C<ndim= sep3d_with_drn(without,with)>
!$
!$=head1 INPUT PARAMETERS
!$
!$=over 4
!$
!$=item without  -  sep3d
!$
!$      structure  without drn
!$
!$=back
!$
!$=head1 OUTPUT PARAMETERS
!$
!$=over 4
!$
!$=item with  -  sep3d
!$
!$      structure  without drn included
!$
!$=back
!$
!$=head1 DESCRIPTION
!$
!$ Returns the sep3d structure with the drn record number included in the
!$  correct key position
!$
!$=head1 SEE ALSO
!$
!$
!$=head1 LIBRARY
!$
!$B<supersetf90>
!$
!$=cut
  subroutine sep3d_with_drn(real_struct,drn_struct)
    type(sep3d) :: real_struct,drn_struct
    integer,external :: sep_get_key_index
    integer :: ierr,i,index,ito
    call init_sep3d(real_struct,drn_struct,real_struct%usage)
    ierr=sep_get_key_index(real_struct%tag,"data_record_number",index)
    if (ierr.eq.0) then
!we have a data_record_number
      call key_allocate(drn_struct,real_struct%nkeys+1)
      do i=1,real_struct%nkeys 
        if (i.eq. index) then
!drn key location
          drn_struct%keyname(i)="data_record_number"
          drn_struct%keytype(i)="scalar_int"
          drn_struct%keyfmt(i)="xdr_int"
        else
          if (i<index) then
            ito=i
          else
            ito=i+1
          end if 
          drn_struct%keyname(ito)=real_struct%keyname(i)
          drn_struct%keytype(ito)=real_struct%keytype(i)
          drn_struct%keyfmt(ito)=real_struct%keyfmt(i)
        end if
      end do
    end if
    call sep3d_set_sep3d(drn_struct)
  end subroutine 
!$=head1 NAME
!$
!$sep3d_ndims - number of dimensions in sep3d datasets
!$
!$
!$=head1 SYNOPSIS
!$
!$C<ndim= sep3d_ndims(struct)>
!$
!$=head1 INPUT PARAMETERS
!$
!$=over 4
!$
!$=item struct  -  sep3d
!$
!$      structure
!$
!$=back
!$
!$=head1 DESCRIPTION
!$
!$The last dimension with axis length greater than 1
!$
!$=head1 SEE ALSO
!$
!$
!$=head1 LIBRARY
!$
!$B<supersetf90>
!$
!$=cut
  integer function sep3d_ndims(struct)
    type(sep3d) :: struct
    integer :: i
    if (.not. valid_structure(struct)) then
      sep3d_ndims=-1
    else
      sep3d_ndims=struct%ndims
      do while (sep3d_ndims.ne.1 .and.  struct%n(sep3d_ndims).eq.1)
        sep3d_ndims= sep3d_ndims-1
      end do
    end if
  end function 
!$=head1 NAME
!$
!$sep3d_ndims - number of dimensions in sep3d datasets
!$
!$
!$=head1 SYNOPSIS
!$
!$C<call sep3d_inorder(struct)>
!$
!$=head1 INPUT PARAMETERS
!$
!$=over 4
!$
!$=item struct  -  sep3d
!$
!$      structure
!$
!$=back
!$
!$=head1 DESCRIPTION
!$
!$ Establish that the data and the headers are synched
!$
!$=head1 SEE ALSO
!$
!$
!$=head1 LIBRARY
!$
!$B<supersetf90>
!$
!$=cut
  subroutine sep3d_inorder(struct)
    type(sep3d) :: struct
    if (0.ne.sep3d_set_inorder(struct%tag)) then
      write(0,*) "trouble setting in order ",trim(struct%tag)
      call erexit("")
    end if
  end subroutine 
!$=head1 NAME
!$
!$sep3d_rite_num_traces - write number of traces in a dataset
!$
!$
!$=head1 SYNOPSIS
!$
!$C<sep3d_rite_num_traces(tag,struct)>
!$
!$=head1 INPUT PARAMETERS
!$
!$=over 4
!$
!$=item tag  -   sepfile
!$
!$      tag to write to
!$
!$=item struct  -  sep3d
!$
!$      structure
!$
!$=back
!$
!$=head1 DESCRIPTION
!$
!$ Write  the number of traces in a dataset to a tag
!$
!$=head1 SEE ALSO
!$
!$
!$=head1 LIBRARY
!$
!$B<supersetf90>
!$
!$=cut
  subroutine sep3d_rite_num_traces(tag,struct)
    type(sep3d) :: struct
    character(len=*) :: tag
    if (0.ne.sep3d_rite_ntraces(tag,struct%tag)) then
      write(0,*) "trouble writing number of traces for ",trim(tag)
      call erexit("")
    end if
  end subroutine 
!$=head1 NAME
!$
!$sep3d_reshape -  reshape a dataset
!$
!$
!$=head1 SYNOPSIS
!$
!$C<call  sep3d_reshape(struct)>
!$
!$=head1 INPUT PARAMETERS
!$
!$=over 4
!$
!$=item struct  -  sep3d
!$
!$      structure
!$
!$=item n  -  int*
!$
!$      axis remapping
!$
!$=back
!$
!$=head1 DESCRIPTION
!$
!$ Change the dimensions of a dataset
!$
!$=head1 EXAMPLES
!$
!$ Given data%n=(/10,20,10/)  n=(/1,2,3,3/) --> data%n(/10,20,10,1/)
!$
!$ Given data%n=(/10,20,10/)  n=(/1,3/) --> data%n(/10,200/)
!$
!$ Given data%n=(/10,20,10/)  n=(/1,2,2,3/) --> data%n(/10,1,20,10/)
!$
!$
!$
!$=head1 SEE ALSO
!$
!$
!$=head1 LIBRARY
!$
!$B<supersetf90>
!$
!$=cut
  subroutine  sep3d_reshape(struct,n)
    type(sep3d) :: struct
    integer :: n(:)
    call sep3d_set_sep3d(struct)
    if (0.ne.sep3d_change_dims(struct%tag,size(n),n)) then
      write(0,*) "trouble changing dimensions for tag ",trim(struct%tag&
        &)
      call erexit("")
    end if
    call sep3d_grab_sep3d(struct%tag,struct)
  end subroutine 
!$=head1 NAME
!$
!$sep3d_header_copy - Copy the headers from one dataset to another
!$
!$
!$=head1 SYNOPSIS
!$
!$C<call sep3d_header_copy(to,from)>
!$
!$=head1 INPUT PARAMETERS
!$
!$=over 4
!$
!$=item to  -  sep3d
!$
!$      structure
!$
!$=item from  -  sep3d
!$
!$      structure
!$
!$=back
!$
!$=head1 DESCRIPTION
!$
!$Copy  the headers from one dataset to another
!$
!$=head1 SEE ALSO
!$
!$
!$=head1 LIBRARY
!$
!$B<supersetf90>
!$
!$=cut
  subroutine sep3d_coord_copy(struct1,struct2)
    type(sep3d) :: struct1,struct2
    if (0.ne.sep3d_copy_coords(struct1%tag,struct2%tag)) then
      write(0,*) "trouble copying coords from ",trim(struct1%tag), " to&
        & ",trim(struct2%tag)
      call erexit("")
    end if
  end subroutine 
  subroutine sep3d_header_copy(struct1,struct2)
    type(sep3d) :: struct1,struct2
    if (0.ne.sep3d_copy_headers(struct1%tag,struct2%tag)) then
      write(0,*) "trouble copying header from ",trim(struct1%tag), " to&
        & ",trim(struct2%tag)
      call erexit("")
    end if
  end subroutine 
!$=head1 NAME
!$
!$sep3d_grid_copy - Copy the grid
!$
!$
!$=head1 SYNOPSIS
!$
!$C<call sep3d_grid_copy(in,out)>
!$
!$=head1 INPUT PARAMETERS
!$
!$=over 4
!$
!$=item in  -  sep3d
!$
!$      structure
!$
!$=item out  -  sep3d
!$
!$      structure
!$
!$=back
!$
!$=head1 DESCRIPTION
!$
!$ Copy the grid from in to out
!$
!$=head1 SEE ALSO
!$
!$
!$=head1 LIBRARY
!$
!$B<supersetf90>
!$
!$=cut
  subroutine sep3d_grid_copy(struct1,struct2)
    type(sep3d) :: struct1,struct2
    if (0.ne.sep3d_copy_grid(struct1%tag,struct2%tag)) then
      write(0,*) "trouble copying grid from ",trim(struct1%tag), " to "&
        &,trim(struct2%tag)
      call erexit("")
    end if
  end subroutine 
!$=head1 NAME
!$
!$sep3d_ge_space - see if space contains another space
!$
!$
!$=head1 SYNOPSIS
!$
!$C<logic= sep3d_ge_space(struct1,struct2)>
!$
!$=head1 INPUT PARAMETERS
!$
!$=over 4
!$
!$=item struct1  -  sep3d
!$
!$      structure
!$
!$=item struct2  -  sep3d
!$
!$      structure
!$
!$=back
!$
!$=head1 DESCRIPTION
!$
!$Check to see if struct2 fits within the space occupied by struct1
!$
!$=head1 SEE ALSO
!$
!$
!$=head1 LIBRARY
!$
!$B<supersetf90>
!$
!$=cut
  logical function sep3d_ge_space(sep3d1,sep3d2)
    type(sep3d) :: sep3d1,sep3d2
    sep3d_ge_space=.true.
    if (0.ne.sep3dge_space(sep3d1%tag,sep3d2%tag)) then
      sep3d_ge_space=.false.
    end if
  end function 
!$=head1 NAME
!$
!$sep3d_conform - see if two spaces are the same size
!$
!$
!$=head1 SYNOPSIS
!$
!$C<logic= sep3d_conform(struct1,struct2)>
!$
!$=head1 INPUT PARAMETERS
!$
!$=over 4
!$
!$=item struct1  -  sep3d
!$
!$      structure
!$
!$=item struct2  -  sep3d
!$
!$      structure
!$
!$=back
!$
!$=head1 DESCRIPTION
!$
!$Check to see if two spaces have the same n,o, and d
!$
!$=head1 SEE ALSO
!$
!$
!$=head1 LIBRARY
!$
!$B<supersetf90>
!$
!$=cut
  logical function sep3d_conform(sep3d1,sep3d2)
    type(sep3d) :: sep3d1,sep3d2
    sep3d_conform=.true.
    if (0.ne.sep3dconform(sep3d1%tag,sep3d2%tag)) then
      sep3d_conform=.false.
    end if
  end function 
!$=head1 NAME
!$
!$sep3d_section_tag -  section a tag
!$
!$
!$=head1 SYNOPSIS
!$
!$C<logic= sep3d_section_tag(struct,axis,pattern,nsect,dff,master_data)>
!$
!$=head1 INPUT PARAMETERS
!$
!$=over 4
!$
!$=item struct  -  sep3d
!$
!$      structure
!$
!$=item axis  -  integer
!$
!$      axis to section along
!$
!$=item pattern  -  char*
!$
!$      distribution pattern ("BLOCK" or "SPREAD")
!$
!$=item nsect  -  int
!$
!$      number of sections
!$
!$=item dff  -  char*
!$
!$      [optional]  name of the internal dff tag
!$
!$=item master_data  -  logical
!$
!$      [optional-.true.]  whether or not the master thread holds data
!$
!$=back
!$
!$=head1 DESCRIPTION
!$
!$Section a dataset
!$
!$=head1 SEE ALSO
!$
!$
!$=head1 LIBRARY
!$
!$B<supersetf90>
!$
!$=cut
  logical function sep3d_section_tag(struct,axis,pattern,nsect,master_data&
    &)
    type(sep3d) ::  struct
    character(len=*) :: pattern
    character(len=128) :: dff_send,junk
    integer :: axis,nsect,ierr,imaster
    logical, optional :: master_data
    sep3d_section_tag=.false.
!if(present(dff)) dff_send=dff
!else  call mkrandom_string(struct%tag,dff_send)
    imaster=1
    if (present(master_data)) then
      if (.not. master_data) then
        imaster=0
      end if
    else
      imaster=1
      call getch("master_data","d",imaster)
    end if 
    ierr=sep3d_init_section_par(struct%tag,struct%tag,axis, pattern,&
      & nsect,imaster)
    call  sep3d_grab_sep3d(struct%tag,struct)
    if (ierr.eq.0) then
      sep3d_section_tag=.true.
    end if
  end function 
!$=head1 NAME
!$
!$sep3d_synch - synchronize  a dataset
!$
!$
!$=head1 SYNOPSIS
!$
!$C<logic= sep3d_synch(tag,struct)>
!$
!$=head1 INPUT PARAMETERS
!$
!$=over 4
!$
!$=item tag  -  sepfile
!$
!$      tag
!$
!$=item struct  -  sep3d
!$
!$      structure
!$
!$=back
!$
!$=head1 DESCRIPTION
!$
!$Move all of the sections to local machine
!$
!$=head1 SEE ALSO
!$
!$
!$=head1 LIBRARY
!$
!$B<supersetf90>
!$
!$=cut
  logical function sep3d_sync(tag,struct)
    type(sep3d) ::  struct
    character(len=*) :: tag
    integer :: ierr
    sep3d_sync=.false.
    ierr=sep3d_sync_tag(tag,struct%tag)
    if (ierr.eq.0) then
      sep3d_sync=.true.
    end if
  end function 
!$=head1 NAME
!$
!$sep3d_copy - a copy a structure and its contents
!$
!$
!$=head1 SYNOPSIS
!$
!$C<logic= sep3d_copy(struct1,struct2)>
!$
!$=head1 INPUT PARAMETERS
!$
!$=over 4
!$
!$=item struct1  -  sep3d
!$
!$      structure
!$
!$=item struct2  -  sep3d
!$
!$      structure
!$
!$=back
!$
!$=head1 DESCRIPTION
!$
!$Copy from struct1 to struct2
!$
!$=head1 SEE ALSO
!$
!$
!$=head1 LIBRARY
!$
!$B<supersetf90>
!$
!$=cut
  logical function sep3d_copy(struct_in,struct_out)
    type(sep3d) ::  struct_in,struct_out
    integer :: ierr
    sep3d_copy=.false.
    ierr=sep3d_copy_struct(struct_in%tag,struct_out%tag)
    call sep3d_grab_sep3d(struct_out%tag,struct_out)
    if (ierr.eq.0) then
      sep3d_copy=.true.
    end if
  end function 
!$=head1 NAME
!$
!$sep3d_grab_coords -  Grab the coordinates
!$
!$
!$=head1 SYNOPSIS
!$
!$C<logic= sep3d_grab_coords(struct,coords)>
!$
!$=head1 INPUT PARAMETERS
!$
!$=over 4
!$
!$=item struct  -  sep3d
!$
!$      structure
!$
!$=item coords  -  int (:,:)
!$
!$      coordinates
!$
!$=back
!$
!$=head1 DESCRIPTION
!$
!$Grab the coordinates [axis(2:)] of the dataset currently in memory
!$
!$=head1 SEE ALSO
!$
!$
!$=head1 LIBRARY
!$
!$B<supersetf90>
!$
!$=cut
  logical function sep3d_grab_coords(struct,coords)
    type(sep3d) :: struct
    integer :: coords(:,:)
    sep3d_grab_coords=.false.
    if (0.ne.sep3d_grab_coord_vals(struct%tag,coords)) then
      write(0,*) "trouble grabbing coord vals"
      return
    end if
    sep3d_grab_coords=.true.
  end function 
!$=head1 NAME
!$
!$sep3d_desection - desection a tag
!$
!$
!$=head1 SYNOPSIS
!$
!$C<logic= sep3d_desection(struct)>
!$
!$=head1 INPUT PARAMETERS
!$
!$=over 4
!$
!$=item struct  -  sep3d
!$
!$      structure
!$
!$=back
!$
!$=head1 DESCRIPTION
!$
!$Desection a tag
!$
!$=head1 SEE ALSO
!$
!$
!$=head1 LIBRARY
!$
!$B<supersetf90>
!$
!$=cut
  logical function sep3d_desection(struct)
    type(sep3d) :: struct
    sep3d_desection=.false.
    if (0.ne.sep3d_desection_tag(struct%tag)) then
      write(0,*) "trouble desection tags"
      return
    end if
    call sep3d_grab_sep3d(struct%tag,struct)
    sep3d_desection=.true.
  end function 
!$=head1 NAME
!$
!$sep3d_local_buffer_size - Get the size of the data associated with a given window
!$
!$
!$=head1 SYNOPSIS
!$
!$C<ndim= sep3d_local_buffer_size(struct,n,nwind,fwind,jwind)>
!$
!$=head1 INPUT PARAMETERS
!$
!$=over 4
!$
!$=item struct  -  sep3d
!$
!$      structure
!$
!$=item n  -  int (2)
!$
!$      the output window size
!$
!$=item nwind  -  int*
!$
!$      [nwind in memory, optional] the number of samples in a window
!$
!$=item fwind  -  int*
!$
!$      [fwind in memory, optional] the first sample in a window
!$
!$=item jwind  -  int*
!$
!$      [jwind in memory, optional] the sampling of the window
!$
!$
!$=back
!$
!$=head1 DESCRIPTION
!$
!$Get the size associated with a given window (defaults to the window
!$ described by the last read_headers call or the entire dataset)
!$ Useful for sectioned tags.
!$
!$
!$=head1 SEE ALSO
!$
!$
!$=head1 LIBRARY
!$
!$B<supersetf90>
!$
!$=cut
  logical function sep3d_local_buffer_size(struct,n,nwind,fwind,jwind)
    type(sep3d) :: struct
    integer :: n(2)
    integer,optional :: nwind(:),fwind(:),jwind(:)
    integer,allocatable,dimension(:) :: nw,fw,jw
    sep3d_local_buffer_size=.false.
    if (.not. valid_structure(struct)) then
      write(0,*) "invalid structure"
      return
    end if
    allocate(nw(struct%ndims))
    allocate(fw(struct%ndims))
    allocate(jw(struct%ndims))
    nw=-1
    fw=-1
    jw=-1
    if (present(nwind)) then
      nw=nwind
    end if
    if (present(fwind)) then
      fw=fwind
    end if
    if (present(jwind)) then
      jw=jwind
    end if
    call fix_vector(struct%n,fw,jw,nw)
    if (0.ne.sep3d_buf_size(struct%tag,nw,fw,jw,n)) then
      write(0,*) "trouble getting buffer size"
      deallocate(nw,fw,jw)
      return
    end if
    deallocate(nw,fw,jw)
    sep3d_local_buffer_size=.true.
  end function 
  logical function disti(struct1,struct2,data_in,data_out)
    type(sep3d) :: struct1,struct2
    integer :: data_in(:,:),data_out(:,:)
    disti=.false.
    if (0.ne.sep3d_dist_data(struct1%tag,struct2%tag,0,data_in,data_out&
      &)) then
      write(0,*) "trouble distributing data"
      return
    end if
    disti=.true.
  end function 
  logical function distc(struct1,struct2,data_in,data_out)
    type(sep3d) :: struct1,struct2
    complex :: data_in(:,:),data_out(:,:)
    distc=.false.
    if (0.ne.sep3d_dist_data(struct1%tag,struct2%tag,0,data_in,data_out&
      &)) then
      write(0,*) "trouble distributing data"
      return
    end if
    distc=.true.
  end function 
!$=head1 NAME
!$
!$sep3d_distribute_data - distribute a datase
!$
!$
!$=head1 SYNOPSIS
!$
!$C<logic= sep3d_distribute_data(struct_in,struct_out,data_in,data_out)>
!$
!$=head1 INPUT PARAMETERS
!$
!$=over 4
!$
!$=item struct_in  -  sep3d
!$
!$      structure
!$
!$=item struct_out  -  sep3d
!$
!$      structure
!$
!$=item data_in  -  void (:,:)
!$
!$      input dataset
!$
!$=item data_out  -  void (:,:)
!$
!$      output dataset
!$
!$=back
!$
!$=head1 DESCRIPTION
!$
!$ Distribute a dataset into sections
!$
!$=head1 SEE ALSO
!$
!$
!$=head1 LIBRARY
!$
!$B<supersetf90>
!$
!$=cut
!$=head1 NAME
!$
!$sep3d_compress_data - comprest a dataset
!$
!$
!$=head1 SYNOPSIS
!$
!$C<logic= sep3d_compress_data(struct_in,struct_out,data_in,data_out)>
!$
!$=head1 INPUT PARAMETERS
!$
!$=over 4
!$
!$=item struct_in  -  sep3d
!$
!$      structure
!$
!$=item struct_out  -  sep3d
!$
!$      structure
!$
!$=item data_in  -  void (:,:)
!$
!$      input dataset
!$
!$=item data_out  -  void (:,:)
!$
!$      output dataset
!$
!$=back
!$
!$=head1 DESCRIPTION
!$
!$ Compress a dataset by summing along the sectioned axis
!$
!$=head1 SEE ALSO
!$
!$
!$=head1 LIBRARY
!$
!$B<supersetf90>
!$
!$=cut
!$=head1 NAME
!$
!$sep3d_broadcast_data - broadcast a dataset
!$
!$
!$=head1 SYNOPSIS
!$
!$C<logic= sep3d_broadcast_data(struct_in,data)>
!$
!$=head1 INPUT PARAMETERS
!$
!$=over 4
!$
!$=item struct_in  -  sep3d
!$
!$      structure
!$
!$=item data_in  -  void (:,:)
!$
!$      input dataset
!$
!$=back
!$
!$=head1 DESCRIPTION
!$
!$ Broadcast a dataset from its various sections
!$
!$=head1 SEE ALSO
!$
!$
!$=head1 LIBRARY
!$
!$B<supersetf90>
!$
!$=cut
!$=head1 NAME
!$
!$sep3d_collect_data - collect a dataset
!$
!$
!$=head1 SYNOPSIS
!$
!$C<logic= sep3d_collect_data(struct_in,struct_out,data_in,data_out)>
!$
!$=head1 INPUT PARAMETERS
!$
!$=over 4
!$
!$=item struct_in  -  sep3d
!$
!$      structure
!$
!$=item struct_out  -  sep3d
!$
!$      structure
!$
!$=item data_in  -  void (:,:)
!$
!$      input dataset
!$
!$=item data_out  -  void (:,:)
!$
!$      output dataset
!$
!$=back
!$
!$=head1 DESCRIPTION
!$
!$ Collect a dataset from its various sections
!$
!$=head1 SEE ALSO
!$
!$
!$=head1 LIBRARY
!$
!$B<supersetf90>
!$
!$=cut
  logical function comc(struct1,struct2,data_in,data_out)
    type(sep3d) :: struct1,struct2
    complex :: data_in(:,:),data_out(:,:)
    comc=.false.
    if (0.ne.sep3d_com_data(struct1%tag,struct2%tag,0,data_in,data_out&
      &)) then
      write(0,*) "trouble compressing data"
      return
    end if
    comc=.true.
  end function 
  logical function comf(struct1,struct2,data_in,data_out)
    type(sep3d) :: struct1,struct2
    real :: data_in(:,:),data_out(:,:)
    comf=.false.
    if (0.ne.sep3d_com_data(struct1%tag,struct2%tag,0,data_in,data_out&
      &)) then
      write(0,*) "trouble compressing data"
      return
    end if
    comf=.true.
  end function 
  logical function broadc(struct1,data)
    type(sep3d) :: struct1,struct2
    complex :: data(:,:)
    broadc=.false.
    if (0.ne.sep3d_broadcast_data(struct1%tag,0,8,size(data),data))&
      & then
      write(0,*) "trouble broadcasting data"
      return
    end if
    broadc=.true.
  end function 
  logical function broadi(struct1,data)
    type(sep3d) :: struct1,struct2
    integer :: data(:,:)
    broadi=.false.
    if (0.ne.sep3d_broadcast_data(struct1%tag,0,4,size(data),data))&
      & then
      write(0,*) "trouble broadcasting data"
      return
    end if
    broadi=.true.
  end function 
  logical function broadf(struct1,data)
    type(sep3d) :: struct1,struct2
    real :: data(:,:)
    broadf=.false.
    if (0.ne.sep3d_broadcast_data(struct1%tag,0,4,size(data),data))&
      & then
      write(0,*) "trouble broadcasting data"
      return
    end if
    broadf=.true.
  end function 
  logical function colf(struct1,struct2,data_in,data_out)
    type(sep3d) :: struct1,struct2
    real :: data_in(:,:),data_out(:,:)
    colf=.false.
    if (0.ne.sep3d_col_data(struct1%tag,struct2%tag,0,data_in,data_out&
      &)) then
      write(0,*) "trouble collecting data"
      return
    end if
    colf=.true.
  end function 
  logical function coli(struct1,struct2,data_in,data_out)
    type(sep3d) :: struct1,struct2
    integer :: data_in(:,:),data_out(:,:)
    coli=.false.
    if (0.ne.sep3d_col_data(struct1%tag,struct2%tag,0,data_in,data_out&
      &)) then
      write(0,*) "trouble collecting data"
      return
    end if
    coli=.true.
  end function 
  logical function colc(struct1,struct2,data_in,data_out)
    type(sep3d) :: struct1,struct2
    complex :: data_in(:,:),data_out(:,:)
    colc=.false.
    if (0.ne.sep3d_col_data(struct1%tag,struct2%tag,0,data_in,data_out&
      &)) then
      write(0,*) "trouble collecting data"
      return
    end if
    colc=.true.
  end function 
  logical function distf(struct1,struct2,data_in,data_out)
    type(sep3d) :: struct1,struct2
    real :: data_in(:,:),data_out(:,:)
    distf=.false.
    if (0.ne.sep3d_dist_data(struct1%tag,struct2%tag,0,data_in,data_out&
      &)) then
      write(0,*) "trouble distributing data"
      return
    end if
    distf=.true.
  end function 
!$=head1 NAME
!$
!$sep3d_distribute_headers - Distribute the headers
!$
!$
!$=head1 SYNOPSIS
!$
!$C<logic= sep3d_distribute_headers(struct_in,struct_out)>
!$
!$=head1 INPUT PARAMETERS
!$
!$=over 4
!$
!$=item struct_in  -  sep3d
!$
!$      structure
!$
!$=item struct_out  -  sep3d
!$
!$      structure
!$
!$=back
!$
!$=head1 DESCRIPTION
!$
!$ Spread the headers of struct_in to the various sections of struct_out
!$
!$=head1 SEE ALSO
!$
!$
!$=head1 LIBRARY
!$
!$B<supersetf90>
!$
!$=cut
!$=head1 NAME
!$
!$sep3d_collect_headers - Distribute the headers
!$
!$
!$=head1 SYNOPSIS
!$
!$C<logic= sep3d_collect_headers(struct_in,struct_out)>
!$
!$=head1 INPUT PARAMETERS
!$
!$=over 4
!$
!$=item struct_in  -  sep3d
!$
!$      structure
!$
!$=item struct_out  -  sep3d
!$
!$      structure
!$
!$=back
!$
!$=head1 DESCRIPTION
!$
!$ Collect the headers from the various sections of struct_in to  struct_out
!$
!$=head1 SEE ALSO
!$
!$
!$=head1 LIBRARY
!$
!$B<supersetf90>
!$
!$=cut
  logical function sep3d_collect_headers(struct1,struct2,nh)
    type(sep3d) :: struct1,struct2
    integer :: nh
    sep3d_collect_headers=.false.
    if (0.ne.sep3d_col_headers(struct1%tag,struct2%tag,0,nh)) then
      write(0,*) "trouble distributing headers"
      return
    end if
    sep3d_collect_headers=.true.
  end function 
  logical function sep3d_distribute_headers(struct1,struct2)
    type(sep3d) :: struct1,struct2
    sep3d_distribute_headers=.false.
    if (0.ne.sep3d_dist_headers(struct1%tag,struct2%tag,0)) then
      write(0,*) "trouble distributing headers"
      return
    end if
    sep3d_distribute_headers=.true.
  end function 
!$=head1 NAME
!$
!$sep3d_update_ntraces - Update the traces of a dataset
!$
!$
!$=head1 SYNOPSIS
!$
!$C<logic= sep3d_update_ntraces(struct)>
!$
!$=head1 INPUT PARAMETERS
!$
!$=over 4
!$
!$=item struct  -  sep3d
!$
!$      structure
!$
!$=back
!$
!$=head1 DESCRIPTION
!$
!$ All write statements count the number of traces written out. This routine will
!$ transfer that count to the ntraces of the dataset
!$
!$
!$=head1 SEE ALSO
!$
!$
!$=head1 LIBRARY
!$
!$B<supersetf90>
!$
!$=cut
  logical function sep3d_update_ntraces(struct)
    type(sep3d) :: struct
    sep3d_update_ntraces=.false.
    if (0.ne.sep3d_count_ntraces(struct%tag)) then
      write(0,*) "trouble grabbing coord vals"
      return
    end if
    sep3d_update_ntraces=.true.
  end function 
!$=head1 NAME
!$
!$sep3d_set_coords - Specify the coordinates of a dataset in memory
!$
!$
!$=head1 SYNOPSIS
!$
!$C<logic= sep3d_set_coords(struct,coords)>
!$
!$=head1 INPUT PARAMETERS
!$
!$=over 4
!$
!$=item struct  -  sep3d
!$
!$      structure
!$
!$=item coords  -  int(:,:)
!$
!$      coordinates
!$
!$=back
!$
!$=head1 DESCRIPTION
!$
!$Set the coordinates of the dataset in memory
!$
!$=head1 SEE ALSO
!$
!$
!$=head1 LIBRARY
!$
!$B<supersetf90>
!$
!$=cut
  logical function sep3d_set_coords(struct,coords)
    type(sep3d) :: struct
    integer :: coords(:,:)
    sep3d_set_coords=.false.
!call sep3d_set_number_headers(struct,size(coords,2))
    if (0.ne.sep3d_set_coord_vals(struct%tag,coords)) then
      write(0,*) "trouble grabbing coord vals"
      return
    end if
    sep3d_set_coords=.true.
  end function 
  logical function grab_secti(struct,param,val)
    type(sep3d) :: struct
    character(len=*) :: param
    integer :: val(:)
    grab_secti=.true.
    if (0.ne.sep3d_grab_sectparams(struct%tag,4,param,"d",val)) then
      grab_secti=.false.
    end if
  end function 
  logical function grab_sectf(struct,param,val)
    type(sep3d) :: struct
    character(len=*) :: param
    real :: val(:)
    grab_sectf=.true.
    if (0.ne.sep3d_grab_sectparams(struct%tag,4,param,"f",val)) then
      grab_sectf=.false.
    end if
  end function 
!$=head1 NAME
!$
!$sep3d_set_sect_param - Write a parameter to all the local sections
!$
!$
!$=head1 SYNOPSIS
!$
!$C<logic= sep3d_set_sect_param(struct,par,val)>
!$
!$=head1 INPUT PARAMETERS
!$
!$=over 4
!$
!$=item struct  -  sep3d
!$
!$      structure
!$
!$=item par  -  char*
!$
!$      parameter name
!$
!$=item value  -  void*
!$
!$      parameter value
!$
!$=back
!$
!$=head1 DESCRIPTION
!$
!$ Write a parameter to all local sections
!$
!$=head1 SEE ALSO
!$
!$
!$=head1 LIBRARY
!$
!$B<supersetf90>
!$
!$=cut
  logical function set_sectf(struct,param,val)
    type(sep3d) :: struct
    character(len=*) :: param
    real :: val
    set_sectf=.true.
    if (0.ne.sep3d_set_sectparams(struct%tag,4,param,"f",val)) then
      set_sectf=.false.
    end if
  end function 
!$=head1 NAME
!$
!$sep3d_grab_sect_param - Grab a parameter from all the local sections
!$
!$
!$=head1 SYNOPSIS
!$
!$C<logic= sep3d_grab_sect_param(struct,par,val)>
!$
!$=head1 INPUT PARAMETERS
!$
!$=over 4
!$
!$=item struct  -  sep3d
!$
!$      structure
!$
!$=item par  -  char*
!$
!$      parameter name
!$
!$=item value  -  void*
!$
!$      parameter value
!$
!$=back
!$
!$=head1 DESCRIPTION
!$
!$ Read a parameter to all local sections. value should be an array of size (nsect)
!$
!$=head1 SEE ALSO
!$
!$
!$=head1 LIBRARY
!$
!$B<supersetf90>
!$
!$=cut
  logical function set_secti(struct,param,val)
    type(sep3d) :: struct
    character(len=*) :: param
    integer :: val
    set_secti=.true.
    if (0.ne.sep3d_set_sectparams(struct%tag,4,param,"d",val)) then
      set_secti=.false.
    end if
  end function 
!$=head1 NAME
!$
!$sep3d_own - check whether I own a given index of shared axis
!$
!$
!$=head1 SYNOPSIS
!$
!$C<logic= sep3d_own(struct,index)>
!$
!$=head1 INPUT PARAMETERS
!$
!$=over 4
!$
!$=item struct  -  sep3d
!$
!$      structure
!$
!$=item index  -  int
!$
!$      index along spread axis
!$
!$=back
!$
!$=head1 DESCRIPTION
!$
!$Check whether the given process owns a given index
!$
!$=head1 SEE ALSO
!$
!$
!$=head1 LIBRARY
!$
!$B<supersetf90>
!$
!$=cut
  logical function sep3d_own(struct,i)
    type(sep3d) :: struct
    integer :: ierr,i
    ierr=0
    ierr=sep3d_iown(struct%tag,i)
    if (ierr<0) then
      call seperr("invalid parametes sep3d_own")
    end if
    if (ierr.eq.0) then
      sep3d_own=.true.
    else
      sep3d_own=.false.
    end if
  end function 
!$=head1 NAME
!$
!$sep3d_section - check the section of a given index of shared axis
!$
!$
!$=head1 SYNOPSIS
!$
!$C<logic= sep3d_section(struct,index)>
!$
!$=head1 INPUT PARAMETERS
!$
!$=over 4
!$
!$=item struct  -  sep3d
!$
!$      structure
!$
!$=item index  -  int
!$
!$      index along spread axis
!$
!$=back
!$
!$=head1 DESCRIPTION
!$
!$Check the section of a given index
!$
!$=head1 SEE ALSO
!$
!$
!$=head1 LIBRARY
!$
!$B<supersetf90>
!$
!$=cut
  integer function sep3d_section(struct,i)
    type(sep3d) :: struct
    integer :: ierr,i,sect
    ierr=0
    ierr=sep3d_isect(struct%tag,i,sect)
    if (ierr<0) then
      call seperr("invalid parametes sep3d_own")
    end if
    sep3d_section=ierr
  end function 
  subroutine sep3d_grab_sect_axis(struct,i)
    type(sep3d) :: struct
    integer :: ierr,i,sect
    ierr=0
    ierr=sep3d_grab_sectaxis(struct%tag,i)
    if (ierr<0) then
      call seperr("trouble grabbing section axis")
    end if
  end subroutine 
  logical function trans_data_c(struct1,struct2,data1,data2)
    type(sep3d) :: struct1,struct2
    complex :: data1(:,:),data2(:,:)
    trans_data_c=.false.
    if (0.ne.sep3d_trans_data(struct1%tag,struct2%tag,data1,data2))&
      & then
      write(0,*) "trouble transefering data"
      return
    end if
    trans_data_c=.true.
  end function 
  logical function trans_data_i(struct1,struct2,data1,data2)
    type(sep3d) :: struct1,struct2
    integer :: data1(:,:),data2(:,:)
    trans_data_i=.false.
    if (0.ne.sep3d_trans_data(struct1%tag,struct2%tag,data1,data2))&
      & then
      write(0,*) "trouble transefering data"
      return
    end if
    trans_data_i=.true.
  end function 
!$=head1 NAME
!$
!$sep3d_transfer_data - transfer a dataset
!$
!$
!$=head1 SYNOPSIS
!$
!$C<logic= sep3d_compress_data(struct_in,data_in,struct_out,data_out)>
!$
!$=head1 INPUT PARAMETERS
!$
!$=over 4
!$
!$=item struct_in  -  sep3d
!$
!$      structure
!$
!$=item struct_out  -  sep3d
!$
!$      structure
!$
!$=item data_in  -  void (:,:)
!$
!$      input dataset
!$
!$=item data_out  -  void (:,:)
!$
!$      output dataset
!$
!$=back
!$
!$=head1 DESCRIPTION
!$
!$ Transfer a dataset handles copying a distributed dataset
!$
!$=head1 SEE ALSO
!$
!$
!$=head1 LIBRARY
!$
!$B<supersetf90>
!$
!$=cut
  logical function trans_data_f(struct1,struct2,data1,data2)
    type(sep3d) :: struct1,struct2
    real :: data1(:,:),data2(:,:)
    trans_data_f=.false.
    if (0.ne.sep3d_trans_data(struct1%tag,struct2%tag,data1,data2))&
      & then
      write(0,*) "trouble transefering data"
      return
    end if
    trans_data_f=.true.
  end function 
!$=head1 NAME
!$
!$sep3d_set_window - specify a subsection of data for a tag
!$
!$
!$=head1 SYNOPSIS
!$
!$C<call sep3d_set_window(struct_in,nwind,fwind,jwin)>
!$
!$=head1 INPUT PARAMETERS
!$
!$=over 4
!$
!$=item struct_in  -  sep3d
!$
!$      structure
!$
!$=item nwind  -  int (:)
!$
!$      number of elements in a window (optional)
!$
!$=item fwind  -  int (:)
!$
!$      first  elements in a window (optional)
!$
!$=item jwind  -  int (:)
!$
!$      sampling in a window (optional)
!$
!$
!$=back
!$
!$=head1 DESCRIPTION
!$
!$  Specify a subsection for a dataset
!$
!$=head1 SEE ALSO
!$
!$
!$=head1 LIBRARY
!$
!$B<supersetf90>
!$
!$=cut
  subroutine sep3d_set_window(struct,nwind,fwind,jwind)
    type(sep3d) :: struct
    integer,optional :: nwind(:),fwind(:),jwind(:)
    integer :: ndim,i
    ndim=sep3d_ndims(struct)
    struct%nwind=-1
    struct%fwind=-1
    struct%jwind=-1
    if (present(nwind)) then
      struct%nwind=nwind
    end if
    if (present(fwind)) then
      struct%fwind=fwind
    end if
    if (present(jwind)) then
      struct%jwind=jwind
    end if
    do i=1,ndim 
      if (.not. fix1(struct%n(i),struct%fwind(i),struct%jwind(i)&
        &,struct%nwind(i))) then
        call seperr("illegal windowing parameters")
      end if
    end do 
    if (0.ne. sep3d_set_wind(struct%tag,struct%nwind,struct%fwind&
      &,struct%jwind)) then
      call seperr("trouble setting window parameters")
    end if
  end subroutine 
  subroutine sep3d_add_key(struct,keyname,keytype,keyfmt)
    type(sep3d) :: struct
    character(len=*) :: keyname,keytype,keyfmt
    character(len=128),pointer :: keynold(:),keytold(:),keyfold(:)
    integer ::i
    if (struct%nkeys >0) then
      allocate(keynold(struct%nkeys))
      keynold=struct%keyname
      allocate(keytold(struct%nkeys))
      keytold=struct%keytype
      allocate(keyfold(struct%nkeys))
      keyfold=struct%keyfmt
      struct%nkeys=struct%nkeys+1 
      call key_allocate(struct,struct%nkeys)
      struct%keyname(1:struct%nkeys-1)=keynold
      struct%keytype(1:struct%nkeys-1)=keytold
      struct%keyfmt(1:struct%nkeys-1)=keyfold
      deallocate(keynold,keytold,keyfold)
    else
      struct%nkeys=1
      call key_allocate(struct,1)
    end if 
    struct%keyname(struct%nkeys)=keyname
    struct%keytype(struct%nkeys)=keytype
    struct%keyfmt(struct%nkeys)=keyfmt
  end subroutine 
  logical function sep3d_file_exist(tag,local)
    integer :: ilocal,i
    character(len=*) :: tag
    logical, optional :: local
    sep3d_file_exist=.false.
    ilocal=0
    if (present(local)) then
      if (local) then
        ilocal=1
      end if
    end if
    i=sep3d_fileexist(tag,ilocal)
    if (i.eq.1) then
      sep3d_file_exist=.true.
    end if
  end function 
end module 
