import re
import string
import pwd
import sys
import os
import socket
import time
import SEP.par
import SEP.sepfile
import SEP.datapath
from math import *
class sep_dff:

  def __init__(self,file=None,nsect=None,dtype="BLOCK",axis=None,
   sepfile=None,share="no"):
    self.datapath=SEP.datapath.sep_datapath() 
    self.sects=[]
    self.host=socket.gethostname()
    self.datap=self.datapath.datapath(self.host)
    self.sect_num=0
    if file!=None : self.file_init(file)
    else:
      if axis != None and nsect != None and sepfile != None:
        if share == "yes": 
          self.extend_it(nsect,axis,sepfile)
        self.create_init(nsect,dtype,axis,sepfile)
      else:
        print "must provide axis,nsect,sepfile",axis,nsect
        sys.exit(-1)

  def extend_it(self,nsect,axis,sepfile):
    ndims=sepfile.ndim()
    if axis <= ndims:
       print "when sharing a dataset you must extend on axis("+str(axis)+")"+ ">ndim("+str(ndims)+")"
       sys.exit(-1)
    for i in range(ndims+1,axis):
      sepfile.set_axis(i,1,0.,1.,"none","none")
    sepfile.set_axis(axis,nsect,0.,1.,"none","none")

  def create_init(self,nsect,dtype,axis,sepfile):
    self.check_logic(axis,nsect,sepfile,dtype)
    self.create_dff(axis,nsect,sepfile,dtype)
    self.create_sects(nsect,sepfile)

  def create_sects(self,nsect,sepfile):
    for i in range(nsect):
      self.append_sect(sepfile)

  def append_sect(self,sepfile):
     axis,err=self.format_par("axis")
     nsect,err=self.format_par("nsect")
     dtype,err=self.format_par("pattern")
     i=len(self.sects)
     name,err=self.format_par("tag_sect"+str(i))
     self.sects.append(SEP.sepfile.sep_file(sepfile=sepfile,name=name))
     val,err=self.dff.par("tag_sect"+str(i))
     if err == 0:
       print "INTERNAL ERROR tag_sect"+i," not setup"
       sys.exit(-1) 
     n,o,d,label,unit=self.sects[i].axis(axis-1)
     n,o,d,label,unit=self.sect_axis(i,n,o,d,label,unit,dtype,nsect)
     self.sects[i].set_axis(axis,n,o,d,label,unit)
     nameb,err=self.sects[i].history.par('myfile')
     nameb=os.path.basename(nameb)
     file=self.datapath.datapath(socket.gethostname())+nameb+"@"
     self.sects[i].history.add_param("in",file)
     self.sects[i].history.add_param("dff","-1")
     try: f = open (file,"w")   #OPEN THE FILE
     except:
       print 'Trouble opening file for writing', file
       sys.exit(-1) 
     f.write(" a")
     f.close()

  def sect_axis(self,isect,n,o,d,label,unit,dtype,nsect):
    if dtype == "BLOCK":
      j=1
      nt=0
      nremain=int(n)
      f=0
      i=0
      for i in range(isect+1):
        nt=ceil(int(nremain)/(int(nsect)-i))
        nremain-=int(nt);
        f=int(nt)+int(f);
      nout=nt;
      f-=nt;
    elif dtype == "SPREAD":
      j=nsect
      f=isect
      nout=floor(n/nsect)
      nremain=n - nout*nsect
      if nremain!=0:
        if isect < nremain: nout+=1;
    else:
      print "Uknown distribution type "+dtype
      sys.exit(-1) 
    oout=float(o)+float(d)*int(f)
    dout=float(d)*int(j)
    return nout,oout,dout,label,unit

  def create_dff(self,axis,nsect,sepfile,dtype):
    nameb,err=sepfile.history.par('myfile')
    name=nameb+"@@@@@@"
    self.nameb,err=sepfile.history.par('myfile')
    self.nameb=os.path.basename(nameb)
    sepfile.history.add_param("dff",name)
    self.dff=SEP.par.sep_pars(name=name)
    self.dff.add_param("pattern",dtype)
    self.dff.add_param("axis",axis,type="int")
    n,o,d,label,unit=sepfile.axis(axis)
    self.dff.add_param("naxis_convert",n,type="int")
    self.dff.add_param("nsect",nsect,type="int")
    for i in range(nsect):
      self.add_dff_sect(i)
    
  def write_file(self):
    var,err=self.format_par('myname')
    if err !=1:
      print "Don't have name for dff file, internal error"
      sys.exit(-1) 
    self.dff.write_pars(var)
    nsect,err=self.format_par("nsect")
    if err !=1:
      print "Don't have number of sections dff file, internal error"
      sys.exit(-1) 
    for sect in self.sects: sect.write_file()
          
      

  def check_logic(self,axis,nsect,sepfile,dtype):
    err=0
    if dtype != "BLOCK" and dtype != "SPREAD":
      print "Only understanding distribution type SPREAD and BLOCK type=",dtype
      err=1
    ndims=sepfile.ndim()
    if axis < 1 or axis > ndims:
      print "axis vaule"+str(axis)+" not in data dimension range 1.."+str(ndims)
      err=1
    n,o,d,label,unit=sepfile.axis(axis)
    if n  < nsect:
       print "more sections "+str(nsect)+" than axis length "+str(n)
       err =1
    if err ==1: sys.exit(-1)


  def add_dff_sect(self,i):
    j=self.sect_num
    self.sect_num=self.sect_num+1
    self.dff.add_param("tag_sect"+str(i),self.datap+self.nameb+"_DFF_"+str(j))
    self.dff.add_param("mach_sect"+str(i),self.host)
      
  def add_section(self,sepfile):
    nsect=len(self.sects)+1
    self.dff.add_param("nsect",nsect,type="int")
    self.add_dff_sect(nsect-1)
    self.append_sect(sepfile)
    axis,err=self.format_par("axis")
    sepfile.set_axis(axis,nsect,0.,1.,"none","none")

  def del_section(self,sepfile,isect):
    a=self.sects.pop(isect)
    nsect,err=self.format_par("nsect")
    for i in range(isect,nsect-1):
      tagn,err=self.format_par("tag_sect"+str(i+1))
      machn,err=self.format_par("mach_sect"+str(i+1))
      self.dff.add_param("tag_sect"+str(i),tagn)
      self.dff.add_param("mach_sect"+str(i),machn)
    self.dff.add_param("nsect",nsect-1)
    axis,err=self.format_par("axis")
    sepfile.set_axis(axis,nsect-1,0.,1.,"none","none")
    
  def file_init(self,file):
    self.dff=SEP.par.sep_pars(file=file)
    val,err=self.format_par("nsect")
    if err ==0:
      print "DFF File "+d+" without nsect"
      sys.exit(-1) 
    for i in range(val):
      pp="tag_sect"+i
      sfile,err=self.format_par(pp)
      if err !=1:
        print "DFF file missing parameter "+pp
        sys.exit(-1) 
      self.sects.append(SEP.par.sep_pars(file=sfile))
  def sect_by_isect(self,isect):
    val,err format_par("nsect")
    if err =0 : return None
    if int(val) >= nsect: return None
    val,err format_par("tag_sect"+isect)
    if err == 0: return None
    else return val

  def sect_by_host(self,host):
    val,err format_par("nsect")
    if err =0 : return None
    list=[]
    ilist=[]
    val,err=format_par("mach_sect"+isect)
    if err ==1:
      if val == host:
        val,err=format_par("tag_sect"+isect)
        list.append(val)
        ilist.append(isect)
    if len(list)==0: return None,None
    return ilist,list
 
    


  def format_par(self,par):
     return self.dff.par(par)
  def sect_par(self,par,isect):
     return self.dff.par(par,isect)
