import re
import string
import pwd
import sys
import os
import socket
import time
import SEP.par
from math import *

class sep_file:

  def __init__(self,file=None,sepfile=None,name=None):
    if file != None: self.file_init(file)
    elif sepfile != None: 
      if name !=  None: self.sep_init(sepfile,name)
      else:
        print "Must provide the name if initializing from another sepfile"
        sys.exit(-1) 
    else:
      print "Must initialize a sep_file with a file or another sep_file"
      sys.exit(-1) 

  def sep_init(self,sepfile,name):
    self.history=SEP.par.sep_pars(seppar=sepfile.history,name=name)
    self.file_format="REGULAR"
    if sepfile.file_format != "REGULAR":
      self.headers=SEP.par.sep_pars(seppar=sepfile.headers,name=name+"@@")
      self.file_format="HEADERS"
    if sepfile.file_format == "GRID":
      self.grid=SEP.par.sep_pars(seppar=sepfile.grid,name=name+"@@@@")
      self.file_format="GRID"

  def file_init(self,file):
    try: f = open (file)   #OPEN THE FILE
    except:
      print 'Trouble opening file', file
      sys.exit(-1) 
    f.close()
    self.history=SEP.par.sep_pars(file=file)
    val, err = self.history.par("hff")
    if err == 1 and val != "-1":
      self.header=SEP.par.sep_pars(file=val)
      val, err = self.history.par("gff")
      if err ==1 and val != "-1":
        self.grid=SEP.par.sep_pars(file=val)
        self.file_format="GRID"
      else:
        self.file_format="HEADERS"
    else:
      self.file_format="REGULAR"

  def history_par(self,par):
     return self.history.par(par)
  def header_par(self,par):
     if self.file_format == "REGULAR": return None,-1
     return self.header.par(par)
  def grid_par(self,par):
     if self.file_format != "GRID": return None,-1
     return self.grid.par(par)
  def axis(self,iax):
     if self.file_format == "GRID" and iax != 1:  
       return self.axis_file(self.grid,iax,"_grid")
     elif self.file_format == "HEADERS" and iax !=1:  
       return self.axis_file(self.headers,iax,"")
     else :  
       return self.axis_file(self.history,iax,"")

  def write_file(self):
     var,err = self.history.par('myfile')
     self.history.write_new_pars(var)
     if self.file_format != "REGULAR": 
       var,err = self.headers['myfile']
       self.headers.write_pars[var]
     if self.file_format == "GRID":
       var,err = self.grid['myfile']
       self.grid.write_pars[var]

  def axis_file(self,part,iax,e):
     n=1
     o=0
     d=1
     unit="none"
     label="none"
     val,err = part.par("n"+str(iax)+e)
     if err == 1 : n= val
     val,err = part.par("o"+str(iax)+e)
     if err == 1 : o= val
     val,err = part.par("d"+str(iax)+e)
     if err == 1 : d= val
     val,err = part.par("label"+str(iax)+e)
     if err == 1 : label= val
     val,err = part.par("unit"+str(iax)+e)
     if err == 1 : unit= val
     return n,o,d,label,unit

  def set_axis(self,iax,n,o,d,label,unit):
     if self.file_format == "GRID":  
       return self.set_axis_file(self.grid,"_grid",iax,n,o,d,label,unit)
     elif self.file_format == "HEADERS":  
       return self.set_axis_file(self.headers,"",iax,n,o,d,label,unit)
     else :  return self.set_axis_file(self.history,"",iax,n,o,d,label,unit)
     

  def set_axis_file(self,file,suf,iax,n,o,d,label,unit):
    file.add_param('n'+str(iax)+suf,n,type="int")
    file.add_param('o'+str(iax)+suf,o)
    file.add_param('d'+str(iax)+suf,d)
    file.add_param('label'+str(iax)+suf,label)
    file.add_param('unit'+str(iax)+suf,unit)



  def ndim(self):
     if self.file_format == "GRID":  
       return self.ndim_file(self.grid,"n","_grid")
     elif self.file_format == "HEADERS":  
       return self.ndim_file(self.headers,"n","")
     else :  return self.ndim_file(self.history,"n","")

  def ndim_file(self,part,b,e):
     iax=1; err=1; not1=0
     while err ==1:
       s=b+str(iax)+e
       val,err = part.par(s)
       if err == 1 and int(val) !=1: not1=iax
       iax=iax+1
     return not1  

