/*$

=head1 

Cabs2 - complex absolute value


=head1 SYNOPSIS

C<val= float cabs2(a)>

=head DESCRIPTION

     Cabs2 returns the squared modulus, re**2 + im**2, of the
     complex number a.

=head1 	RETURN VALUE

=over

=item val -  float  

      squared modulus

=back

=head1 	INPUT PARAMTERS

=over4

=item	a  - complex  complex number to find modulus of

=back

=head1 SEE ALSO

L<cabs>, L<ccabs>

=head1 LIBRARY

B<sepmath>


*/
#include <sepmath.h>
#if NeedFunctionPrototypes
_XFUNCPROTOBEGIN
float cabs2(complex x)
_XFUNCPROTOEND
#else
float cabs2(x)
complex x;
#endif
{
	float i;
	i = x.re*x.re +x.im*x.im;
	return (i);
}
