/*$

=head1 NAME

cexp - complex exponent


=head1 SYNOPSIS

C<val= complex cexp(a)>

=head1 INPUT PARAMETER

=over 4

=item a  - complex  

      number to find the exp of

=back

=head1 RETURN VALUES

=over 4

=item val- complex 

      exp(a)

=back

=head1  DESCRIPTION

     Cexp returns exp(a) for an arbitrary complex a.  An
     equivalent formula is csmul(ciexp(a.im),exp(a.re)).

=head1 SEE ALSO

L<csmult>,L<ciexp>


=head1 LIBRARY

B<sepmath>

=cut



>*/
#include <sepmath.h>
#if NeedFunctionPrototypes
_XFUNCPROTOBEGIN
complex cexp(complex x)
_XFUNCPROTOEND
#else
complex cexp(x)
complex x;
#endif

	{
	complex i;
	double amp;

	amp = exp((double)(x.re));
	i.re = amp * cos((double)(x.im));
	i.im = amp * sin((double)(x.im));
	return (i);
	}
